C     PROGRAM ADMCOL(INPUT,OUTPUT,PLOT,TAPE5=INPUT,TAPE6=OUTPUT)                
C  MAIN PROGRAM FOR METHOD OF ASSUMING DEFLECTED SHAPE                          
C    ASSUMING SINE CURVE FOR ALL DEFLECTIONS                                    
C      IRS=1...EXACT M-P-PHI WITHOUT R.S.                                       
C      IRS=2...EXACT M-P-PHI WITH  R.S.                                         
C      IRS=9...ELASTIC-PERFECTLY PLASTIC M-P-PHI                                
C      IRS=10..AVERAGE FLOW MOMENT METHOD                                       
C    SHELL NORDBEAM, IRS=10                                                     
C    ASSUMING POLYNOMIALS FOR LATERAL LOAD AND BENDING MOMENT, AND SINE         
C    CURVE FOR ADDITIONAL DEFLECTION DUE TO AXIAL FORCE                         
C     IRS=101...EXACT M-P-PHI WITHOUT R.S.                                      
C     IRS=102...EXACT M-P-PHI WITH R.S.                                         
C     IRS=109...MODIFIED PLASTIC HINGE METHOD (N=1), AND AVERAGE FLOW           
C               MOMENT METHOD (N=2)                                             
C   NOTE... + =PIN-ENDS, - =FIXED-ENDS                                          
C                                                                               
C     IRS=3 OR 4...RELATIONS BETWEEN END-MOMENT AND DEFLECTION AT CENTER        
C     IRS=5 OR 6...M-P-E0 CURVE CALCULATED FROM M-P-PHI                         
C                                                                               
C    IRS= OVER 200 ... I SHAPE BEAM-COLUMN                                      
C                                                                               
      COMMON /APLOT/ IPLOT,PY,WYILD,DLYILD                                      
      OPEN(UNIT=6,FILE='ADMRESL')
      
      OPEN(UNIT=5,FILE='ADMDATA')

C   DRAWING THE AXES FOR CALCOMP (PLOTING)                                      
C     CALL PLOTS                                                                
C     CALL PLOT(0.0,0.8,-3)                                                     
      READ(5,*) IPLOT                                                           
      WRITE(6,620) IPLOT                                                        
  620 FORMAT(1H ,2X,'IPLOT=',I2)                                                
      IF(IPLOT.EQ.2) GO TO 5                                                    
      CALL AXIS( 0.0,0.0,15HSHORTENING (IN),-15,7.0,0.0,0.0,0.1,0)              
C     CALL PLOT(0.0,0.8,-3)                                                     
      CALL AXIS(0.0,0.0,15HDEFLECTION (IN),-15,7.0,0.0,0.0,1.0,0)               
      CALL AXIS(0.0,0.0,8HP (KIPS),8,6.0,90.0,0.0,10.0,-1)                      
      GO TO 10                                                                  
    5 CALL AXIS(0.0,0.0,33HDEFLECTION  W/WY   OR  SHORTENING,-33,7.0,           
     1          0.0,0.0,0.5,0)                                                  
      CALL AXIS(0.0,0.0,4HP/PY,4,5.0,90.0,0.0,0.2,-1)                           
C                                                                               
   10 READ(5,*) IRS                                                     
      WRITE(6,400) IRS                                                          
      IF(IRS.EQ.1.OR.IRS.EQ.2.OR.IRS.EQ.9)  CALL YDELT(IRS)                     
      IF(IRS.EQ.-1.OR.IRS.EQ.-2.OR.IRS.EQ.-9) CALL YDELT(IRS)                   
      IF(IRS.EQ.10.OR.IRS.EQ.-10)  CALL YDELT(IRS)                              
      IF(IRS.EQ.11.OR.IRS.EQ.-11) CALL YDSHEL(IRS)                              
      IF(IRS.EQ.3.OR.IRS.EQ.4)  CALL MVSWM(IRS)                                 
      IF(IRS.EQ.5.OR.IRS.EQ.6)  CALL MPE0(IRS)                                  
      IF(IRS.GT.100) CALL YDELT2(IRS)                                           
      IF(IRS.LT.-100) CALL YDELT2(IRS)                                          
      GO TO 10                                                                  
C 999 CALL PLOT(0.0,0.0,999)                                                    
      STOP                                                                      
  400 FORMAT(1H ,2X,'IRS=',I4,/)                                                
      END                                                                       
      SUBROUTINE ABCF(A,B,C,F,EM1,EM2,PHI1,PHI2,EMPC)                           
C    COEFFICIENTS OF CIRCULAR TUBE SECTION FOR M-P-PHI                          
      A=EM1/PHI1                                                                
      B=(EM2*SQRT(PHI2)-EM1*SQRT(PHI1))/(SQRT(PHI2)-SQRT(PHI1))                 
      C=(EM2-EM1)/(1.0/SQRT(PHI1)-1.0/SQRT(PHI2))                               
      F=(EMPC-EM2)*PHI2*PHI2                                                    
      RETURN                                                                    
      END                                                                       
      SUBROUTINE ABCFRT(A,B,C,F,PS)                                             
C    COEFFICIENTS OF RECTANGULAR SECTION FOR M-P-PHI                            
      A=1.0                                                                     
      B=3.0*(1.0-PS)                                                            
      C=2.0*(1.0-PS)**1.5                                                       
      F=0.5                                                                     
      RETURN

      END                                                                      
      
      SUBROUTINE CUBIC(A,XR,XI)                                                 
C   THIS SUBROUTINE IS USED IN 'ROTCUB'                                         
      DIMENSION A(4),XR(3),AQ(3)                                                
      INTEGER PATH                                                              
      PATH=2                                                                    
      EX=1.0/3.0                                                                
      IF(A(4).NE.0.0) GO TO 300                                                 
      XR(1)=0.0                                                                 
      GO TO 10                                                                  
  300 A2=A(1)**2                                                                
      Q=(27.0*A2*A(4)-9.0*A(1)*A(2)*A(3)+2.0*A(2)**3)/(54.0*A2*A(1))            
      IF(Q) 400,500,600                                                         
  500 Z=0.0                                                                     
      GO TO 20                                                                  
  400 Q=-Q                                                                      
      PATH=1                                                                    
  600 P=(3.0*A(1)*A(3)-A(2)**2)/(9.0*A2)                                        
      ARG=P**3+Q**2                                                             
      IF(ARG) 700,800,900                                                       
  700 Z=-2.0*SQRT(-P)*COS(ATAN(SQRT(-ARG)/Q)/3.0)                               
      GO TO 30                                                                  
  800 Z=-2.0*Q**EX                                                              
      GO TO 30                                                                  
  900 SARG=SQRT(ARG)                                                            
      IF(P) 1000,1100,1200                                                      
 1000 Z=-(Q+SARG)**EX-(Q-SARG)**EX                                              
      GO TO 30                                                                  
 1100 Z=-(2.0*Q)**EX                                                            
      GO TO 30                                                                  
 1200 Z=(SARG-Q)**EX-(SARG+Q)**EX                                               
   30 GO TO (1300,20),PATH                                                      
 1300 Z=-Z                                                                      
   20 XR(1)=(3.0*A(1)*Z-A(2))/(3.0*A(1))                                        
   10 AQ(1)=A(1)                                                                
      AQ(2)=A(2)+XR(1)*A(1)                                                     
      AQ(3)=A(3)+XR(1)*AQ(2)                                                    
      CALL QUAD(AQ,XR(2),XR(3),XI)                                              
      RETURN                                                                    
      END                                                                       
      SUBROUTINE E0STRN(E,SYILD,DIA,T,P,PHIX,PHIY,E01,J)                        
C     END                                                                       
C  CALCULATION OF AXIAL STRAIN, E0, KNOWING P, PHIX AND PHIY                    
      RC=(DIA-T)/2.0                                                            
      N=0                                                                       
      EY=SYILD/E                                                                
      PAI=4.0*ATAN(1.0)                                                         
      E0=P/(2.0*PAI*E*T*RC)                                                     
      ERR=0.005                                                                 
      PHI0=SQRT(PHIX*PHIX+PHIY*PHIY)                                            
      TPHI=RC*TAN(PHI0)                                                         
      EULT1=TPHI-E0                                                             
      EULT2=TPHI+E0                                                             
      IF(EULT1.GT.EY.AND.EULT2.GT.EY) GO TO 300                                 
      IF(EULT1.GT.EY. OR.EULT2.GT.EY) GO TO 200                                 
      E01=E0                                                                    
      GO TO 100                                                                 
  200 N=N+1                                                                     
      IF(N.GT.30) GO TO 190                                                     
      ETA1=(EY+E0)/TPHI                                                         
      IF(ABS(ETA1).GT.1.0) GO TO 191                                            
      THETY=ASIN(ETA1)                                                          
      E01=(P/(E*T*RC)+EY*(PAI-2.0*THETY)-2.0*TPHI*COS(THETY))/(PAI+             
     1     2.0*THETY)                                                           
      EULT1=TPHI-E01                                                            
      EULT2=TPHI+E01                                                            
      IF(EULT1.GT.EY.AND.EULT2.GT.EY) GO TO 300                                 
      IF(ABS(E01-E0).LT.ERR) GO TO 100                                          
      E0=E01                                                                    
      GO TO 200                                                                 
  300 N=N+1                                                                     
      IF(N.GT.30) GO TO 190                                                     
      ETA1=(EY+E0)/TPHI                                                         
      ETA2=(EY-E0)/TPHI                                                         
      IF(ABS(ETA1).GT.1.0) GO TO 191                                            
      IF(ABS(ETA2).GT.1.0) GO TO 200                                            
      THETY1=ASIN(ETA1)                                                         
      THETY2=ASIN(ETA2)                                                         
      E01=(P/(2.0*E*T*RC)-TPHI*(COS(THETY1)-COS(THETY2))-EY*(THETY1-            
     1     THETY2))/(THETY1+THETY2)                                             
      IF(ABS(E01-E0).LT.ERR) GO TO 100                                          
      E0=E01                                                                    
      GO TO 300                                                                 
  190 WRITE(6,519)  J,(E01-E0)                                                  
      GO TO 100                                                                 
  191 WRITE(6,520) J                                                            
  100 RETURN                                                                    
  519 FORMAT(1H ,   ' ***  TOO MANY ITERATIONS IN CACULATING E0',               
     1      '  J=',I3,'  ERROR=',E12.4)                                         
  520 FORMAT(1H ,   ' ***  ETA1.GT. 1  IN E0-STRAIN  J=',I3)                    
      END                                                                       
      SUBROUTINE MOMPHI(IRS,PS,EM1,EM2,PHI1,PHI2,EMPC)                          
C    CALCULATION OF M1,PHI1,M2,PHI2,MPC WHICH ARE THE BOUNDARY VALUES           
C    FOR M-P-PHI EQUATIONS                                                      
C    * CIRCULAR TUBE SECTION                                                    
      IF(IRS.NE.1.AND.IRS.NE.-1.AND.IRS.NE.101.AND.IRS.NE.-101)GO TO 200        
C   WITHOUT RESIDUAL STRESSES                                                   
      EM1=1.0-PS                                                                
      PHI1=EM1                                                                  
      IF(PS.GT.0.4) GO TO 50                                                    
      EM2=1.0+0.21*PS-1.05*PS*PS                                                
      PHI2=1.0/(1.0-1.395*PS+1.206*PS*PS)                                       
      GO TO 220                                                                 
   50 EM2=1.528*(1.0-PS)                                                        
      PHI2=2.625*(1.0-PS)                                                       
      GO TO 220                                                                 
C   WITH RESIDUAL STRESSES                                                      
  200 IF(PS.GT.0.6) GO TO 210                                                   
      EM1=0.893-1.305*PS+0.796*PS*PS                                            
      PHI1=EM1                                                                  
      EM2=0.893+0.546*PS-1.946*PS*PS                                            
      PHI2=1.0/(1.12-2.491*PS+4.308*PS*PS)                                      
      GO TO 220                                                                 
  210 EM1=1.50-2.333*PS+0.833*PS*PS                                             
      PHI1=EM1                                                                  
      EM2=1.375-1.5*PS+0.125*PS*PS                                              
      PHI2=1.0+0.875*PS-1.875*PS*PS                                             
  220 IF(PS.GT.0.65) GO TO 230                                                  
      EMPC=1.273*(1.0-1.18*PS*PS)                                               
      GO TO 240                                                                 
  230 EMPC=1.82*(1.0-PS)                                                        
  240 RETURN                                                                    
      END                                                                       
      SUBROUTINE MPE0(IRS)                                                      
C  M-P-E0 RELATIONS CALCULATED FROM M-P-PHI CURVES                              
C    JULY, 1979                                                                 
C   IS=5 M-P-PHI WITHOUT RESIDUAL STRESSES                                      
C   IS=6 M-P-PHI WITH RESIDUAL STRESSES                                         
C   E.....YOUNG'S MODULAS                                                       
C   SYILD..YIELD STRESS                                                         
C   DIA...DIAMETER OF PIPE                                                      
C   T.....THICKNESS OF PIPE                                                     
C   EMS...STARTING VALUE OF MOMENT                                              
C   PSS...STARTING VALUE OF AXIAL FORCE                                         
C   DEM,DPS..INCREMENTAL VALUES OF MOMENT AND FORCE                             
C   NM,NPS...NUMBER OF INCREMENT FOR CALCULATION                                
C   EMP...MOMENT NORMALIZED BY MP                                               
C   EM....MOMENT NORMALIZED BY MY                                               
      DIMENSION PS(50),E0(50)                                                   
      READ(5,*)    E,SYILD,DIA,T                                                
      WRITE(6,405) E,SYILD,DIA,T                                                
      READ(5,*) EMS,DEM,NM                                                      
      WRITE(6,410) EMS,DEM,NM                                                   
      READ(5,*) PSS,DPS,NPS                                                     
      WRITE(6,420) PSS,DPS,NPS                                                  
      WRITE(6,500)                                                              
      EMI=0.0                                                                   
      PAI=4.0*ATAN(1.0)                                                         
C                                                                               
      DO 100 I=1,NM                                                             
      EMP=EMS+DEM*FLOAT(I-1)                                                    
      EM=EMP*4.0/PAI                                                            
      WRITE(6,510) EMP                                                          
C                                                                               
      DO 110 J=1,NPS                                                            
      PS(J)=PSS+DPS*FLOAT(J-1)                                                  
C                                                                               
C  COMPUTATION OF PHI KNOWING P AND M                                           
      IS=IRS-4                                                                  
      CALL MOMPHI(IS,PS(J),EM1,EM2,PHI1,PHI2,EMPC)                              
      CALL ABCF(A,B,C,F,EM1,EM2,PHI1,PHI2,EMPC)                                 
      IF(EM.LE.(EM1-EMI)) PHI=(EM-EMI)/A                                        
      IF(EM.GT.(EM1-EMI).AND.EM.LE.(EM2-EMI)) PHI=(C/(B-EM+EMI))**2             
      R=F/(EMPC-EM+EMI)                                                         
      IF(R.LT.0.0) GO TO 110                                                    
      IF(EM.GT.(EM2-EMI)) PHI=SQRT(R)                                           
C                                                                               
C  COMPUTATION OF E0 KNOWING PHI AND P AND M-P-PHI CURVE EQUATIONS              
      PHIX=0.0                                                                  
      PHIY=PHI*2.0*SYILD/E/DIA                                                  
      PY=PAI*(DIA*DIA-(DIA-2.0*T)**2)/4.0*SYILD                                 
      P=-PS(J)*PY                                                               
      CALL E0STRN(E,SYILD,DIA,T,P,PHIX,PHIY,E0(J),J)                            
      E0(J)=E0(J)*E/SYILD                                                       
  110 CONTINUE                                                                  
C                                                                               
  100 WRITE(6,520) (PS(J),E0(J),J=1,NPS)                                        
C                                                                               
  405 FORMAT(2H ,/,5X,'E=',E12.4,'  SYILD=',E12.4,'  DIA=',E12.4,'  T=',        
     1         E12.4)                                                           
  410 FORMAT(1H ,/,5X,'EMS=',E12.4,'  DEM=',E12.4,'  NM=',I3)                   
  420 FORMAT(1H ,/,5X,'PSS=',E12.4,'  DPS=',E12.4,'  NPS=',I3)                  
  500 FORMAT(1H ,/////,2X,'P-M-E0')                                                
  510 FORMAT(1H ,/,2X,'EM=',E12.4,/,2X,'PS(J)=, E0(J)=')                        
  520 FORMAT(1H ,5X,10E12.4)                                                    
      END                                                                       
      SUBROUTINE MPHIRT(PS,PHI1,PHI2,EMPC)                                      
C   PARAMETERS FOR RECTANGULAR SECTION                                          
      PHI1=1.0-PS                                                               
      PHI2=1.0/(1.0-PS)                                                         
      EMPC=1.5*(1.0-PS*PS)                                                      
      RETURN                                                                    
      END                                                                       
      SUBROUTINE MVSWM(IRS)                                                     
C   END-MOMENT V.S. WM RELATION                                                 
C              DEFLECTIONS, WM, ARE NORMALIZED BY WY=PHIY*(L/PAI)**2            
C  NORMALIZED WM  IRS=3 (CIRCULAR SECTION) OR  4 (RECTANGULAR SECTION)          
C      EMI= BENDING MOMENT DUE TO INITIAL IMPERFECTION, =WI*P/MY                
C     DEMI= INCREMENT OF EMI                                                    
C     NMI= NUMBER OF INCREMENT                                                  
C     PSS= STARTING VALUE OF PS, PS=P/PY                                        
C     DPS= INCREMENT OF PS                                                      
C     NPS= NUMBER OF INCREMENT DPS                                              
C     DWM= INCREMENT OF WM, WM=W(AT CENTER) /WY, WY=PHIY*(L/PAI)**2             
C     NWM= NUMBER OF INCREMENT WM                                               
C     PES= EULER BUCKLING LOAD/PY                                               
      DIMENSION EM0(10,10,30),EM(10),PS(10),WM(10)                              
C                                                                               
      READ(5,*) EMI,DEMI,NMI                                                    
      WRITE(6,400) EMI,DEMI,NMI                                                 
      READ(5,*) PSS,DPS,NPS                                                     
      WRITE(6,410) PSS,DPS,NPS                                                  
      READ(5,*) DWM,NWM,PES                                                     
      WRITE(6,420) DWM,NWM,PES                                                  
C                                                                               
      DO 100 I=1,NMI                                                            
      EM(I)=EMI+DEMI*FLOAT(I-1)                                                 
      DO 100 J=1,NPS                                                            
      PS(J)=PSS+DPS*FLOAT(J-1)                                                  
      DO 100 K=1,NWM                                                            
      WM(K)=DWM*FLOAT(K)                                                        
      IF(IRS.NE.4)  GO TO 30                                                    
      CALL MPHIRT(PS(J),PHI1,PHI2,EMPC)                                         
      CALL ABCFRT(A,B,C,F,PS(J))                                                
      GO TO 40                                                                  
   30 IS=1                                                                      
      CALL MOMPHI(IS,PS(J),EM1,EM2,PHI1,PHI2,EMPC)                              
      CALL ABCF(A,B,C,F,EM1,EM2,PHI1,PHI2,EMPC)                                 
   40 IF(WM(K).LE.PHI1) EM0(I,J,K)=(A-PS(J)/PES)*WM(K)-EM(I)                    
      IF(WM(K).GT.PHI1.AND.WM(K).LE.PHI2) EM0(I,J,K)=B-C*SQRT(1.0/WM(K))        
     1        -PS(J)/PES*WM(K)-EM(I)                                            
      IF(WM(K).GT.PHI2) EM0(I,J,K)=EMPC-F/WM(K)/WM(K)-PS(J)/PES*WM(K)-          
     1           EM(I)                                                          
  100 CONTINUE                                                                  
C                                                                               
      DO 110 I=1,NMI                                                            
      DO 110 J=1,NPS                                                            
      WRITE(6,500) I,J,EM(I),PS(J)                                              
  110 WRITE(6,510) (WM(K),EM0(I,J,K),K=1,NWM)                                   
      RETURN                                                                    
  400 FORMAT(1H ,/, 2X,'INPUT DATA (NORMALIZED FORM)',//,5X,'EMI=',E12.4        
     1     ,'  DEMI=',E12.4,'  NMI=',I3)                                        
  410 FORMAT(1H ,/,5X,'PSS=',E12.4,'  DPS=',E12.4,'  NPS=',I3)                  
  420 FORMAT(1H ,/,5X,'DWM=',E12.4,'  NWM=',I5,//,5X,'PES=',E12.4,/////)        
  500 FORMAT(1H ,'I=',I2,' J=',I2,'  MI(I)=',E12.4,'  PS(J)=',E12.4,/,          
     1       8X,'WM(K),EM0(I,J,K)=')                                            
  510 FORMAT(1H ,5X,10E12.4)                                                    
      END                                                                       
      SUBROUTINE ORDER(A1,A2,A3)                                                
C    PUT  3  VALIABLES IN SEQUENCE                                              
      IF(A1.LE.A2.AND.A1.LE.A3) X1=A1                                           
      IF(A2.LE.A1.AND.A2.LE.A3) X1=A2                                           
      IF(A3.LE.A1.AND.A3.LE.A2) X1=A3                                           
      IF(A1.GE.A2.AND.A1.GE.A3) X3=A1                                           
      IF(A2.GE.A1.AND.A2.GE.A3) X3=A2                                           
      IF(A3.GE.A1.AND.A3.GE.A2) X3=A3                                           
      X2=0.0                                                                    
      IF(A1.GT.X1.AND.A1.LT.X3) X2=A1                                           
      IF(A2.GT.X1.AND.A2.LT.X3) X2=A2                                           
      IF(A3.GT.X1.AND.A3.LT.X3) X2=A3                                           
      A1=X1                                                                     
      A2=X2                                                                     
      A3=X3                                                                     
      RETURN                                                                    
      END                                                                       
      SUBROUTINE PLOTNG(K,I)                                                    
C  PLOTTING SHORTENING AND DEFLECTION                                           
C     K=1...DRAW SOLID AND DASH LINES                                           
C    2...DRAW DASH-DOTTED AND DOTTED LINES                                      
C      YY(J)=AXIAL FORCE                                                        
C      XW(J)=DEFLECTION                                                         
C      XS(J)=SHORTENING                                                         
      COMMON /BSHORT/ SH                                                        
      COMMON /APLOT/ IPLOT,PY,WYILD,DLYILD                                      
      COMMON /BPLOT/ XW(150),XS(150),YY(150)                                    
      DIMENSION A(75),DSH(2),GAP(2)                                             
C                                                                               
      IF(IPLOT.NE.2) GO TO 10                                                   
      DO 5 J=1,2*I                                                              
      YY(J)=YY(J)/PY                                                            
      XW(J)=XW(J)/WYILD                                                         
    5 XS(J)=XS(J)/DLYILD                                                        
C    REARRANGE YY, XW, XS IN SEQUENCE                                           
   10 DO 20 J=1,I                                                               
      A(J)=YY(2*J)                                                              
   20 YY(J)=YY(2*J-1)                                                           
      DO 25 J=1,I                                                               
   25 YY(I+J)=A(I+1-J)                                                          
      DO 26 J=1,I                                                               
      A(J)=XW(2*J)                                                              
   26 XW(J)=XW(2*J-1)                                                           
      DO 27 J=1,I                                                               
   27 XW(I+J)=A(I+1-J)                                                          
      DO 28 J=1,I                                                               
      A(J)=XS(2*J)                                                              
   28 XS(J)=XS(2*J-1)                                                           
      DO 29 J=1,I                                                               
   29 XS(I+J)=A(I+1-J)                                                          
C                                                                               
C    FIND THE MAXIMUM NUMBER (IW, IS) FOR PLOTING                               
      WMAX=7.0                                                                  
      DLMAX=0.7                                                                 
      SXW=1.0                                                                   
      SXS=0.1                                                                   
      SYY=10.0                                                                  
      IF(IPLOT.NE.2) GO TO 15                                                   
      WMAX=3.5                                                                  
      DLMAX=3.5                                                                 
      SXW=0.5                                                                   
      SXS=0.5                                                                   
      SYY=0.2                                                                   
   15 DO 30 IW=1,150                                                            
   30 IF(XW(IW).GT.WMAX) GO TO 31                                               
   31 DO 32 IS=1,150                                                            
   32 IF(XS(IS).GT.DLMAX) GO TO 33                                              
   33 IW=IW-1                                                                   
      IS=IS-1                                                                   
      IF(2*I.LT.IS) IS=2*I                                                      
      IF(2*I.LT.IW) IW=2*I                                                      
C    SET THE INITIAL AND SCALING VALUES                                         
      XW(IW+1)=0.0                                                              
      XW(IW+2)=SXW                                                              
      XS(IS+1)=0.0                                                              
      XS(IS+2)=SXS                                                              
      YY1=YY(  IW+1)                                                            
      YY2=YY(  IW+2)                                                            
      YY(  IW+1)=0.0                                                            
      YY(IW+2)=SYY                                                              
C                                                                               
      WRITE(6,700) I                                                            
  700 FORMAT(1H ,'  I=',I3)                                                     
C    1)                                                                         
      WRITE(6,701)                                                              
  701 FORMAT(1H ,'  YY(I), XW(I), XS(I)')                                       
      WRITE(6,500) (YY(I1),I1=1,90)                                             
      WRITE(6,500) (XW(I1),I1=1,90)                                             
      WRITE(6,500) (XS(I1),I1=1,90)                                             
C                                                                               
      IF(K.EQ.2) GO TO 40                                                       
      CALL DSHLINE(XW,YY,IW,0.20,0.08,1)                                        
      YY(  IW+1)=YY1                                                            
      YY(  IW+2)=YY2                                                            
      YY(  IS+1)=0.0                                                            
      YY(IS+2)=SYY                                                              
      CALL DSHLINE(XS,YY,IS,0.0,0.0,0)                                          
      GO TO 50                                                                  
   40 CALL DSHLINE(XW,YY,IW,0.08,0.08,1)                                        
      DSH(1)=0.4                                                                
      DSH(2)=0.05                                                               
      GAP(1)=0.08                                                               
      GAP(2)=0.08                                                               
      YY(  IW+1)=YY1                                                            
      YY(  IW+2)=YY2                                                            
      YY(  IS+1)=0.0                                                            
      YY(IS+2)=SYY                                                              
      CALL DSHLINE(XS,YY,IS,DSH,GAP,2)                                          
   50 RETURN                                                                    
  500 FORMAT(1H ,//,9(1X,10E12.4,/))                                             
      END                                                                       
      SUBROUTINE  QUAD(A,XR1,XR2,XI)                                            
C   THIS SUBROUTINE IS USED IN 'ROTCUB'                                         
      DIMENSION A(3)                                                            
      X1=-A(2)/(2.0*A(1))                                                       
      D=X1**2-A(3)/A(1)                                                         
      IF(D.GE.0.0) GO TO 20                                                     
      X2=SQRT(-D)                                                               
      XR1=X1                                                                    
      XR2=X1                                                                    
      XI=X2                                                                     
      GO TO 30                                                                  
   20 X2=SQRT(D)                                                                
      XR1=X1+X2                                                                 
      XR2=X1-X2                                                                 
      XI=0.0                                                                    
   30 RETURN                                                                    
      END                                                                       
      SUBROUTINE ROTCUB(A1,A2,A3,A4,X1,X2,X3)                                   
C  GET 3-ROOTS SOLVING CUBIC EQUATION                                           
      DIMENSION A(4),X(3),XI(3)                                                 
      A(1)=A1                                                                   
      A(2)=A2                                                                   
      A(3)=A3                                                                   
      A(4)=A4                                                                   
      IF(A(1).EQ.0.0) GO TO 5                                                   
      CALL CUBIC(A,X,XI(2))                                                     
      XI(1)=0.0                                                                 
      XI(3)=-XI(2)                                                              
*     WRITE(6,20) A,X,XI                                                        
      X1=X(1)                                                                   
      X2=X(2)                                                                   
      X3=X(3)                                                                   
      GO TO 100                                                                 
    5 PRINT*,'  A(1) EQUALS TO 0.0 IN ROTCUB'                                    
      STOP                                                                      
   20 FORMAT(//,7X,4HA(1),13X,4HA(2),13X,4HA(3),13X,4HA(4),/                    
     1   4(2X,E15.7,1X),//,22X,8H2ND ROOT,9X,8H3RD ROOT,/,                      
     2   7X,9HREAL PART,3(3X,E15.7),/,17H   IMAGINARY PART,3(3X,E15.7))         
  100 RETURN                                                                    
      END                                                                       
      SUBROUTINE SHORTG(AL,WM,P,SA,E,SYILD,EMY,IS,DIA,T,WI,EM0,IN)              
C  CALCULATION OF SHORTENING DUE TO AXIAL FORCE AND GEOMETRICAL CHANGE          
C    NOTE...THIS SUBROUTINE WAS WRITTEN FOR =YDELT=                             
      DIMENSION E0(30)                                                          
      PAI=4.0*ATAN(1.0)                                                         
      EM0S=EM0/EMY                                                              
      PY=SA*SYILD                                                               
      PS=P/PY                                                                   
      PNEG=-PS*PY                                                               
      FIS=ABS(FLOAT(IS))                                                        
      IF(ABS(FIS).GT.2.01.AND.ABS(FIS).LT.100.0) GO TO 40                       
      IF(ABS(FIS).GT.102.01) GO TO 40                                           
C  SHORTENING CONSIDERING INELASTICITY FROM M-P-PHI CURVES                      
C   ... FOR PIN-END ONLY                                                        
      NS=10                                                                     
      DL=0.5*AL/FLOAT(NS)                                                       
C                                                                               
      DO 20 I=1,NS+1                                                            
      XI=DL*FLOAT(I-1)                                                          
      YI=WM*SIN(XI*PAI/AL)                                                      
      IF(IS.LT.0)  YI=WM/2.0*(1.0-COS(2.0*PAI*XI/AL))                           
      EM=P*YI/EMY                                                               
      EMI=P*WI*SIN(XI*PAI/AL)/EMY                                               
      IF(IS.LT.0)  EMI=P*WI/2.0*(1.0-COS(2.0*PAI*XI/AL))/EMY                    
      EM=EM+EMI+EM0S                                                            
C  COMPUTATION OF PHI KNOWING P AND M                                           
      CALL MOMPHI(IS,PS,   EM1,EM2,PHI1,PHI2,EMPC)                              
      CALL ABCF(A,B,C,F,EM1,EM2,PHI1,PHI2,EMPC)                                 
      IF(EM.LE.(EM1-EMI)) PHI=(EM-EMI)/A                                        
      IF(EM.GT.(EM1-EMI).AND.EM.LE.(EM2-EMI)) PHI=(C/(B-EM+EMI))**2             
      R=F/(EMPC-EM+EMI)                                                         
      IF(R.LT.0.0) GO TO 20                                                     
      IF(EM.GT.(EM2-EMI)) PHI=SQRT(R)                                           
C                                                                               
C  COMPUTATION OF E0 KNOWING PHI AND P AND M-P-PHI CURVE EQUATIONS              
      PHIX=0.0                                                                  
      PHIY=PHI*2.0*SYILD/E/DIA                                                  
      CALL E0STRN(E,SYILD,DIA,T,PNEG,PHIX,PHIY,E0(I),I)                         
   20 CONTINUE                                                                  
C                                                                               
      SHORTP=0.5*E0(1)*DL                                                       
      DO 30 I=2,NS                                                              
   30 SHORTP=SHORTP+E0(I)*DL                                                    
      SHORTP=2.0*(SHORTP+E0(NS+1)*0.5*DL)                                       
C                                                                               
C  ELASTIC SHORTENING DUE TO AXIAL FORCE                                        
   40 SHORTE=PNEG/E/SA*AL                                                       
C  GEOMETRICAL SHORTENING OF SIN CURVE                                          
      SHORT=-PAI*PAI*WM*WM/4.0/AL                                               
      SHORT1=SHORTE+SHORT                                                       
      SHORT2=SHORTP+SHORT                                                       
      IF(FIS.LT.2.01) WRITE(6,500) SHORT1,SHORT2                                
      IF(FIS.GT.100.0.AND.FIS.LT.102.01) WRITE(6,500) SHORT1,SHORT2             
      IF(FIS.GT.2.01.AND.FIS.LT.100.0) WRITE(6,500) SHORT1                      
      IF(FIS.GT.102.01) WRITE(6,500) SHORT1                                     
C                                                                               
      IN=99                                                                     
C                                                                               
      RETURN                                                                    
  500 FORMAT(1H ,50X,'SHORTENING(ELASTIC)=',E14.6,'   SHORTENING(ELASTIC        
     1-PLASTIC)=',E14.6)                                                        
      END                                                                       
      SUBROUTINE SHOTG2(AL,WM,W0MQ,WI,P,SA,SI,E,SYILD,EMY,IRS,EMED,QS,          
     1      IN,DIA,T,W0Q,W0M)                                                   
C  CALCULATION OF SHORTENING DUE TO AXIAL FORCE AND GEOMETRICAL CHANGE          
C    THIS SUBROUTINE MATCHES WITH =YDELT2=                                      
      COMMON /BSHORT/ SH                                                        
      DIMENSION E0(30)                                                          
      PAI=4.0*ATAN(1.0)                                                         
      NS=10                                                                     
      PY=SA*SYILD                                                               
      PS=P/PY                                                                   
      PNEG=-PS*PY                                                               
      FIS=ABS(FLOAT(IRS))                                                       
      IF(ABS(FIS).GT.2.01.AND.ABS(FIS).LT.100.0) GO TO 40                       
C                                                                               
      IF(ABS(FIS).GT.102.01) GO TO 40                                           
C  (1) AXIAL STRAIN SHORTENING                                                  
C                                                                               
C  SHORTENING CONSIDERING INELASTICITY FROM M-P-PHI CURVES                      
      DL=0.5*AL/FLOAT(NS)                                                       
C                                                                               
      DO 20 I=1,NS+1                                                            
      XI=DL*FLOAT(I-1)                                                          
      IF(IRS.LT.0) GO TO 10                                                     
C  PIN-END                                                                      
      YII=WI*SIN(XI*PAI/AL)                                                     
      EMI=P*YII/EMY                                                             
      YIW=(WM-W0MQ)*SIN(XI*PAI/AL)                                              
      EMW=P*YIW/EMY                                                             
      Q=QS*4.0*EMY/AL                                                           
      YI0=Q*(3.0*AL*AL*XI-4.0*XI**3)/(48.0*E*SI)                                
      EM0=P*YI0/EMY                                                             
      EM=Q/2.0*XI/EMY+EMI+EMW+EM0+EMED                                          
      GO TO 15                                                                  
C  FIXED-ENDS                                                                   
   10 YII=WI/2.0*(1.0-COS(2.0*PAI*XI/AL))                                       
      EMI=P*YII/EMY                                                             
      YIW=(WM-W0MQ)/2.0*(1.0-COS(2.0*PAI*XI/AL))                                
      EMW=P*YIW/EMY                                                             
      YI0=Q*(3.0*AL*XI*XI-4.0*XI**3)/(48.0*E*SI)                                
      Q=QS*8.0*EMY/AL                                                           
      EM0=P*YI0/EMY                                                             
      EM=Q/2.0*XI/EMY+EMI+EMW+EM0-EMED                                          
C  COMPUTATION OF PHI KNOWING P AND M                                           
   15 CALL MOMPHI(IRS,PS,  EM1,EM2,PHI1,PHI2,EMPC)                              
      CALL ABCF(A,B,C,F,EM1,EM2,PHI1,PHI2,EMPC)                                 
      IF(EM.LE.EM1) PHI=EM/A                                                    
      IF(EM.GT.EM1.AND.EM.LE.EM2) PHI=(C/(B-EM))**2                             
      R=F/(EMPC-EM)                                                             
      IF(R.LT.0.0) GO TO 20                                                     
      IF(EM.GT.EM2) PHI=SQRT(R)                                                 
C                                                                               
C  COMPUTATION OF E0 KNOWING PHI AND P AND M-P-PHI CURVE EQUATIONS              
      PHIX=0.0                                                                  
      PHIY=PHI*2.0*SYILD/E/DIA                                                  
      CALL E0STRN(E,SYILD,DIA,T,PNEG,PHIX,PHIY,E0(I),I)                         
   20 CONTINUE                                                                  
C                                                                               
      SHORTP=0.5*E0(1)*DL                                                       
      DO 30 I=2,NS                                                              
   30 SHORTP=SHORTP+E0(I)*DL                                                    
      SHORTP=2.0*(SHORTP+E0(NS+1)*0.5*DL)                                       
C                                                                               
C  ELASTIC SHORTENING DUE TO AXIAL FORCE                                        
   40 SHORTE=PNEG/E/SA*AL                                                       
C                                                                               
C  (2) GEOMETRICAL SHORTENING                                                   
C                                                                               
C  GEOMERICAL SHORTENING OF SINE CURVE AND POLYNOMIAL FUNCTIONS                 
      SHORT=-PAI*PAI*WM*WM/4.0/AL                                               
      IF(FIS.GT.102.01) GO TO 50                                                
C                                                                               
      WS=WM-W0MQ                                                                
      ALQ=AL+SHORTE                                                             
      ALQQ=ALQ                                                                  
      DO 2 I=1,5                                                                
      ALN=0.0                                                                   
      DL1=0.0                                                                   
      DH=ALQQ/FLOAT(NS)*0.5                                                     
      Y1=0.0                                                                    
      DO 3 K=1,NS                                                               
      XL=FLOAT(K)/FLOAT(2*NS)                                                   
      YQ=3.0*W0Q*(XL-4.0*XL**3/3.0)                                             
      IF(IRS.LT.0) YQ=12.0*W0Q*(XL*XL-4.0*XL**3/3.0)                            
      YM=4.0*W0M*(XL-XL*XL)                                                     
      YS=WS*SIN(PAI*XL)                                                         
      IF(IRS.LT.0) YS=WS/2.0*(1.0-COS(2.0*PAI*XL))                              
      YI=WI*SIN(PAI*XL)                                                         
      IF(IRS.LT.0) YI=WI/2.0*(1.0-COS(2.0*PAI*XL))                              
      Y2=YQ+YM+YS+YI                                                            
      YD=Y2-Y1                                                                  
      SD=SQRT(YD*YD+DH*DH)                                                      
      Y1=Y2                                                                     
    3 ALN=ALN+SD                                                                
      ALN=2.0*ALN                                                               
      DL2=ALN-ALQQ                                                              
      DDL=DL1-DL2                                                               
      IF(ABS(DDL).LT.1.0E-3)  GO TO 5                                           
      IF(ABS(ALQ-ALN).LT.1.0E-4) GO TO 5                                        
      DL1=DL2                                                                   
    2 ALQQ=ALQ-DL2                                                              
    5 SHORT=-DL2+PAI*PAI*WI*WI/4.0/AL                                           
      IF(I.GE.5) WRITE(6,510)                                                   
C                                                                               
   50 SHORT1=SHORTE+SHORT                                                       
      SHORT2=SHORTP+SHORT                                                       
*     IF(FIS.LT.2.01) WRITE(6,500) SHORT1,SHORT2                                
*     IF(FIS.GT.100.0.AND.FIS.LT.102.01) WRITE(6,500) SHORT1,SHORT2             
*     IF(FIS.GT.2.01.AND.FIS.LT.100.0) WRITE(6,500) SHORT1                      
*     IF(FIS.GT.102.01) WRITE(6,500) SHORT1                                     
C                                                                               
      IN=99                                                                     
      SH=-SHORT2                                                                
      IF(FIS.GT.2.01.AND.FIS.LT.100.) SH=-SHORT1                                
      IF(FIS.GT.102.01) SH=-SHORT1                                              
C                                                                               
      RETURN                                                                    
  500 FORMAT(1H ,50X,'SHORTENING(ELASTIC)=',E14.6,'   SHORTENING(ELASTIC        
     1-PLASTIC)=',E14.6)                                                        
  510 FORMAT(1H ,50X,'ITERATION TIMES=5 IN SHORTENING')                         
      END                                                                       
      SUBROUTINE YDELT(IRS)                                                     
C  CALCULATION OF DEFLECTION AND SHORTENING                                     
C  METHOD OF ASSUMING A DEFLECTED SHAPE AS SINE CURVE                           
C   +=PIN-END SUPPORT AND -=FIXED-END SUPPORT                                   
C    IRS=1....WITHOUT RESIDUAL STRESSES FOR M-P-PHI CURVE                       
C    IRS=2....WITH RESIDUAL STRESSES FOR M-P-PHI CURVE                          
C    IRS=9 ...ELASTIC-PERFECTLY PLASTIC ASSUMPTION FOR M-P-PHI CURVE            
C    IRS=10...USING AVERAGE FLOW MOMENT,MMC, INSTEAD OF MPC                     
C     L= LENGTH OF THE COLUMN (FEET)                                            
C     E= YOUNG'S MODULAS                                                        
C     SY= YIELD STRENGTH                                                        
C     D= DIAMETER OF PIPE (INCH)                                                
C     T= THICKNESS OF PIPE (INCH)                                               
C     P= AXIAL LOAD                                                             
C     PDELT= AXIAL LOAD INCREMENT                                               
C     NP= NUMBER OF LOAD P                                                      
C     WI= INITIAL OUT-OF-STRAIGHTNESS                                           
C     EM0= BENDING MOMENT AT ENDS FOR PIN-ENDS, OR LATERAL LOAD AT THE          
C          CENTER FOR FIXED-END SUPPORT                                         
      REAL L                                                                    
      IF(IRS.EQ.1)  WRITE(6,600)                                                
  600 FORMAT(1H ,'    DEFLECTION AND SHORTENING USING EXACT M-P-PHI WITH        
     1OUT RESIDUAL STRESSES, PIN-END')                                                   
      IF(IRS.EQ.-1) WRITE(6,601)                                                
  601 FORMAT(1H ,'    DEFLECTION AND SHORTENING USING EXACT M-P-PHI WITH        
     1OUT RESIDUAL STRESSES, FIXED-END')                                                
      IF(IRS.EQ.2)  WRITE(6,602)                                                
  602 FORMAT(1H ,'    DEFLECTION AND SHORTENING USING EXACT M-P-PHI WITH        I
     1    RESDUAL STRESSES, PIN-END')                                                  
      IF(IRS.EQ.-2) WRITE(6,603)                                                
  603 FORMAT(1H ,'    DEFLECTION AND SHORTENING USING EXACT M-P-PHI WITH        
     1    RESIDUAL STRESSES, FIXED-END')                                                
      IF(IRS.EQ.9)  WRITE(6,604)                                                
  604 FORMAT(1H ,'    DEFLECTION AND SHORTENING USING ELASTIC-PERFECTLY         
     1PLASTIC M-P-PHI(MPC), PIN-END')                                                   
      IF(IRS.EQ.-9) WRITE(6,605)                                                
  605 FORMAT(1H ,'    DEFLECTION AND SHORTENING USING ELASTIC-PERFECTLY         
     1PLASTIC M-P-PHI(MPC), FIXED-END')                                         
      IF(IRS.EQ.10)  WRITE(6,606)                                               
  606 FORMAT(1H ,'    DEFLECTION AND SHORTENING USING AVERAGE FLOW MOMEN        
     1T (MMC),PIN-END')                                                                 
      IF(IRS.EQ.-10) WRITE(6,607)                                               
  607 FORMAT(1H ,'    DEFLECTION AND SHORTENING USING AVERAGE FLOW MOMEN        
     1T (MMC),FIXED-END')                                                               
      WRITE(6,405)                                                              
      READ(5,*) L,E,SY,D,T                                                      
      WRITE(6,400) L,E,SY,D,T                                                   
      L=12.0*L                                                                  
      READ(5,*) P,PDELT,NP,WI,EM0                                               
      WRITE(6,410) P,PDELT,NP,WI,EM0                                            
C                                                                               
      WI=WI*L                                                                   
      PAI=4.0*ATAN(1.0)                                                         
      PAIL=L/PAI                                                                
      SI=PAI/64.0*(D**4-(D-2.0*T)**4)                                           
      SA=PAI/4.0*(D*D-(D-2.0*T)*(D-2.0*T))                                      
      PHIY=ATAN(2.0*SY/D/E)                                                     
      EMY=E*SI*PHIY                                                             
      PES=E*SI/(PAIL*PAIL*SA*SY)                                                
      IF(IRS.LT.0) PES=4.0*PES                                                  
      PY=SA*SY                                                                  
      WRITE(6,420) SI,PHIY,SA,PES,PY,EMY                                        
      IF(IRS.LT.0) EM0=EM0*L/8.0                                                
      EM0S=EM0/EMY                                                              
      P=P-PDELT                                                                 
      IN=99                                                                     
C                                                                               
      DO 100 I=1,NP                                                             
      IF(IN.NE.99) GO TO 100                                                    
      IN=0                                                                      
      P=P+PDELT                                                                 
      PS=P/PY                                                                   
      WRITE(6,500) P,PS                                                         
      IF(PS.GT.1.0) GO TO 199                                                   
      IF(PS/PES.GT.1.0) GO TO 199                                               
      CALL MOMPHI(IRS,PS,EM1,EM2,PHI1,PHI2,EMPC)                                
      CALL ABCF(A,B,C,F,EM1,EM2,PHI1,PHI2,EMPC)                                 
      EMIS=P*WI/EMY                                                             
      IF(IRS.LT.0) EMIS=0.5*EMIS                                                
C  ELASTIC-PERFECTLY PLASTIC M-P-PHI CURVE                                      
      IF(IRS.NE.9.AND.IRS.NE.-9.AND.IRS.NE.10.AND.IRS.NE.-10) GO TO 10          
      IF(IRS.EQ.10)  EMPC=EMPC-P/PY*(EMPC-(1.0-P/PY))                           
      IF(IRS.EQ.-10) EMPC=EMPC-P/PY*(EMPC-(1.0-P/PY))*0.5                       
      WM=(EM0S+EMIS)*PAIL*PAIL*PHIY/(1.0-PS/PES)                                
      IF(IRS.LT.0) WM=0.5*WM                                                    
      EM=EM0S+P*(WM+WI)/EMY                                                     
      IF(IRS.LT.0) EM=EM0S+P*(WM+WI)/EMY*0.5                                    
      WRITE(6,540) WM,EM                                                        
      IF(EM.LT.EMPC) CALL SHORTG(L,WM,P,SA,E,SY,EMY,IRS,D,T,WI,EM0,IN)          
      WMP=PES/PS*(EMPC-EM0S-EMIS)*PAIL*PAIL*PHIY                                
      IF(IRS.LT.0) WMP=0.5*WMP                                                  
      WRITE(6,550) WMP,EMPC                                                     
      IF(EM.LT.EMPC) CALL SHORTG(L,WMP,P,SA,E,SY,EMY,IRS,D,T,WI,EM0,IN)         
      GO TO 100                                                                 
   10 W1=PHI1*PHIY*PAIL*PAIL                                                    
      W2=PHI2*PHIY*PAIL*PAIL                                                    
      IF(IRS.LT.0) W1=0.5*W1                                                    
      IF(IRS.LT.0) W2=0.5*W2                                                    
C  WM1   ELASTIC REGION                                                         
      WM1=(EM0S+EMIS)*PAIL*PAIL*PHIY/(A-PS/PES)                                 
      IF(IRS.LT.0) WM1=0.5*WM1                                                  
      WRITE(6,510) WM1,W1                                                       
      IF(WM1. LT.W1) CALL SHORTG(L,WM1, P,SA,E,SY,EMY,IRS,D,T,WI,EM0,IN)        
C ***                                                                           
C  WM2   ONE-SIDE YIELDED REGION                                                
C *** FIND ROOTS BY SOLVING 3-RD ORDER EQUATION                                 
      A0=PS/(PES*PAIL*PAIL*PHIY)                                                
      A1=0.0                                                                    
      A2=EM0S+EMIS-B                                                            
      A3=PAIL*C*SQRT(PHIY)                                                      
      CALL ROTCUB(A0,A1,A2,A3,X1,X2,X3)                                         
      IF(ABS(X2-X3).GT.1.0E-5) GO TO 40                                         
      X2=0.0                                                                    
      X3=0.0                                                                    
   40 WM21=X1*X1                                                                
      WM22=X2*X2                                                                
      WM23=X3*X3                                                                
      IF(IRS.GT.0) GO TO 45                                                     
      WM21=0.5*WM21                                                             
      WM22=0.5*WM22                                                             
      WM23=0.5*WM23                                                             
   45 WRITE(6,520) WM21,WM22,WM23,W1,W2                                         
      IF(WM21.GT.W1.AND.WM21.LT.W2) CALL SHORTG(L,WM21,P,SA,E,SY,EMY,           
     1          IRS,D,T,WI,EM0,IN)                                              
      IF(WM22.GT.W1.AND.WM22.LT.W2) CALL SHORTG(L,WM22,P,SA,E,SY,EMY,           
     1          IRS,D,T,WI,EM0,IN)                                              
      IF(WM23.GT.W1.AND.WM23.LT.W2) CALL SHORTG(L,WM23,P,SA,E,SY,EMY,           
     1          IRS,D,T,WI,EM0,IN)                                              
C  WM3   BOTH-SIDE YIELDED REGION                                               
      A0=PS/(PES*PAIL**6*PHIY**3)                                               
      A1=(EM0S+EMIS-EMPC)/(PAIL**4*PHIY*PHIY)                                   
      A2=0.0                                                                    
      A3=F                                                                      
      CALL ROTCUB(A0,A1,A2,A3,X1,X2,X3)                                         
      IF(ABS(X2-X3).GT.1.0E-5) GO TO 50                                         
      X2=0.0                                                                    
      X3=0.0                                                                    
   50 WM31=X1                                                                   
      WM32=X2                                                                   
      WM33=X3                                                                   
      IF(IRS.GT.0) GO TO 55                                                     
      WM31=0.5*WM31                                                             
      WM32=0.5*WM32                                                             
      WM33=0.5*WM33                                                             
   55 WRITE(6,530) WM31,WM32,WM33,W2                                            
      IF(WM31.GT.W2) CALL SHORTG(L,WM31,P,SA,E,SY,EMY,IRS,D,T,WI,EM0,IN)        
      IF(WM32.GT.W2) CALL SHORTG(L,WM32,P,SA,E,SY,EMY,IRS,D,T,WI,EM0,IN)        
      IF(WM33.GT.W2) CALL SHORTG(L,WM33,P,SA,E,SY,EMY,IRS,D,T,WI,EM0,IN)        
C ***                                                                           
  100 CONTINUE                                                                  
C                                                                               
  199 RETURN                                                                    
  405 FORMAT(1H ,/,2X,'INPUT DATA')                                             
  400 FORMAT(1H ,/,6X,'L=',E12.4,'  E=',E12.4,'  SY=',E12.4,'  D=',E12.4        
     1      ,'  T=',E12.4)                                                      
  410 FORMAT(1H ,/,6X,'P=',E12.4,'  PDELT=',E12.4,'  NP=',I3,'  WI=',           
     1       E12.4,'  EM0=',E12.4)                                              
  420 FORMAT(1H ,/,6X,'SI=',E12.4,'  PHIY=',E12.4,'  SA=',E12.4,'  PE=',        
     1       E12.4,'  PY=',E12.4,'  MY=',E12.4)                                 
  500 FORMAT(1H ,/////,2X,'P=',E12.4,'  PS=',E12.4)                                
  510 FORMAT(1H ,/,5X,'WM1=',E12.4,'  W1=',E12.4)                               
  520 FORMAT(1H ,/,5X,'WM2=',3E12.4,5X,'  W1=',E12.4,'  W2=',E12.4)             
  530 FORMAT(1H ,/,5X,'WM3=',3E12.4,5X,           '  W2=',E12.4)                
  540 FORMAT(1H ,/,5X,'WM(ELASTIC)=',E12.4,'   EM=',E12.4)                      
  550 FORMAT(1H ,/,5X,'WM(PLASTIC)=',E12.4,'  MPC=',E12.4)                      
      END                                                                       C----------------------------------------------------------------------
C     SUBROUTINE MOMPHW(IRS,PS,EM1,EM2,PHI1,PHI2,EMPC)                          
C  CALCULATION OF M1,M2,PHI1,PHI2, AND MPC                                      
C  WIDE-FLANGE SECTIONS                                                         
C      FIRS=ABS(FLOAT(IRS))                                                     
C     IF(FIRS.NE.200) GO TO 20                                                  
C   WITHPUT RESIDUAL STRESS FOR STRNG AXIS                                      
C     EM1=1.0-PS                                                                
C     PHI1=1.0-PS                                                               
C     IF(PS.GT.0.225) GO TO 10                                                  
C     EMPC=1.11-2.64*PS*PS                                                      
C     EM2=1.0+0.778*PS-4.78*PS*PS                                               
C     PHI2=1.0/(1.0-3.7*PS+8.4*PS*PS)                                           
C     GO TO 100                                                                 
C  10 EMPC=1.238-1.143*PS-0.095*PS*PS                                           
C     EM2=1.20*(1.0-PS)                                                         
C     PHI2=2.20*(1.0-PS)                                                        
C     GO TO 100                                                                 
C   WITH RESIDUAL STRESS FOR STRNG AXIS                                         
C  20 IF(FIRS.NE.202) GO TO 30                                                  
C     EM1=0.9-PS                                                                
C     PHI1=0.9-PS                                                               
C     IF(PS.LT.0.8) GO TO 21                                                    
C     EM1=-1.1+3.1*PS-2.0*PS*PS                                                 
C     PHI1=3.3-8.0*PS+5.0*PS*PS                                                 
C  21 IF(PS.GT.0.225) GO TO 22                                                  
C     EMPC=1.11-2.64*PS*PS                                                      
C     EM2=0.9+1.94*PS-9.4*PS*PS                                                 
C     PHI2=1.0/(1.11-7.35*PS+29.2*PS*PS)                                        
C     GO TO 100                                                                 
C  22 EMPC=1.238-1.143*PS-0.095*PS*PS                                           
C     EM2=1.1*(1.0-PS)                                                          
C     PHI2=1.3-PS                                                               
C   WEAK AXIS BENDING WITH NO RESIDUAL STRESS                                   
C  30 IF(FIRS.NE.205) GO TO 40                                                  
C     EM1=1.0-PS                                                                
C     PHI1=1.0-PS                                                               
C     IF(PS.GT.0.4) GO TO 31                                                    
C     EM2=1.0+1.5*PS-2.5*PS*PS                                                  
C     PHI2=1.0/(1.0-1.57*PS+0.725*PS*PS)                                        
C     GO TO 35                                                                  
C  31 EM2=0.85+2.03*PS-2.88*PS*PS                                               
C     PHI2=1.0/(0.368+0.645*PS-0.862*PS*PS)                                     
C  35 EMPC=1.51*(1.0-0.185*PS*PS)                                               
C     IF(PS.GT.0.252) EMPC=2.58*(0.52+PS)*(1.0-PS)                              
C     GO TO 100                                                                 
C   WEAK AXIS BENDING WITH RESIDUAL STRESS                                      
C  40 IF(FIRS.NE.206) GO TO 100                                                 
C     IF(PS.GT.0.4) GO TO 41                                                    
C     EM1=0.9-PS                                                                
C     PHI1=0.9-PS                                                               
C     EM2=0.9+PS-2.5*PS*PS                                                      
C     PHI2=1.0/(1.11-2.11*PS+2.81*PS*PS)                                        
C     GO TO 45                                                                  
C  41 EM1=0.567+0.1*PS-0.667*PS*PS                                              
C     PHI1=0.5                                                                  
C     EM2=1.0+0.25*PS-1.25*PS*PS                                                
C     PHI2=1.0/(1.3-2.45*PS+2.45*PS*PS)                                         
C  45 EMPC=1.51-0.28*PS*PS                                                      
C     IF(PS.GT.0.252) EMPC=2.58*(0.52+PS)*(1.0-PS)                              
C                                                                               
C 100 RETURN                                                                    
C     END                                                                       
C --------------------------------------------------------------------------  

      SUBROUTINE YDELT2(IRS)                                                    
C  CALCULATION OF DEFLECTION AND SHORTENING                                     
C    METHOD OF ASSUMING A DEFLECTED SHAPE AS SINE CURVE FOR AMPLIFIED           
C      DEFLECTION BY AXIAL FORCE  AND POLYNOMIALS FOR LATERAL LOAD + B.M        
C   +=PIN-END SUPPORT AND -=FIXED-END SUPPORT                                   
C    IRS=101..WITHOUT RESIDUAL STRESSES FOR M-P-PHI CURVE                       
C    IRS=102..WITH RESIDUAL STRESSES FOR M-P-PHI CURVE                          
C    IRS=109..ELASTIC-PERFECTLY PLASTIC ASSUMPTION FOR M-P-PHI CURVE            
C    IRS=110..USING AVERAGE FLOW MOMENT,MMC, INSTEAD OF MPC                     
C     L= LENGTH OF THE COLUMN (FEET)                                            
C     E= YOUNG'S MODULAS                                                        
C     SY= YIELD STRENGTH                                                        
C     D= DIAMETER OF PIPE (INCH)                                                
C     T= THICKNESS OF PIPE (INCH)                                               
C     P= AXIAL LOAD                                                             
C     PDELT= AXIAL LOAD INCREMENT                                               
C     NP= NUMBER OF LOAD P                                                      
C     WI= INITIAL OUT-OF-STRAIGHTNESS                                           
C     EM0= BENDING MOMENT AT ENDS FOR PIN-ENDS, OR LATERAL LOAD AT THE          
C          CENTER FOR FIXED-END SUPPORT                                         
      COMMON /BSHORT/ SH                                                        
      COMMON /APLOT/ IPLOT,PY,WYILD,DLYILD                                      
      COMMON /BPLOT/ XW(150),XS(150),YY(150)                                    
      REAL L                                                                    
C     PAI=4.0*ATAN(1.0)                                                         
      IF(IRS.EQ.101) WRITE(6,610)                                               
  610 FORMAT(1H ,'   DEFLECTION AND SHORTENING USING EXACT M-P-PHI WITHO        
     1UT RESIDUAL STRESSES, PIN-END')                                                   
      IF(IRS.EQ.-101) WRITE(6,611)                                              
  611 FORMAT(1H ,'  DEFLECTION AND SHORTENING USING EXACT M-P-PHI WITHOU        
     1T RESIDUAL STRESSES, FIXED-END')                                                  
      IF(IRS.EQ.102) WRITE(6,612)                                               
  612 FORMAT(1H ,'    DEFLECTION AND SHORTENING USING EXACT M-P-PHI WITH        
     1    RESIDUAL STRESSES, PIN-END')                                                  
      IF(IRS.EQ.-102) WRITE(6,613)                                              
  613 FORMAT(1H ,'   DEFLECTION AND SHORTENING USING EXACT M-P-PHI WITH         
     1   RESIDUAL STRESSES, FIXED-END')                                                 
      IF(IRS.EQ.109) WRITE(6,614)                                               
  614 FORMAT(1H ,'    DEFLECTION AND SHORTENING USING ELASTIC-PERFECTLY         
     1PLASTIC M-P-PHI(MPC), PIN-END')                                                   
      IF(IRS.EQ.-109) WRITE(6,615)                                              
  615 FORMAT(1H ,'   DEFLECTION AND SHORTENING USING ELASTIC-PERFECTLY P        
     1LASTIC M-P-PHI(MPC), FIXED-END')                                                  
      IF(IRS.EQ.110) WRITE(6,616)                                               
  616 FORMAT(1H ,'    DEFLECTION AND SHORTENING USING AVERAGE FLOW MOMEN        
     1T (MMC), PIN-END')                                                                
      IF(IRS.EQ.-110) WRITE(6,617)                                              
  617 FORMAT(1H ,'    DEFLECTION AND SHORTENING USING AVERAGE FLOW MOMEN        
     1T (MMC),FIXED-END')                                                               
      WRITE(6,405)                                                              C--------------------------------------------------------------------------
C  WIDE-FLANGE BEAM-COLUMN                                                      
C     FIRS=ABS(FLOAT(IRS))                                                      
C     IF(FIRS.LT.200) GO TO 5                                                  C
C     WRITE(6,402) L,E,SY,WI                                                    
C     READ(5,*) L,E,SY,WI,HT,BD,TF,TW                                           
C     WRITE(6,403) HT,BD,TF,TW                                                  
C 402 FORMAT(1H ,/,6X,'L=',E12.4,'  E=',E12.4,'  SY=',E12.4,'  WI=',            
C    1         E12.4)                                                           
C 403 FORMAT(1H ,/,6X,'HT=',E12.4,'  BD=',E12.4,'  TF=',E12.4,                  
C    1          '  TW=',E12.4)                                                  
C     SA=BD*TF*2.0+TW*(HT-2.0*TF)                                               
C     SI=BD*TF**3/6.0+TW*(HT-2.0*TF)**3/12.0+2.0*BD*TF*(0.5*(HT-TF))**2         
C     IF(FIRS.GE.205) SI=TF*BD**3/6.0+(HT-2.0*TF)*TW**3/12.0                    
C     PHIY=ATAN(2.0*SY/HT/E)                                                    
C     GO TO 8                                                                   C--------------------------------------------------------------------
      READ(5,*) L,E,SY,D,T,WI                                                   
      WRITE(6,400) L,E,SY,D,T,WI                                                
C     SI=PAI/64.0*(D**4-(D-2.0*T)**4)                                           
C     SA=PAI/4.0*(D*D-(D-2.0*T)*(D-2.0*T))                                     C
C     PHIY=ATAN(2.0*SY/D/E)                                                     
      L=12.0*L                                                                  
      READ(5,*) PP,PDELT,NP,EM0S,QS                                             
      WRITE(6,410) PP,PDELT,NP,EM0S,QS                                          
C     PAIL=L/PAI                                                                
C                                                                               
      WI=WI*L                                                                   
      PAI=4.0*ATAN(1.0)                                                         
      PAIL=L/PAI                                                                
      SI=PAI/64.0*(D**4-(D-2.0*T)**4)                                           
      SA=PAI/4.0*(D*D-(D-2.0*T)*(D-2.0*T))                                      
      PHIY=ATAN(2.0*SY/D/E)                                                     
      EMY=E*SI*PHIY                                                             
      EM0=EM0S*EMY                                                              
      PES=E*SI/(PAIL*PAIL*SA*SY)                                                
      IF(IRS.LT.0) PES=4.0*PES                                                  
      PY=SA*SY                                                                  
      WRITE(6,420) SI,PHIY,SA,PES,PY,EMY                                        
      IF(IRS.LT.0) EM0S=0.0                                                     
      EMSMQ=EM0S+QS                                                             
      W0Q=QS*EMY*L**2/(12.0*E*SI)                                               
      W0M=EM0S*EMY*L*L/(8.0*E*SI)                                               
      W0MQ=W0Q+W0M                                                              
      IF(IRS.LT.0) W0MQ=W0MQ/2.0                                                
      DLYILD=L*SY/E                                                             
      WYILD=PHIY*PAIL*PAIL                                                      
      IF(IRS.LT.0) WYILD=0.5*WYILD                                              
      GYR=SQRT(SI/SA)                                                           
      WRITE(6,430) W0MQ,GYR,WYILD,DLYILD                                        
      SRT=L/SQRT(SI/SA)                                                         
      IF(IRS.LT.0) SRT=0.5*SRT                                                  
      F2=SRT/70.0                                                               
C                                                                               
      N=0                                                                       
   30 N=N+1                                                                     
C    PLOTING FOR THE PLASTIC HINGE METHOD                                       
      IF(N.EQ.2) CALL PLOTNG(1,I-1)                                             
C    PLOTING FOR THE MODIFIED PLASTIC HINGE METHOD                              
      IF(N.EQ.3) CALL PLOTNG(2,I-1)                                             
      IF(N.GE.3) GO TO 199                                                      
      WRITE(6,401) N                                                            
      IF(N.EQ.1) GO TO 31                                                       
      PBUCK=P                                                                   
      FN=4.0/(1.0+QS+EM0S)                                                      
      FN2=1.0                                                                   
   31 CONTINUE                                                                  
      DO 15 IJ=1,150                                                            
      YY(IJ)=0.0                                                                
      XW(IJ)=0.0                                                                
   15 XS(IJ)=0.0                                                                
C                                                                               
      DO 100 I=1,NP                                                             
      IN=0                                                                      
      P=PP+PDELT*FLOAT(I-1)                                                     
      PS=P/PY                                                                   
*     WRITE(6,500) P,PS                                                         
      IF(PS.GT.1.0) GO TO 250                                                   
      IF(PS/PES.GT.1.0) GO TO 250                                               
C                                                                               
C     IF(FIRS.LT.200) GO TO 17                                                  
C     CALL MOMPHW(IRS,PS,EM1,EM2,PHI1,PHI2,EMPC)                                
C     GO TO 18                                                                  
      CALL MOMPHI(IRS,PS,EM1,EM2,PHI1,PHI2,EMPC)                                
      CALL ABCF(A,B,C,F,EM1,EM2,PHI1,PHI2,EMPC)                                 
      EMIS=P*WI/EMY                                                             
      EM0P=P*W0MQ/EMY                                                           
      IF(IRS.LT.0) EMIS=0.5*EMIS                                                
      IF(IRS.LT.0) EM0P=0.5*EM0P                                                
C  ELASTIC-PERFECTLY PLASTIC M-P-PHI CURVE                                      
C    N=1...FIRST CYCLE, MODIFIED PLASTIC HINGE METHOD                           
C    N=2...SECOND CYCLE, AVERAGE FLOW MOMENT METHOD                             
      IF(IRS.NE.109.AND.IRS.NE.-109) GO TO 10                                   
      IF(N.EQ.2) EMPC=EMPC-(P/PBUCK)**FN*(EMPC-EM1)*F2                          
      IF(N.EQ.2.AND.IRS.LT.0) EMPC=EMPC-0.5*(P/PBUCK)**FN*(EMPC-EM1)*F2         
      WME=(EMSMQ*(1.0-A)+EMIS+EM0P)/((A-PS/PES)*PES*PY/EMY)                     
      IF(IRS.LT.0) WME=2.0*WME                                                  
      WME=WME+W0MQ                                                              
      EM=EMSMQ+EMIS+EM0P+P*(WME-W0MQ)/EMY                                       
      IF(IRS.LT.0) EM=EMSMQ+EMIS+EM0P+P*(WME-W0MQ)/EMY*0.5                      
*     WRITE(6,540) WME,EM                                                       
      IF(EM.GT.EMPC) GO TO 35                                                   
                     CALL SHOTG2( L,WME,W0MQ,WI,P,SA,SI,E,SY,   EMY,IRS,        
     1         EMED,QS,IN,D,T,W0Q,W0M)                                          
      XW(2*I-1)=WME                                                             
      YY(2*I-1)=P                                                               
      XS(2*I-1)=SH                                                              
   35 WMP=(EMPC-EMSMQ-EMIS-EM0P)*EMY/P                                          
      IF(IRS.LT.0) WMP=2.0*WMP                                                  
      WMP=WMP+W0MQ                                                              
*     WRITE(6,550) WMP,EMPC                                                     
      EEP=E                                                                     
      IF(N.EQ.2) EEP=(0.50+0.50*(P/PBUCK)**FN2)*E                               
      IF(EM.GT.EMPC) GO TO 36                                                   
                     CALL SHOTG2(L,WMP,W0MQ,WI,P,SA,SI,EEP,SY,EMY,IRS,          
     1         EMED,QS,IN,D,T,W0Q,W0M)                                          
      XW(2*I)=WMP                                                               
      YY(2*I)=P                                                                 
      XS(2*I)=SH                                                                
   36 IF(IN.EQ.0) GO TO 30                                                      
      GO TO 100                                                                 
C                                                                               
C  EXACT M-P-PHI SOLUTION                                                       
   10 W1=(PHI1-EMSMQ)*EMY/(PES*PY)+W0MQ                                         
      W2=(PHI2-EMSMQ)*EMY/(PES*PY)+W0MQ                                         
      IF(IRS.GT.0) GO TO 20                                                     
      W1=(PHI1-EMSMQ)*2.0*EMY/(PES*PY)+W0MQ                                     
      W2=(PHI2-EMSMQ)*2.0*EMY/(PES*PY)+W0MQ                                     
C  WM1   ELASTIC REGION                                                         
   20 WM1=(EMSMQ*(1.0-A)+EMIS+EM0P)*EMY/(A*PES*PY-P)                            
      IF(IRS.LT.0) WM1=2.0*WM1                                                  
      WM1=WM1+W0MQ                                                              
*     WRITE(6,510) WM1,W1                                                       
      EMED=EM0S                                                                 
      IF(IRS.LT.0) EMED=EMSMQ+EMIS+P*WM1/EMY/2.0                                
      IF(WM1.GT.W1) GO TO 21                                                    
                    CALL SHOTG2(L,WM1,W0MQ,WI,P,SA,SI,E,SY,   EMY,IRS,          
     1         EMED,QS,IN,D,T,W0Q,W0M)                                          
      XW(2*I-1)=WM1                                                             
      YY(2*I-1)=P                                                               
      XS(2*I-1)=SH                                                              
C ***                                                                           
C  WM2   ONE-SIDE YIELDED REGION                                                
C *** FIND ROOTS BY SOLVING 3-RD ORDER EQUATION                                 
   21 AA=EMSMQ+EMIS+EM0P-B                                                      
      BB=P/EMY                                                                  
      DD=EMSMQ                                                                  
      EE=PES*PY/EMY                                                             
      A0=BB*BB*EE                                                               
      A1=2.0*AA*BB*EE+BB*BB*DD                                                  
      A2=2.0*AA*BB*DD+AA*AA*EE                                                  
      A3=AA*AA*DD-C*C                                                           
      CALL ROTCUB(A0,A1,A2,A3,X1,X2,X3)                                         
      WM21=X1                                                                   
      WM22=X2                                                                   
      WM23=X3                                                                   
      IF(IRS.GT.0) GO TO 22                                                     
      WM21=2.0*WM21                                                             
      WM22=2.0*WM22                                                             
      WM23=2.0*WM23                                                             
   22 WM21=WM21+W0MQ                                                            
      WM22=WM22+W0MQ                                                            
      WM23=WM23+W0MQ                                                            
      IF(ABS(WM22-WM23).GT.1.0E-5)  GO TO 40                                    
      WM22=0.0                                                                  
      WM23=0.0                                                                  
   40 CONTINUE                                                                  
      CALL ORDER(WM21,WM22,WM23)                                                
*     WRITE(6,520) WM21,WM22,WM23,W1,W2                                         
      EMED=EM0S                                                                 
      IF(IRS.LT.0) EMED=EMSMQ+EMIS+P*WM21/EMY/2.0                               
      IF(WM21.LT.W1.OR.WM21.GT.W2) GO TO 41                                     
                                    CALL SHOTG2(L,WM21,W0MQ,WI,P,SA,SI,         
     1      E,SY,EMY,IRS,EMED,QS,IN,D,T,W0Q,W0M)                                
      IF(YY(2*I-1).NE.0.0) GO TO 44                                             
      XS(2*I-1)=SH                                                              
      YY(2*I-1)=P                                                               
      XW(2*I-1)=WM21                                                            
      GO TO 41                                                                  
   44 XS(2*I)=SH                                                                
      YY(2*I)=P                                                                 
      XW(2*I)=WM21                                                              
   41 EMED=EM0S                                                                 
      IF(IRS.LT.0) EMED=EMSMQ+EMIS+P*WM22/EMY/2.0                               
      IF(WM22.LT.W1.OR.WM22.GT.W2) GO TO 42                                     
                                    CALL SHOTG2(L,WM22,W0MQ,WI,P,SA,SI,         
     1      E,SY,EMY,IRS,EMED,QS,IN,D,T,W0Q,W0M)                                
      IF(YY(2*I-1).NE.0.0) GO TO 45                                             
      XS(2*I-1)=SH                                                              
      YY(2*I-1)=P                                                               
      XW(2*I-1)=WM22                                                            
      GO TO 42                                                                  
   45 XS(2*I)=SH                                                                
      YY(2*I)=P                                                                 
      XW(2*I)=WM22                                                              
   42 EMED=EM0S                                                                 
      IF(IRS.LT.0) EMED=EMSMQ+EMIS+P*WM23/EMY/2.0                               
      IF(WM23.LT.W1.OR.WM23.GT.W2) GO TO 43                                     
                                    CALL SHOTG2(L,WM23,W0MQ,WI,P,SA,SI,         
     1      E,SY,EMY,IRS,EMED,QS,IN,D,T,W0Q,W0M)                                
      IF(YY(2*I-1).NE.0.0) GO TO 46                                             
      XS(2*I-1)=SH                                                              
      YY(2*I-1)=P                                                               
      XW(2*I-1)=WM23                                                            
      GO TO 43                                                                  
   46 XS(2*I)=SH                                                                
      YY(2*I)=P                                                                 
      XW(2*I)=WM23                                                              
C  WM3   BOTH-SIDE YIELDED REGION                                               
   43 GG=EMPC-EMSMQ-EMIS-EM0P                                                   
      A0=BB*EE*EE                                                               
      A1=2.0*BB*DD*EE-GG*EE*EE                                                  
      A2=BB*DD*DD-2.0*GG*DD*EE                                                  
      A3=F-GG*DD*DD                                                             
      CALL ROTCUB(A0,A1,A2,A3,X1,X2,X3)                                         
      WM31=X1                                                                   
      WM32=X2                                                                   
      WM33=X3                                                                   
      IF(IRS.GT.0) GO TO 55                                                     
      WM31=2.0*WM31                                                             
      WM32=2.0*WM32                                                             
      WM33=2.0*WM33                                                             
   55 WM31=WM31+W0MQ                                                            
      WM32=WM32+W0MQ                                                            
      WM33=WM33+W0MQ                                                            
      IF(ABS(WM32-WM33).GT.1.0E-5) GO TO 50                                     
      WM32=0.0                                                                  
      WM33=0.0                                                                  
   50 CONTINUE                                                                  
      CALL ORDER(WM31,WM32,WM33)                                                
*     WRITE(6,530) WM31,WM32,WM33,W2                                            
      EMED=EM0S                                                                 
      IF(IRS.LT.0) EMED=EMSMQ+EMIS+P*WM31/EMY/2.0                               
      IF(WM31.LT.W2) GO TO 56                                                   
                     CALL SHOTG2(L,WM31,W0MQ,WI,P,SA,SI,E,SY,   EMY,            
     1          IRS,EMED, QS,IN,D,T,W0Q,W0M)                                    
      IF(YY(2*I-1).NE.0.0) GO TO 51                                             
      XS(2*I-1)=SH                                                              
      YY(2*I-1)=P                                                               
      XW(2*I-1)=WM31                                                            
      GO TO 56                                                                  
   51 XW(2*I)=WM31                                                              
      YY(2*I)=P                                                                 
      XS(2*I)=SH                                                                
   56 EMED=EM0S                                                                 
      IF(IRS.LT.0) EMED=EMSMQ+EMIS+P*WM32/EMY/2.0                               
      IF(WM32.LT.W2) GO TO 57                                                   
                     CALL SHOTG2(L,WM32,W0MQ,WI,P,SA,SI,E,SY,   EMY,            
     1          IRS,EMED, QS,IN,D,T,W0Q,W0M)                                    
      IF(YY(2*I-1).NE.0.0) GO TO 52                                             
      XS(2*I-1)=SH                                                              
      YY(2*I-1)=P                                                               
      XW(2*I-1)=WM32                                                            
      GO TO 57                                                                  
   52 XS(2*I)=SH                                                                
      YY(2*I)=P                                                                 
      XW(2*I)=WM32                                                              
   57 EMED=EM0S                                                                 
      IF(IRS.LT.0) EMED=EMSMQ+EMIS+P*WM33/EMY/2.0                               
      IF(WM33.LT.W2) GO TO 58                                                   
                     CALL SHOTG2(L,WM33,W0MQ,WI,P,SA,SI,E,SY,   EMY,            
     1          IRS,EMED, QS,IN,D,T,W0Q,W0M)                                    
      IF(YY(2*I-1).NE.0.0) GO TO 53                                             
      XS(2*I-1)=SH                                                              
      YY(2*I-1)=P                                                               
      XW(2*I-1)=WM33                                                            
      GO TO 58                                                                  
   53 XS(2*I)=SH                                                                
      YY(2*I)=P                                                                 
      XW(2*I)=WM33                                                              
C ***                                                                           
   58 IF(IN.EQ.0) GO TO 250                                                     
  100 CONTINUE                                                                  
C    PLOTING FOR THE EXACT MOMENT-CURVATURE METHOD                              
  250 CALL PLOTNG(1,I-1)                                                        
C                                                                               
  199 RETURN                                                                    
  405 FORMAT(1H ,/,2X,'INPUT DATA')                                             
  400 FORMAT(1H ,/,6X,'L=',E12.4,'  E=',E12.4,'  SY=',E12.4,'  D=',E12.4        
     1      ,'  T=',E12.4,'  WI=',E12.4)                                        
  401 FORMAT(1H ,///,20X,' **********  N=',I2,'  **********')                    
  410 FORMAT(1H ,/,6X,'P=',E12.4,'  PDELT=',E12.4,'  NP=',I3,                   
     1             '  EM0S=',E12.4,'  QS=',E12.4)                               
  420 FORMAT(1H ,/,6X,'SI=',E12.4,'  PHIY=',E12.4,'  SA=',E12.4,'  PES='        
     1      ,E12.4,'  PY=',E12.4,'  MY=',E12.4)                                 
  430 FORMAT(1H ,/,6X,'W0MQ=',E12.4,'  RADIUS OF GYRATION=',E12.4,              
     1    '  WYILD=',E12.4,'  DLYILD=',E12.4)                                   
  500 FORMAT(1H , /,2X,'P=',E12.4,'  PS=',E12.4)                                
  510 FORMAT(1H ,/,5X,'WM1=',E12.4,'  W1=',E12.4)                               
  520 FORMAT(1H ,/,5X,'WM2=',3E12.4,5X,'  W1=',E12.4,'  W2=',E12.4)             
  530 FORMAT(1H ,/,5X,'WM3=',3E12.4,5X,           '  W2=',E12.4)                
  540 FORMAT(1H ,/,5X,'WM(ELASTIC)=',E12.4,'   EM=',E12.4)                      
  550 FORMAT(1H ,  5X,'WM(PLASTIC)=',E12.4,'  MPC=',E12.4)                      
      END                                                                       
      SUBROUTINE YDSHEL(IRS)                                                    
C IRS=11 SHELL APPROACH FOR PIN-END SUPPORT                                     
C IRS=-11   ...FOR FIXED-END SUPPORT                                            
C  DEFLECTION AND SHORTENING CALCULATION ACCORDING TO SHELL CONCEPT             
C  SHELL PROGRAM 'NORDREAM', AUG. 1979                                          
C                                                                               
C   SY=YIELD STRESS, E=YOUNG'S MODULUS                                          
C   PIPE...D=DIAMETER, T=THICKNESS, AL=LENGTH                                   
C   YI=INITIAL IMPERFECTION                                                     
C   TRANSVERSE FORCE AT CENTER...Q                                              
C    SQ=STARTING VALUE                                                          
C    DQ=INCREMENTAL VALUE                                                       
C    NQ=NUMBER OF REPETITIONAL CALCULATION                                      
C   AXIAL FORCE AT ENDS...P                                                     
C                                                                               
      WRITE(6,618)                                                              
  618 FORMAT(1H ,'   DEFLECTION AND SHORTENING ACCORDING TO SHELL CONCEP        
     1T')                                                                       
      READ (5,*)         SY,E,D,T,AL                                            
      AL=12.0*AL                                                                
      WRITE (6,400) SY,E,D,T,AL                                                 
      READ (5,*) YI,SQ,DQ,NQ,SP,DP,NP,EM0S                                      
      WRITE(6,410) YI                                                           
      WRITE(6,420)    SQ,DQ,NQ,SP,DP,NP,EM0S                                    
      PAI=4.0*ATAN(1.0)                                                         
      YI=AL*YI                                                                  
      SI=PAI/64.0*(D**4-(D-2.0*T)**4)                                           
      SA=PAI/4.0*(D*D-(D-2.0*T)*(D-2.0*T))                                      
      PCR=PAI*PAI*E*SI/AL/AL                                                    
      PY=SY*SA                                                                  
      THETA=ASIN(2.0*YI/AL)                                                     
      EYI=AL*COS(THETA)                                                         
      EMY=2.0*SI*SY/D                                                           
      WRITE(6,430) SI,SA,PCR,PY,EMY                                             
      QY=EMY*4.0/AL                                                             
      IF(IRS.LT.0) QY=2.0*QY                                                    
      EM0=EM0S*EMY                                                              
C                                                                               
      DO 110 I=1,NQ                                                             
      QS=SQ+DQ*FLOAT(I-1)                                                       
      WRITE(6,500) QS                                                           
      Q=QS*QY                                                                   
      N=1                                                                       
   60 WRITE(6,405) N                                                            
C  N=1... FIRST CYCLE, CONVENTIONAL CALCULATION                                 
C  N=2... SECOND CYCLE, IMPROVED METHOD                                         
      IF(IRS.EQ.11) WRITE(6,502)                                                
      IF(IRS.EQ.-11) WRITE(6,505)                                               
C                                                                               
      DO 100 J=1,NP                                                             
      P=SP+DP*FLOAT(J-1)                                                        
      IF(P.GT.4.0*PCR) GO TO 110                                                
      PSS=P/PY                                                                  
      IF(ABS(PSS).GT.1.0) GO TO 110                                             
      CALL MOMPHI(IRS,PSS,EM1,EM2,PHI1,PHI2,EMPC)                               
      IF(N.LE.1) GO TO 80                                                       
C  MODIFICATION FOR AVERAGE FLOW MOMENT, MMC                                    
      FN=4.0/(1.0+QS+EM0S)                                                      
      FR=(P/PBUCK)**FN                                                          
      EMPC=EMPC-FR*(EMPC-EM1)                                                   
   80 EMPC=EMPC*EMY                                                             
      E0P=P*AL/SA/E                                                             
C                                                                               
C   Y....DEFLECTION DUE TO Q AND P                                              
C   D....SHORTENING CAUSED BY P(AXIAL) AND Y(GEOMETRICAL)                       
C   EL....ELASTIC                                                               
C   EP....ELASTIC-PLASTIC                                                       
C   PL....PLASTIC                                                               
      IF(IRS.EQ.-11) GO TO 50                                                   
C  PIN-END                                                                      
      YELP=(YI+Q*AL**3/(48.0*E*SI)+EM0*AL*AL/(8.0*E*SI))/(1.0-P/PCR)-YI         
      BETA=ASIN(2.0*(YI+YELP)/AL)                                               
      DELP=E0P+EYI-AL*COS(BETA)                                                 
      YPLP=(EMPC-Q*AL/4.0-EM0)/P-YI                                             
      IF(2.0*(YI+YPLP)/AL.GT.1.0) YPLP=AL/2.0-YI                                
      BETA=ASIN(2.0*(YI+YPLP)/AL)                                               
      DPLP=E0P+EYI-AL*COS(BETA)                                                 
      WRITE(6,510) P,YELP,DELP,YPLP,DPLP                                        
      IF(YELP.GT.YPLP) GO TO 70                                                 
      GO TO 100                                                                 
C  FIXED-END                                                                    
   50 YELF=(YI+Q*AL**3/(192.0*E*SI))/(1-P/(4.0*PCR))-YI                         
      BETA=ASIN(2.0*(YI+YELF)/AL)                                               
      DELF=E0P+EYI-AL*COS(BETA)                                                 
      YPLF=(2.0*EMPC-Q*AL/4.0)/P-YI                                             
      IF(2.0*(YI+YPLF)/AL.GT.1.0) YPLF=AL/2.0-YI                                
      BETA=ASIN(2.0*(YI+YPLF)/AL)                                               
      DPLF=E0P+EYI-AL*COS(BETA)                                                 
      YEPF=(Q*AL**3/(48.0*E*SI)-EMPC*AL*AL/(8.0*E*SI)+YI)/(1.0-P/PCR)-YI        
      IF(YEPF.LT.0.0) YEPF=0.0                                                  
      IF(YEPF.GT.YPLF) YEPF=0.0                                                 
      BETA=ASIN(2.0*(YI+YEPF)/AL)                                               
      DEPF=E0P+EYI-AL*COS(BETA)                                                 
      WRITE(6,510) P,YELF,DELF,YEPF,DEPF,YPLF,DPLF                              
      IF(YELF.GT.YPLF) GO TO 70                                                 
  100 CONTINUE                                                                  
   70 N=N+1                                                                     
      IF(N.GE.3) GO TO 110                                                      
      PBUCK=P                                                                   
      GO TO 60                                                                  
  110 CONTINUE                                                                  
C                                                                               
      RETURN                                                                    
  400 FORMAT(1H ,/////,' INPUT DATA',//,5X,'YIELD STRESS=',E11.4,'  YOUNG M        
     1ODULUS=',E11.4,'  PIPE... D=',E11.4,' T=',E11.4,' L=',E11.4)              
  405 FORMAT(1H ,//,'  N=',I2)                                                  
  410 FORMAT(1H ,/,5X,'INITIAL DEFLECTION=',E12.4)                              
  420 FORMAT(1H ,/,5X,'LATERAL LOAD... SQ=',                                    
     1  E11.4,' DQ=',E11.4,' NQ=',I2,'  AXIAL LOAD... SP=',E11.4,' DP=',        
     2  E11.4,' NP=',I2,//,5X,'END-MOMENYS=',E11.4)                             
  430 FORMAT(1H ,//,5X,'I=',E11.4,'  A=',E11.4,'  PCR=',E11.4,'  PY=',          
     1      E11.4,'  MY=',E11.4)                                                
  500 FORMAT(1H ,/////,3X,'Q=',E12.4)                                           
  502 FORMAT(1H ,/,8X,'P',10X,'YELP',9X,'DELP',9X,'YPLP',9X,'DPLP')             
  505 FORMAT(1H ,/,8X,'P    *     YELF',9X,'DELF    *    YEPF',9X,              
     1    'DEPF    *    YPLF',9X,'DPLF')                                        
  510 FORMAT(1H ,10E13.4)                                                       
      END                                                                       
