************************************************************************
***** PROGRAM BRACE DEVELOPED BY I.S. SOHAL AT PURDUE UNIVERSITY  ******
************************************************************************
      common/plt/yy(1000),xw(1000),xs(1000)
      common/parm/ irs,nout,nond
      common/sec2/ emy,phibo,phiy,py
      common/col/al,pes,wyild,syild,srt,nel,qy
      common/def/wi,w0q,w0m,w0mq
      dimension ni(20)
c
      read(5,*) ncase,nout
      write(6,100) ncase,nout
      nc = ncase
      iarg = 1
c
      do 10 i = 1,ncase
	call datage (i)
	call load (yy(iarg),xw(iarg),xs(iarg),ii)
	call unload (yy(iarg),xw(iarg),xs(iarg),ii)
	if(nond.eq.1) then
	  do 20 jj = iarg,iarg+ii-1
	    yy(jj) =  yy(jj)/py
	    xw(jj) =  xw(jj)/wyild
	    xs(jj) =  xs(jj)/syild
 20       continue
        endif
        ni(i) = ii
	iarg = iarg + ii
 10   continue
c
      call out(yy,xw,xs,iarg,ncase,ni)
c
      stop
  100 format(///,2x,'total number of cases to be analysed = ',i2,//,2x,
     *'nout = ',i2)
      end
c
c----------------------------------------------------------------------- 
      subroutine datage(icase)
c----------------------------------------------------------------------- 
      common/bug/ nbug,jp1,jp2,nbug0
      common/parm/ irs,nout,nond
      common/sec1/ dot,d,t,sigy,e
      common/sec2/ emy,phibo,phiy,py
      common/pi/ pi
      common/newt/xx,in,dx,eps,n,lim
      common/col/al,pes,wyild,syild,srt,nel,qy
      common/rev/ wmr,smr,smt,pr,emr,rl,fwm,epsr(20),phir(20),yr(20)
      common/rev2/nin,irev,ishp
      common/load1/ em0s,qs,emsmq,pp,pdelt,np,pmax
      common/def/wi,w0q,w0m,w0mq
      common/plt/yy(1000),xw(1000),xs(1000)
c
      write(6,100) icase
  100 format(//,5x,'input and preliminary data for case',i2)
      nbug=0
      jp1=0
      jp2=0
c      read(5,*) nbug,jp1,jp2
      nbug0 = 0
      read(5,*) irs,nond
      write(6,110) irs,nond
  110 format(//,10x,'irs = ',i4,10x,'nond = ',i2)
      read(5,*) d,t,e,sigy
      write (6,120) d,t,e,sigy
  120 format (/,10x,'d = ',f8.3,5x,'t = ',f6.3,5x,'e = ',f10.2,//,
     *        10x,'sigy = ',f8.2)
      read(5,*) al,wi,nel
      al=12.0*al
      wi=wi*al
      write(6,130) al,wi,nel
  130 format (/,10x,'length = ',f7.2,5x,'wi = ',f6.4,5x,'nel = ',i2)
c
      pi=4.0*atan(1.0)
      si=pi/64.0*(d**4-(d-2.0*t)**4)
      sa=pi/4.0*(d*d-(d-2.0*t)*(d-2.0*t))
      gyr=sqrt(si/sa) 
      write(6,140) si,sa,gyr
  140 format (/,10x,'moi = ',f8.2,5x,'area = ',f6.2,5x,
     *         'rad. of gyr = ',f6.3)
      srt=al/sqrt(si/sa)
      if(irs.lt.0) srt=0.5*srt
      write(6,145) srt
  145 format(/,10x,'kl/r=',f6.2)
c
      phiy=atan(2.0*sigy/d/e)
      write (6,147) phiy
  147 format (/,10x,'phiy = ',e12.4)
      emy=e*si*phiy 
      alpi=al/pi
      pes=e*si/(alpi*alpi*sa*sigy)
      if(irs.lt.0) pes=4.0*pes
      py=sa*sigy
      emp = sigy * ((d+t)**3. - (d-t)**3.)/6.
      shap = emp/emy
      qy = 4.*emy/al
      if(irs.lt.0) qy=qy*2.
      write(6,150) pes*py,py
  150 format (/,10x,'el.buck.load = ',f8.2,5x,'yld.axial load = ',f8.2)
      write(6,160) emy,emp,shap
  160 format (/,10x,'my = ',f10.2,5x,'mp = ',f10.2,5x,'sh fac = ',f5.3)
c
      read(5,*) pp,pdelt,np,em0s,qs 
      write(6,170) pp,pdelt,np
  170 format (/,10x,'pp = ',f8.2,5x,'pdelt = ',f6.2,5x,'np = ',i4)
      if(irs.lt.0) em0s=0.0 
      write(6,180) em0s,qs
  180 format (/,10x,'em0s = ',f4.2,5x,'qs = ',f4.2)
      emsmq=em0s+qs 
      w0q=qs*emy*al**2/(12.0*e*si)
      w0m=em0s*emy*al*al/(8.0*e*si)
      w0mq=w0q+w0m
      if(irs.lt.0) w0mq=w0mq/2.0
      syild=al*sigy/e
      wyild=phiy*alpi*alpi
      if(irs.lt.0) wyild=0.5*wyild
      write (6,190) w0mq,wyild,syild
  190 format(/,10x,'w0mq = ',f6.3,5x,'wyild = ',f6.3,
     *       5x,'syild = ',f6.3)
c
      dot = d/t
      if(iabs(irs).gt.200 .and. iabs(irs).lt.300) then
        phibo = 4.1 - 500./dot + 22500./(dot**2.) 
	xx = 0.
	in  = 0
	dx  = 0.001
	eps = 0.00001
	n   = 10
	lim = 50
      endif 
c
      call maxp(irs,srt,emy,emsmq,wi,w0mq,pes,py,pmax)
      write(6,200) pmax
  200 format (/,10x,'max. axial capacity = ',f8.2)
      read(5,*) wmr,smr,smt
      if(nond.eq.1) wmr = wmr*wyild
      if(nond.eq.1) smr = smr*syild
      if(nond.eq.1) smt = smt*syild
      write(6,210) wmr,smr,smt
  210 format (/,10x,'wmr = ',f6.2,5x,'smr = ',f6.2,5x,'smt = ',f6.2)
      read(5,*) nin,irev,ishp
      write(6,220) nin,irev,ishp
  220 format(/,10x,'nin = ',i3,5x,'irev = ',i2,5x,'ishp = ',i2)
c 
      return
      end
c
c----------------------------------------------------------------------- 
      subroutine load(yy,xw,xs,iarg)
c----------------------------------------------------------------------- 
      common/parm/ irs,nout,nond
      common/sec1/ dot,d,t,sigy,e
      common/sec2/ emy,phibo,phiy,py
      common/load1/ em0s,qs,emsmq,pp,pdelt,np,pmax
      common/col/al,pes,wyild,syild,srt,nel,qy
      common/def/wi,w0q,w0m,w0mq
      common/rev/ wmr,smr,smt,pr,emr,rl,fwm,epsr(20),phir(20),yr(20)
      common/pi/ pi
      common /abc/  a,b,c,f,em1,em2,empc,phi1,phi2,ddd
      common /abcr/  ar,br,cr,fr,em1r,em2r,empcr,phi1r,phi2r,dddr
      dimension aa(500)
      dimension yy(1),xw(1),xs(1)
c
      do 100 i = 1,np
	p = pp + pdelt*float(i-1)
	ps = p/py
	if(ps.gt.1.0) go to 200
	if(ps/pes.gt.1.0) go to 200
	call admcol (p,xw1,xw2,xs1,xs2,i)
	if(xw1.lt. 0.) go to 200
	yy(i*2-1) = p
	yy(i*2) = p
	xw(i*2-1) = xw1
	xw(i*2) = xw2
	xs(i*2-1) = xs1
	xs(i*2) = xs2
 100  continue
 200  continue
c    rearrange yy, xw, xs in sequence 
      i = i-1
      do 20 j=1,i
      aa(j)=yy(2*j)
   20 yy(j)=yy(2*j-1)
      do 25 j=1,i 
   25 yy(i+j)=aa(i+1-j)
      do 26 j=1,i 
      aa(j)=xw(2*j)
   26 xw(j)=xw(2*j-1)
      do 27 j=1,i 
   27 xw(i+j)=aa(i+1-j)
      do 28 j=1,i 
      aa(j)=xs(2*j)
   28 xs(j)=xs(2*j-1)
      do 29 j=1,i 
   29 xs(i+j)=aa(i+1-j)
c 
c    find the index iw corresponding to maximum deflection
c
      if(wmr.gt.0.0) then
      do 30 iw=1,500
      if(abs(xw(iw)).ge.wmr) go to 31
   30 continue
   31 continue
c     perform calculations for wmr
      iter = 0
      slop = pdelt/abs((xw(iw)-xw(iw-1)))
      p = abs(yy(iw-1)) - slop*(wmr-abs(xw(iw-1)))
 300  iter = iter + 1
      if(iter.ge.25) stop 00
      call admcol(p,xw1,xw2,xs1,xs2,i)
      pdif = slop * (wmr - xw2)
 310  p = p-pdif
      if(p.le.yy(iw)) then
	pdif = pdif/2.
	go to 310
      endif
      conv1 = abs(pdif/pmax)
      conv2 = abs((wmr-xw2)/wmr)
      if(conv1. gt. 0.01 .and. conv2 .gt. 0.01) go to 300
c
      yy(iw) = p
      xw(iw) = wmr
      xs(iw) = xs2
      iarg = iw
      endif
c
c    find the index is corresponding to maximum deflection
c
      if(smr.gt.0.0) then
      do 430 is=1,500
      if(abs(xs(is)).ge.smr) go to 431
  430 continue
  431 continue
c     perform calculations for smr
      iter = 0
      slop = pdelt/abs((xs(is)-xs(is-1)))
      p = abs(yy(is-1)) - slop*(smr-abs(xs(is-1)))
 400  iter = iter + 1
      if(iter.ge.25) stop 00
      call admcol(p,xw1,xw2,xs1,xs2,i)
      pdif = slop * (smr - xs2)
 410  p = p-pdif
      if(p.lt.yy(is)) then
	p = p + pdif
	pdif = pdif/2.
	go to 410
      endif
      conv1 = abs(pdif/pmax)
      conv2 = abs((smr-xs2)/smr)
      if(conv1. gt. 0.01 .and. conv2 .gt. 0.01) go to 400
c
      yy(is) = p
      xw(is) = xw2
      xs(is) = smr
      iarg = is
      endif
      wmr = xw(iarg)
      smr = xs(iarg)
      pr = yy(iarg)
c
c
      alpi = al/pi
      fshp = exp((1.- pmax/pr)*0.30)
      fwm = fshp
      wmr = wmr - w0mq
      ws = wmr
      phic1 = fshp*ws/(alpi*alpi*phiy)
      if(irs .lt.0) phic1 = phic1 * 2.
      phic2 = (1.-fshp)*ws*38.40/al/al/phiy
      phic = phic1 + phic2
      prs = pr/py
      call momphi(irs,prs,0.)
      call abcf(irs)
      if(abs(irs).lt.200) then
	call mom(a,b,c,ddd,f,phi1,phi2,empc,phic,emr)
      endif
      ar = a
      br = b
      cr = c
      dddr = ddd
      fr = f
      em1r = em1
      em2r = em2
      empcr = empc
      phi1r = phi1
      phi2r = phi2
      dddr = ddd
      em0 = em0s*emy
      q = qs*qy
      do 3 k=1,nel+1
	xl=float(k-1)/float(2*nel)
	yq=3.0*w0q*(xl-4.0*xl**3/3.0)
	if(irs.lt.0) yq=12.0*w0q*(xl*xl-4.0*xl**3/3.0)
	ym=4.0*w0m*(xl-xl*xl)
	ys=ws*sin(pi*xl)
	if(irs.lt.0) ys=ws/2.0*(1.0-cos(2.0*pi*xl))
	yi=wi*sin(pi*xl)
	if(irs.lt.0) yi=wi/2.0*(1.0-cos(2.0*pi*xl))
	arg = (xl - 0.5)/0.04
	yfm = ws*(1. - (arg*atan(arg)-0.5*alog(1.+arg*arg))/16.11 )
	yr(k)=yq+ym+ys*fshp+yfm*(1.-fshp)
        if(irs.gt.0) then 
	  phim = em0s
	  phiq = qs*2.*xl
	  phip1 = phic1*sin(pi*xl)
	  phip2 = phic2/(1.+((xl-0.5)/0.040)**2.)
	  phir(k) = phim + phiq + phip1 + phip2
	else
	  phiq = qs * (4.*xl - 1.)
	  phip1 = - phic1 * cos(2.*pi*xl)
	  phip2 = phic2/(1.+((xl-0.5)/0.040)**2.)
	  phir(k) = abs(phiq + phip1 + phip2)
        endif 
	phi = phiy*phir(k)
        pneg = -pr
	call e0strn(e,sigy,d,t,pneg,0.,phi,epsr(k),k)
  3   continue
      return
  550 format(8(3x,e12.4))
      end
c----------------------------------------------------------------------- 
      subroutine admcol(p,xw1,xw2,xs1,xs2,i)
c----------------------------------------------------------------------- 
c
      common/bug/ nbug,jp1,jp2,nbug0
      common/parm/ irs,nout,nond
      common/sec1/ dot,d,t,sigy,e
      common/sec2/ emy,phibo,phiy,py
      common/pi/ pi
      common/col/al,pes,wyild,syild,srt,nel,qy
      common/load1/ em0s,qs,emsmq,pp,pdelt,np,pmax
      common/rev/ wmr,smr,smt,pr,emr,rl,fwm,epsr(20),phir(20),yr(20)
      common/def/wi,w0q,w0m,w0mq
      common /abc/  a,b,c,f,em1,em2,empc,phi1,phi2,ddd
c
      if(nbug.eq.1 .or. nbug0.eq.1) then
        if(nbug.ne.0) nbug0 = nbug
        if(i.lt.jp1.or.i.gt.jp2) nbug = 0 
        if(i.ge.jp1.and.i.le.jp2) nbug = 1
      endif 
      xw1= -1.
      xw2=-1.
      iflg2 = 0
      phi = -99.
      ps= p / py
      if(p.le.pmax) fshp = exp((1.- pmax/p)*0.30)
      if(irs.gt.0) ff = fshp + (1.- fshp)*38.40/pi/pi
      if(irs.lt.0) ff = fshp + (1.- fshp)*38.40/pi/pi/2.
      fshp1 = 1.
c
      if(nbug.eq.1) print*,'ps=',ps,' irs=',irs
      call momphi(irs,ps,0.)
      if(nbug.eq.1) print*,'phi1=',phi1
      call abcf(irs)
c 
      emis=p*wi/emy 
      em0p=p*w0mq/emy 
      if(irs.lt.0) emis=0.5*emis
      if(irs.lt.0) em0p=0.5*em0p
c 
c  exact m-p-phi solution 
c 
      if(iabs(irs).gt.200 .and. iabs(irs).lt.300) then
        call bklphi (ps,phibo,phibpo,i) 
        phibp = phibpo - emsmq
	call mom(a,b,c,ddd,f,phi1,phi2,empc,phibpo,empeak)
	if (nbug.eq.1) print*,'empeak=',empeak
      endif 
      if(iabs(irs) .gt. 300) then
	call closed(dot,ps,phibp1,em3,ei2)
	call mom(a,b,c,ddd,f,phi1,phi2,empc,phibp1,empeak)
	phibp = phibp1 - emsmq
      endif
      if(nbug.eq.1) print*,'phi1=',phi1
      if(irs. gt. 0) then 
        w1=(phi1-emsmq)*emy/(pes*py)+w0mq 
        w2=(phi2-emsmq)*emy/(pes*py)+w0mq 
        if(iabs(irs) .gt.200) wbkl=phibp*emy/(pes*py)+w0mq
      else
        w1=(phi1-emsmq)*2.0*emy/(pes*py)+w0mq 
        w2=(phi2-emsmq)*2.0*emy/(pes*py)+w0mq 
        if(iabs(irs) .gt.200) wbkl=phibp*2.0*emy/(pes*py)+w0mq
      endif 
      if(nbug.eq.1) then
        print*,'i=',i 
        if(iabs(irs) .gt.200)write(6,560) phibo,phibpo,phibp,wbkl 
      endif 
c 
c  wm1   elastic region 
c  ---------------------------
      wm1=(emsmq*(1.0-a)+emis+em0p)*emy/(a*pes*py-p)
      if(irs.lt.0) wm1=2.0*wm1
      wm1=wm1+w0mq
      if(nbug.eq.1)write(6,510) wm1,w1
      if(wm1.le.w1) then
	call shotg(wm1,p,1.,sh)
	xw1=wm1
	xs1=sh
      endif
c *** 
c  wm2   one-side yielded region
c  ---------------------------------- 
c *** find roots by solving 3-rd order equation 
      aa=emsmq+emis+em0p-b
      bb=p/emy
      dd=emsmq
      ee=pes*py/emy 
      if(abs(xw1) .ne. 0.) then
	ee = ee*ff
	fshp1 = fshp
	w2 = (w2-w0mq)/ff + w0mq
	iflg2 = 1
      endif
      a0=bb*bb*ee 
      a1=2.0*aa*bb*ee+bb*bb*dd
      a2=2.0*aa*bb*dd+aa*aa*ee
      a3=aa*aa*dd-c*c 
      call rotcub(a0,a1,a2,a3,x1,x2,x3) 
      wm21=x1 
      wm22=x2 
      wm23=x3 
      if(irs.lt.0) then
	wm21=2.0*wm21
	wm22=2.0*wm22
	wm23=2.0*wm23
      endif
      wm21=wm21+w0mq
      wm22=wm22+w0mq
      wm23=wm23+w0mq
      if(abs(wm22-wm23).le.1.0e-5)  then
	wm22=0.0
	wm23=0.0
      endif
      call order(wm21,wm22,wm23)
      if(nbug.eq.1)write(6,520) wm21,wm22,wm23,w1,w2
      if(wm21.ge.w1.and.wm21.le.w2) then
       if(irs .gt.0) emext = emsmq + emis + em0p + p*wm21/emy
       if(irs .lt.0) emext = emsmq + emis + em0p + p*wm21/(2.*emy)
       sphi = c/(b - emext)
       if(sphi .ge. 0.) then
	 call shotg(wm21,p,fshp1,sh)
	 if(xw1.eq.0.0) then
	  xs1=sh
	  xw1=wm21
	 else
	  xs2=sh
	  xw2=wm21
	 endif
       endif
      endif
      if(wm22.gt.w1.and.wm22.lt.w2) then
       if(irs .gt.0) emext = emsmq + emis + em0p + p*wm22/emy
       if(irs .lt.0) emext = emsmq + emis + em0p + p*wm22/(2.*emy)
       sphi = c/(b - emext)
       if(sphi .ge. 0.) then
	 call shotg(wm22,p,fshp1,sh)
	 if(xw1.eq.0.0) then
	  xs1=sh
	  xw1=wm22
	 else
	  xs2=sh
	  xw2=wm22
	 endif
       endif
      endif
      if(wm23.ge.w1.and.wm23.le.w2) then
       if(irs .gt.0) emext = emsmq + emis + em0p + p*wm23/emy
       if(irs .lt.0) emext = emsmq + emis + em0p + p*wm23/(2.*emy)
       sphi = c/(b - emext)
       if(sphi .ge. 0.) then
	 call shotg(wm23,p,fshp1,sh)
	 if(xw1.eq.0.0) then
	  xs1=sh
	  xw1=wm23
	 else
	  xs2=sh
	  xw2=wm23
	 endif
       endif
      endif
c  wm3   both-side yielded region 
c ------------------------------- 
   43 gg=empc-emsmq-emis-em0p 
      dd = dd + ddd 
      if(abs(xw1).ne.0.0 .and. iflg2.ne.1 ) then
	ee = ee*ff
	fshp1 = fshp
	w2 = (w2-w0mq)/ff + w0mq
      endif
      a0=bb*ee*ee 
      a1=2.0*bb*dd*ee-gg*ee*ee
      a2=bb*dd*dd-2.0*gg*dd*ee
      a3=f-gg*dd*dd 
      call rotcub(a0,a1,a2,a3,x1,x2,x3) 
      wm31=x1 
      wm32=x2 
      wm33=x3 
      if(irs.lt.0) then
       wm31=2.0*wm31
       wm32=2.0*wm32
       wm33=2.0*wm33
      endif
      wm31=wm31+w0mq
      wm32=wm32+w0mq
      wm33=wm33+w0mq
      if(abs(wm32-wm33).lt.1.0e-5) then
       wm32=0.0
       wm33=0.0
      endif
      call order(wm31,wm32,wm33)
      if(nbug.eq.1)write(6,530) wm31,wm32,wm33,w2
      if(wm31.ge.w2) then
	call shotg(wm31,p,fshp1,sh)
	if(xw1.eq.0.0) then
	 xs1=sh
	 xw1=wm31
	else
	 xs2=sh
	 xw2=wm31
	endif
      endif
      if(wm32.ge.w2) then
	call shotg(wm32,p,fshp1,sh)
	if(xw1.eq.0.0) then
	 xs1=sh
	 xw1=wm32
	else
	 xs2=sh
	 xw2=wm32
	endif
      endif
      if(wm33.ge.w2) then
	call shotg(wm33,p,fshp1,sh)
	if(xw1.eq.0.0) then
	 xs1=sh
	 xw1=wm33
	else
	 xs2=sh
	 xw2=wm33
	endif
      endif
      if(iabs(irs) .lt. 200) rl = 1.
c *** 
      if(iabs(irs) .gt. 200) then
	if(abs(xw1).ne.0.) then
	  fshp1 = fshp
	  wbkl = (wbkl-w0mq)/ff + w0mq
	endif
      if(xw2 .gt. wbkl) then
	wm4 = xw2 - w0mq
	if(irs .gt. 0) phio = wm4*pes*py/emy*ff + emsmq
	if(irs .lt. 0) phio = (wm4/2.)*pes*py/emy*ff + emsmq
	if(nbug.eq.1)write(6,565) wm4,phio
        phi = phio
	dphim = phio - phibp
        n = 0 
	emu = 0.
	dphi = 0.
	if(nbug.eq.1) print*,'n,emext,emint,emu,phi,wm4'
  300   n = n + 1 
	if(n.gt.30) then
          write (6,570) i 
          return
        endif 
        if(irs .gt.0) emext = emsmq + emis + em0p + p*wm4/emy 
        if(irs .lt.0) emext = emsmq + emis + em0p + p*wm4/(2.*emy)
	if(iabs(irs).gt.200 .and. iabs(irs).lt.300) then
	  call locb(phi,ps,phibo,emint,i)
	  emint = emint * empeak
	endif
	if(iabs(irs) .gt. 300)
     *  emint = (empeak-em3)*exp((phi-phibp1)*ei2/(empeak-em3)) + em3
        emu1 = emu
        emu = emext - emint 
        if(abs(emu) .gt. 0.005) then
          if(n.lt.2) slop = 0.
          if(n.ge.2) slop = (emu - emu1) / (-dphi)
          if(abs(slop).gt.0.00001) dphi = emu / slop
	  if(abs(slop).le.0.00001 .or. dphi.ge.phi)
     *     dphi = emu * dphim/10.
          phi = phi - dphi
	  wm4 = (phi-emsmq) * emy / (pes*py)/ff
          if(irs .lt. 0) wm4 = 2.*wm4 
	  if(nbug.eq.1)write(6,580) n,emext,emint,emu,phi,wm4
          go to 300 
        else
	  if(nbug.eq.1)write(6,580) n,emext,emint,emu,phi,wm4
          wm4 = wm4 + w0mq
	  if(nbug.eq.1) print*,'wm4=',wm4
	  call shotg(wm4,p,fshp1,sh)
	  xs2=sh
	  xw2=wm4
        endif 
	emr = emint
	rl = emint/empeak
      endif 
      endif 
c 
      return
  500 format(/,2x,'p=',e12.4,'  ps=',e12.4)
  510 format(/,5x,'wm1=',e12.4,'  w1=',e12.4)
  520 format(/,5x,'wm2=',3e12.4,5x,'  w1=',e12.4,'  w2=',e12.4)
  530 format(/,5x,'wm3=',3e12.4,5x,           '  w2=',e12.4)
c 540 format(/,5x,'wm(elastic)=',e12.4,'   em=',e12.4)
c 550 format(/,5x,'wm(plastic)=',e12.4,'  mpc=',e12.4)
  560 format(/,5x,'phibo=',e12.4,5x,'phibpo=',e12.4,5x,'phibp=',e12.4,
     1       5x,'wbkl=',e12.4/) 
  565 format(/,5x,'wm4=',e12.4,5x,'phio=',e12.4)
  570 format(//,'too many iterations while iterating phi',
     1           5x,'np='i5//)
  580 format(5x,i3,5(3x,e12.4)) 
      end 
c 
c----------------------------------------------------------------------- 
      subroutine shotg(wm,p,fshp,sh)
c----------------------------------------------------------------------- 
c  calculation of shortening due to axial force both
c  geometrical and material
c----------------------------------------------------------------------- 
      common/parm/ irs,nout,nond
      common/sec1/ dot,d,t,sigy,e
      common/sec2/ emy,phibo,phiy,py
      common/pi/ pi
      common/col/al,pes,wyild,syild,srt,nel,qy
      common/load1/ em0s,qs,emsmq,pp,pdelt,np,pmax
      common/def/wi,w0q,w0m,w0mq
c
      dimension e0(30)
c
      ns = nel
      ps=p/py 
      pneg=-ps*py 
      alpi = al/pi
c     w0mq = w0q+w0m
      phic1 = fshp*(wm-w0mq)/(alpi*alpi*phiy)
      if(irs .lt.0) phic1 = phic1 * 2.
      phic2 = (1.-fshp)*(wm-w0mq)*38.40/al/al/phiy
c 
c  (1) axial strain shortening
c      shortening considering inelasticity from m-p-phi curves
c 
      dl=0.5*al/float(ns) 
c 
      do 20 i=1,ns+1
        xi=dl*float(i-1)
c-----  pin-end 
        if(irs.gt.0) then 
	  phim = em0s
	  phiq = qs*2.*xi/al
	  phip1 = phic1*sin(pi*xi/al)
	  phip2 = phic2/(1.+((xi-al/2.)/al/0.040)**2.)
	  phi = phim + phiq + phip1 + phip2
	else
c---    fixed-ends
	  phiq = qs * (4.*xi/al - 1.)
	  phip1 = - phic1 * cos(2.*pi*xi/al)
	  phip2 = phic2/(1.+((xi-al/2.)/al/0.040)**2.)
	  phi = abs(phiq + phip1 + phip2)
        endif 
c 
c---    computation of e0 knowing phi and p and p-phi-e0 curve equations
	phi=phi*phiy
	call e0strn(e,sigy,d,t,pneg,0.,phi,e0(i),i)
   20 continue
c 
      shortp=0.5*e0(1)*dl 
      do 30 i=2,ns
   30 shortp=shortp+e0(i)*dl
      shortp=2.0*(shortp+e0(ns+1)*0.5*dl) 
c 
c  (2) geometrical shortening 
c      geomerical shortening of sine curve and polynomial functions 
c 
      ws=wm-w0mq
      alq=al+shortp
      alqq=alq
      do 2 i=1,10 
      aln=0.0 
      dl1=0.0 
      dh=alqq/float(ns)*0.5 
      y1=0.0
      do 3 k=1,ns
      xl=float(k)/float(2*ns)
      yq=3.0*w0q*(xl-4.0*xl**3/3.0) 
      if(irs.lt.0) yq=12.0*w0q*(xl*xl-4.0*xl**3/3.0)
      ym=4.0*w0m*(xl-xl*xl) 
      ys=ws*sin(pi*xl)
      if(irs.lt.0) ys=ws/2.0*(1.0-cos(2.0*pi*xl))
      yi=wi*sin(pi*xl)
      if(irs.lt.0) yi=wi/2.0*(1.0-cos(2.0*pi*xl))
      arg = (xl - 0.5)/0.04
      yfm = ws*(1. - (arg*atan(arg)-0.5*alog(1.+arg*arg))/16.11 )
      y2=yq+ym+yi+ys*fshp+yfm*(1.-fshp)
      yd=y2-y1
      sd=sqrt(yd*yd+dh*dh)
      y1=y2 
    3 aln=aln+sd
      aln=2.0*aln 
      dl2=aln-alqq
      ddl=dl1-dl2 
      if(abs(ddl).lt.1.0e-3)  go to 5 
      if(abs(alq-aln).lt.1.0e-4) go to 5
      dl1=dl2 
    2 alqq=alq-dl2
    5 short=-dl2+pi*pi*wi*wi/4.0/al
c 
      sh=-(shortp+short)
      return
      end 
c
c----------------------------------------------------------------------- 
      subroutine e0strn(e,syild,dia,t,p,phix,phiy,e01,j)
c----------------------------------------------------------------------- 
c  calculation of axial strain, e0, knowing p, phix and phiy
c----------------------------------------------------------------------- 
      rc=(dia-t)/2.0
      n=0 
      ey=syild/e
      pai=4.0*atan(1.0) 
      e0=p/(2.0*pai*e*t*rc) 
      if(p.gt.0.0) e01=e0 
      if(p.gt.0.0) go to 100
      err=1.0e-5
      phi0=sqrt(phix*phix+phiy*phiy)
      tphi=rc*tan(phi0) 
      eult1=tphi-e0 
      eult2=tphi+e0 
      if(eult1.gt.ey.and.eult2.gt.ey) go to 300 
      if(eult1.gt.ey. or.eult2.gt.ey) go to 200 
      e01=e0
      go to 100 
  200 n=n+1 
      if(n.gt.30) go to 190 
      eta1=(ey+e0)/tphi 
      if(abs(eta1).gt.1.0) go to 191
      thety=asin(eta1)
      e01=(p/(e*t*rc)+ey*(pai-2.0*thety)-2.0*tphi*cos(thety))/(pai+ 
     1     2.0*thety) 
      eult1=tphi-e01
      eult2=tphi+e01
      if(eult1.gt.ey.and.eult2.gt.ey) go to 300 
      if(abs(e01-e0).lt.err) go to 100
      e0=e01
      go to 200 
  300 n=n+1 
      if(n.gt.30) go to 190 
      eta1=(ey+e0)/tphi 
      eta2=(ey-e0)/tphi 
      if(abs(eta1).gt.1.0) go to 191
      if(abs(eta2).gt.1.0) go to 200
      thety1=asin(eta1) 
      thety2=asin(eta2) 
      e01=(p/(2.0*e*t*rc)-tphi*(cos(thety1)-cos(thety2))-ey*(thety1-
     1     thety2))/(thety1+thety2) 
      if(abs(e01-e0).lt.err) go to 100
      e0=e01
      go to 300 
  190 continue
      go to 100 
  191 write(6,520) j
  100 return
  520 format(' ***  eta1.gt. 1  in e0-strain  j= ',i3)
      end 
c----------------------------------------------------------------------- 
      subroutine abcf(irs1)
c----------------------------------------------------------------------- 
      common /abc/  a,b,c,f,em1,em2,empc,phi1,phi2,d
c    coefficients of circular tube section for m-p-phi
      if(abs(empc).lt.0.0001) then
	a= 1.
	b = 0.
	c = 0.
	d = 0.
	f = 0.
	return
      endif
      irs = iabs(irs1)
      if(irs .gt. 300) irs = irs - 300
      if(irs .gt. 200) irs = irs - 200
      if(irs .gt. 100) irs = irs - 100
      a=em1/phi1
      b=(em2*sqrt(phi2)-em1*sqrt(phi1))/(sqrt(phi2)-sqrt(phi1)) 
      c=(em2-em1)/(1.0/sqrt(phi1)-1.0/sqrt(phi2)) 
      if(irs .lt. 10) d = 0.
      if(irs .gt. 10)
     1    d = 4.*(empc-em2)*(phi2**1.5)/c  - phi2 
      f = (empc-em2) * ((phi2+d)** 2.)
      return
      end 
c----------------------------------------------------------------------- 
      subroutine momphi(irs1,ps,qr)
c----------------------------------------------------------------------- 
      common /abc/  a,b,c,f,em1,em2,empc,phi1,phi2,ddd
c
      irs = iabs(irs1)
      if(irs .gt. 300) irs = irs - 300
      if(irs .gt. 200) irs = irs - 200
      if(irs .gt. 100) irs = irs - 100
      if(irs .gt. 10) then
      q = qr
      p = ps
c---- calculate m1, phi1
      if (p.le.0.6) em1 = 0.96 - 0.87*p - 0.45*q +
     +                    0.92*p*q - 0.38*(p**2) + 0.22*q*(p**2)
      if (p.gt.0.6) em1 = 0.45 + 0.05*p - 0.5*(p**2)
      phi1 = em1
c 
c---- calculate m2,phi2 
c 
      if (p. le. 0.6) then
        if (q .le. 0.4) then
          em2 = 1.15 - 0.1*p - 0.15*q - 0.35*p*q -
     +          1.14*(p**2) + 0.99*q*(p**2) 
          phi2 = 1./ (0.7 - 0.65*p + 1.33*p*q + 
     +                0.38*(p**2) - 2.22*q*(p**2))
        else
          em2 = 1.27 - 0.79*p - 0.46*q + 1.37*p*q - 
     +          0.33*(p**2) - 1.02*q*(p**2) 
          phi2 = 1./ (0.5 + 0.72*p + 0.5*q - 2.08*p*q - 
     +                1.35*(p**2) - 2.08*q*(p**2) ) 
        endif 
      else
        em2 = 2.3 - 3.14*p + 0.84*(p**2)
        phi2 = 22. - 42.*p + 20.*(p**2) 
      endif 
c 
c---- calculate mpc 
c 
      if (p.le.0.6) then
        if (q.le.0.4) empc = 1.259 - 0.07*p - 0.21*q + 0.64*q*p - 
     +                       1.35*(p**2) - 0.48*q*(p**2)
        if (q.gt.0.4) empc = 1.3 - 0.05*p - 0.33*q + 0.59*p*q - 
     +                       1.43*(p**2) - 0.19*q*(p**2)
      else
        empc = 1.85*(1.- p) 
      endif 
      endif 
c
      if(irs.ne.3)  go to 30
      em1=0.75-ps 
      if(em1.lt.0.0) em1=1.0e-10
      phi1=em1
      em2=1.24-0.233*ps-1.17*ps*ps
      if(ps.gt.0.6) em2=1.7*(1.0-ps)
      phi2=3.6-0.433*ps-0.25*ps*ps-2.917*ps**3
      go to 220 
   30 continue
c  saleeb's curve fitting equations 
      if(irs.ne.0)  go to 200 
c   without residual stresses 
      em1=1.0-ps
      phi1=em1
      if(ps.gt.0.4) go to 50
      em2=1.0+0.21*ps-1.05*ps*ps
      phi2=1.0/(1.0-1.395*ps+1.206*ps*ps) 
      go to 220 
   50 em2=1.528*(1.0-ps)
      phi2=2.625*(1.0-ps) 
      go to 220 
c   with residual stresses
  200 if(irs.ne.1)  go to 300 
      if(ps.gt.0.6) go to 210 
      em1=0.893-1.305*ps+0.796*ps*ps
      phi1=em1
      em2=0.893+0.546*ps-1.946*ps*ps
      phi2=1.0/(1.12-2.491*ps+4.308*ps*ps)
      go to 220 
  210 em1=1.50-2.333*ps+0.833*ps*ps 
      phi1=em1
      em2=1.375-1.5*ps+0.125*ps*ps
      phi2=1.0+0.875*ps-1.875*ps*ps 
  220 if(ps.gt.0.65) go to 230
      empc=1.299*(1.0-1.18*ps*ps) 
      go to 240 
  230 empc=1.86*(1.0-ps)
  300 if(irs.ne.2) go to 240
      if(ps.gt.0.4) go to 40
      em1=1.25*ps-2.5*(ps-0.4)*(0.893-0.876*qr+0.591*qr*qr) 
      phi1=1.25*ps-2.5*(ps-0.4)*(.893-0.876*qr+0.591*qr*qr) 
      go to 42
   40 if(ps.gt.0.6) go to 41
      em1=0.893-1.305*ps+0.796*ps*ps
      phi1=.893-1.305*ps+0.796*ps*ps
      go to 42
   41 em1=1.5-2.333*ps+0.833*ps*ps
      phi1=1.5-2.333*ps+0.833*ps*ps 
   42 if(ps.gt.0.4) go to 43
      em2=2.5*ps*(0.8+0.066*qr-0.166*qr*qr)-2.5*(ps-0.4)*(0.893+qr-1.32 
     1        *qr*qr) 
      phi2=2.5*ps*(1.26+0.053*qr-0.133*qr*qr)-2.5*(ps-0.4)*(0.893+1.925 
     1    *qr-1.8*qr*qr)
      go to 47
   43 if(ps.gt.0.6) go to 46
      em2=0.893+0.546*ps-1.946*ps*ps
      phi2=1.0/(1.12-2.491*ps+4.308*ps*ps)
      go to 47
   46 em2=1.375-1.5*ps+0.125*ps*ps
      phi2=1.0+0.875*ps-1.875*ps*ps 
   47 empc=1.307*(1.0-1.12*ps*ps)*(1.0-0.2*qr)
      if(ps.gt.0.65) empc=2.03*(1.0-ps)*(1.0-0.2*qr)
  240 return
      end 
c----------------------------------------------------------------------- 
      subroutine maxp(irs,srt,emy,emsmq,wi,w0mq,pes,py,pmax)
c----------------------------------------------------------------------- 
      common /abc/  a,b,c,f,em1,em2,empc,phi1,phi2,ddd
c
      srt1 = srt
      if(irs.lt.0.) srt1 = srt*2.
      if(srt1.ge.60.) f2 = 1.
      if(srt1.ge.20.0 .and. srt1.lt.60.) f2 = srt1/40. - 0.5
      if(srt1.lt.20.) f2 = 0.
      f3 = 1.
      if(irs.lt.0) f3 = 0.5
c
      pu = 1.
      pl = 0.
      ps = 0.
      ps1 = 0.006
      n = 0
  10  if(abs(ps1-ps) .gt. 0.001) then
	n = n+1
	if (n.gt.25) then
	   print *,'n greater than 25 in maxp'
	   stop
	endif
	ps1 = ps
	call momphi(irs,ps,0.)
	f1 = ps**0.6
	ff = f1*f2*f3
	emmc = empc - ff*(empc-em1)
	emi = ps*py*wi/emy
	em0p = ps*py*w0mq/emy
	if(irs.lt.0) emi = 0.5 * emi
	if(irs.lt.0) em0p = 0.5 * em0p
	p = (emmc-emsmq-emi-em0p)*emy / ((emmc-emsmq)*emy/pes/py+w0mq)
	ps = p/py
	if(ps1.gt.ps .and. ps1.lt.pu) pu = ps1
	if(ps1.lt.ps .and. ps1.gt.pl) pl = ps1
	ps = (pu+pl)/2.
	go to 10
      endif
      pmax = ps*py
      return
      end
c----------------------------------------------------------------------- 
      subroutine mom(a,b,c,d,f,phi1,phi2,bmpc,phi,bm) 
c----------------------------------------------------------------------- 
      common/bug/ nbug,jp1,jp2,nbug0
c 
      if (phi .le. phi1) then 
        bm = phi*a
      elseif (phi .le. phi2) then 
        bm = b - c / phi ** 0.5 
      else
        bm = bmpc - f/(phi + d)**2
      endif 
      if(nbug.eq.5) print*,'  bm,phi',bm,phi
      return
      end 
c 
c----------------------------------------------------------------------- 
      subroutine order(a1,a2,a3)
c----------------------------------------------------------------------- 
c    put  3  valiables in sequence
c----------------------------------------------------------------------- 
c 
      if(a1.le.a2.and.a1.le.a3) x1=a1 
      if(a2.le.a1.and.a2.le.a3) x1=a2 
      if(a3.le.a1.and.a3.le.a2) x1=a3 
      if(a1.ge.a2.and.a1.ge.a3) x3=a1 
      if(a2.ge.a1.and.a2.ge.a3) x3=a2 
      if(a3.ge.a1.and.a3.ge.a2) x3=a3 
      x2=0.0
      if(a1.gt.x1.and.a1.lt.x3) x2=a1 
      if(a2.gt.x1.and.a2.lt.x3) x2=a2 
      if(a3.gt.x1.and.a3.lt.x3) x2=a3 
      a1=x1 
      a2=x2 
      a3=x3 
      return
      end 
c----------------------------------------------------------------------- 
      subroutine cubic(a,xr,xi) 
c----------------------------------------------------------------------- 
c   this subroutine is used in 'rotcub' 
c----------------------------------------------------------------------- 
c 
      dimension a(4),xr(3),aq(3)
      integer path
      path=2
      ex=1.0/3.0
      if(a(4).ne.0.0) go to 300 
      xr(1)=0.0 
      go to 10
  300 a2=a(1)**2
      q=(27.0*a2*a(4)-9.0*a(1)*a(2)*a(3)+2.0*a(2)**3)/(54.0*a2*a(1))
      if(q) 400,500,600 
  500 z=0.0 
      go to 20
  400 q=-q
      path=1
  600 p=(3.0*a(1)*a(3)-a(2)**2)/(9.0*a2)
      arg=p**3+q**2 
      if(arg) 700,800,900 
  700 z=-2.0*sqrt(-p)*cos(atan(sqrt(-arg)/q)/3.0) 
      go to 30
  800 z=-2.0*q**ex
      go to 30
  900 sarg=sqrt(arg)
      if(p) 1000,1100,1200
 1000 z=-(q+sarg)**ex-(q-sarg)**ex
      go to 30
 1100 z=-(2.0*q)**ex
      go to 30
 1200 z=(sarg-q)**ex-(sarg+q)**ex 
   30 go to (1300,20),path
 1300 z=-z
   20 xr(1)=(3.0*a(1)*z-a(2))/(3.0*a(1))
   10 aq(1)=a(1)
      aq(2)=a(2)+xr(1)*a(1) 
      aq(3)=a(3)+xr(1)*aq(2)
      call quad(aq,xr(2),xr(3),xi)
      return
      end 
c 
c----------------------------------------------------------------------- 
      subroutine  quad(a,xr1,xr2,xi)
c----------------------------------------------------------------------- 
c   this subroutine is used in 'rotcub' 
c----------------------------------------------------------------------- 
c 
      dimension a(3)
      x1=-a(2)/(2.0*a(1)) 
      d=x1**2-a(3)/a(1) 
      if(d.ge.0.0) go to 20 
      x2=sqrt(-d) 
      xr1=x1
      xr2=x1
      xi=x2 
      go to 30
   20 x2=sqrt(d)
      xr1=x1+x2 
      xr2=x1-x2 
      xi=0.0
   30 return
      end 
c 
c----------------------------------------------------------------------- 
      subroutine rotcub(a1,a2,a3,a4,x1,x2,x3) 
c----------------------------------------------------------------------- 
c  get 3-roots solving cubic equation 
c-----------------------------------------------------------------------
c 
      dimension a(4),x(3),xi(3) 
      a(1)=a1 
      a(2)=a2 
      a(3)=a3 
      a(4)=a4 
      if(a(1).eq.0.0) go to 5 
      call cubic(a,x,xi(2)) 
      xi(1)=0.0 
      xi(3)=-xi(2)
      x1=x(1) 
      x2=x(2) 
      x3=x(3) 
      go to 100 
    5 write(6,10)
   10 format ('  a(1) equals to 0.0 in rotcub' )
      stop
  100 return
      end 
c 
c----------------------------------------------------------------------- 
      subroutine locb(phi,p,phibo,bm,jp)
c-----------------------------------------------------------------------
      common/bug/ nbug,jp1,jp2,nbug0
      common/pi/pi
      common/newt/x,in,dx,eps,n,lim 
c 
c---- step 1 => determine height of above n.a. and totel height 
c               of section. first assume n.a. at previous position. 
c 
      if(nbug.eq.3 .or. nbug0.eq.3) then
        if(nbug.ne.0) nbug0 = nbug
        if(jp.lt.jp1.or.jp.gt.jp2) nbug = 0 
        if(jp.ge.jp1.and.jp.le.jp2) nbug = 3
      endif 
      if (nbug.eq.3) print*, 'going through local buckling' 
      phimin = phibo/(1.+ sin (p*pi/2.))
      if(phi.le.phimin) then
        bm = 1. 
        return
      endif 
      dp = 0. 
      iter = 0
      bbod = 0.5 - p / (2*phi)
      bbi = 0.
      btod = phibo/(2.*phi) 
 100  iter = iter + 1 
      if(iter.gt. 20) then
        write(6,300) jp 
        stop 50 
      endif 
      bod = btod + bbod 
      if(bod.gt.1.) then
        if(nbug .eq. 3) write(6,310)
        bod = 0.999 
        bbod = bod - btod 
      endif 
      if(nbug.eq.3) print*,'  btod,bbod,bod ',btod,bbod,bod 
c 
c---- step 2 => determine corrosponding shape, theta and dia. 
c 
      xe = pi - 0.001 
      xb = 0. 
      call  newton (xb,xe,x,in,dx,eps,n,lim,bod,jp) 
      dod = 2.*bod / (1. + cos(x))
      if(nbug.eq.3)print*,'  bod,dod,ang',bod,dod,x 
c 
c---- step 3 => check if section is balanced, if balanced determine 
c               moment capacity 
c 
      call rmom (bbod,dod,x,p,bbi,bm,dp,iter) 
      if(bm.le.-99.) go to 100
      return
 300  format(//20x,'need to iterate more while determining'/
     +       25x,'m for min. sec.'/ 
     +       30x,'i =',i5)
 310  format(//'**** warning bod greater than 1  ****') 
      end 
c-----------------------------------------------------------------------
      subroutine rmom (bbod,dod,x,p,bbi,bm,dp,iter) 
c-----------------------------------------------------------------------
      common/bug/ nbug,jp1,jp2,nbug0
      common/pi/pi
c 
c---- step 1 => determine boundaries
c 
c 
      xcr = x - sin(x) + 0.5 * pi / dod 
      xna = pi - acos(1.- 2.*bbod/dod)
      if(nbug.eq.3)print*, '  xcr,xna   ',xcr,xna 
c 
c---- step 2 => determine forces resisted by each portion.
c               forces non-dimensionalized w.r.t. 'py'
c 
      f1 = (dod/pi) * sin (x) 
      f2 = (dod/pi) * (xna - x) 
      f3 =  dod*(1.- xna/pi)
      if(nbug.eq.3) print*,'  f1,f2,f3,p  ' ,f1,f2,f3,p 
c 
c---- step 3 => iterate if forces not balanced
c 
      dp1 = dp
      dp = f1 + f2 - f3 - p 
      if (abs(dp) .gt. 0.001) then
        bm = -99. 
        if(iter.lt.2) slop = 0. 
        if(iter.ge.2) slop = (dp - dp1)/bbi 
        if(abs(slop).gt.0.00001) bbi = -dp/slop 
        if(abs(slop).le.0.00001) bbi = dp * bbod
        bbod1 = bbod
        bbod = bbod + bbi 
        if(bbod .lt. 0.0001) then 
           bbod = 0.0001
           bbi =  0.0001 - bbod1
        endif 
        if(nbug.eq.3)print*, '  dp,bbi',dp,bbi
        return
      endif 
c 
c---- step 4 => determine moment resisted, non-dimensionalized w.r.t. 
c               'my', moments taken about axis at xcr 
c 
      fmom = (1.-p)/2.
      if(f1 .ge. fmom) then 
        ff = fmom 
        xmom = x
      else
        ff = f1 
        xmom = x + (fmom - f1) * pi /dod
      endif 
      if(nbug.eq.3)print*, '  xmom ',xmom 
      bm1 = 2.*ff*dod* (cos(x) - cos(xcr))
      bm2 = ((2.*dod**2.)/pi)*( (-cos(xcr))*(xmom - x)
     +                          + sin(xmom) - sin(x) )
      bm3 = ((2.*dod**2.)/pi)*( (cos(xcr))*(pi - xna) + sin(xna) )
      bmt = bm1 + bm2 + bm3 
c 
      if(nbug.eq.3)print*, '  bm1,bm2,bm3 ',bm1,bm2,bm3 
      if(nbug.eq.3)print*, '  bmt  ',bmt
c 
      bm = bmt / (sin((1.-p)*(pi/2.))*4./pi)
c 
      if(nbug.eq.3)print*, ' bmt,bm',bmt,bm 
      return
      end 
c----------------------------------------------------------------------- 
      subroutine bklphi(p,phibo,phibp,jp) 
c----------------------------------------------------------------------- 
c 
      common/bug/ nbug,jp1,jp2,nbug0
      common/pi/pi
c 
      if(nbug.eq.2 .or. nbug0.eq.2) then
        if(nbug.ne.0) nbug0 = nbug
        if(jp.lt.jp1.or.jp.gt.jp2) nbug = 0 
        if(jp.ge.jp1.and.jp.le.jp2) nbug = 2
      endif 
      err = 0.01
      sg = 1. 
      dp = 1. 
      n = 0 
      ep0 = p 
      dep0m = phibo - p 
      dep0 = dep0m/5. 
      if(nbug.eq.2) print*, 'p,phibo',p,phibo 
 100  n = n+1 
      if(n.gt.25) then
        write(6,110) jp,dp,dep0 
        return
      endif 
      if(nbug.eq.2) print*,'n = ',n,'    ep0 = ',ep0
      phi = phibo - ep0 
      etb = ep0 - phi 
      if(nbug.eq.2) print*, 'etb = ',etb
c 
      if(abs(ep0) .le. 1.0 .and. etb .le. 1.) then
        if(etb.ge.-1.) then 
          tht1 = asin ( (1.-ep0)/phi )
          if(nbug.eq.2) print*,'tht1',tht1
          pcal = ( (pi+2.*tht1)*ep0 + (pi-2.*tht1) -
     +               2.*phi*cos(tht1)   ) / (2*pi)
c 
        else
          tht1 = asin ( (1.-ep0)/phi )
          tht2 = asin ( (1.+ep0)/phi )
          if(nbug.eq.2) print*,'tht1,tht2',tht1,tht2
          pcal = ( (tht1+tht2)*ep0 + (tht2-tht1) -
     +               phi*(cos(tht1)-cos(tht2))  ) /  pi 
c 
        endif 
      endif 
      if(ep0 .gt. 1.0 .and. etb .le. 1.0) then
        if(etb.ge.-1.) then 
          tht0 = asin ( (ep0 -1.)/phi ) 
          if(nbug.eq.2) print*,'tht0',tht0
          pcal = 1. - phi*( cos(tht0)-(pi/2.-tht0)*sin(tht0) ) / pi 
c 
        else
          tht0 = asin ( (ep0 -1.)/phi ) 
          tht2 = asin ( (1.+ep0)/phi )
          if(nbug.eq.2) print*,'tht0,tht2',tht0,tht2
          pcal = 1. - phi*( cos(tht0)-(pi/2.-tht0)*sin(tht0)
     *                     -cos(tht2)+(pi/2.-tht2)*sin(tht2) ) / pi 
c 
        endif 
      endif 
c 
      dp = p - pcal 
      if(abs(dep0) .le. err) then 
        phibp = phibo - ep0 
        if(nbug.eq.2)print*,'phibp = ',phibp, '  n=',n,'   dp=',dp
        return
      endif 
      if(abs(dep0) .gt. err) then 
        sg0 = sg
        sg = sign(1.,dp)
        ss = sg0*sg 
        if(ss.lt.0.0 .or. etb .ge. 1.) then 
          ep0 = ep0 - dep0
          dep0 = dep0/2.
          if(ss.lt.0.0) sg = -sg
        endif 
        ep0 = ep0 + dep0
        if(nbug.eq.2) print*,'dp,dep0,ep0',dp,dep0,ep0
        if(nbug.eq.2) write(6,120)
        go to 100 
      endif 
 110  format(/20x, 'too many iterations while'/ 
     *         20x, 'calculating buckling curvature'/ 
     *         15x,'jp=',i5,5x,'dp=',e12.4,'dep0=',e12.4/)
 120  format('    ')
      end 
c 
c----------------------------------------------------------------------- 
      subroutine  newton (xb,xe,x,in,dx,eps,n,lim,bod,jp) 
c----------------------------------------------------------------------- 
c 
      if(in .ne. 0)  goto  100
      i1  = 0 
      i2  = 0 
      xbb = xb
      xee = xe
      sb  = sign(1.,fnc(xbb,bod)) 
   10 xdd = (xee-xbb)/float(n)
      x   = xbb 
      sbb = sb
   20 x   = x+xdd 
      s   = sign(1.,fnc(x,bod)) 
      if(s .eq. 0.)  goto  500
      if(s*sbb .lt. 0.)  goto  40 
      if(x .gt. xee)  goto 30 
      sbb = s 
      goto  20
   30 i1 = i1+1 
      if(i1 .ge. 2)  goto  9991 
      n = 2*n 
      goto  10
   40 i2 = i2+1 
      if(i2 .ge. 2)  goto  50 
      xbb = x-xdd 
      xee = x 
      sb  = sbb 
      if(i1 .eq. 0)  goto  45 
      n  = n/2
      i1 = 0
   45 goto  10
   50 x = -.5*xdd+x 
c 
  100 continue
      ii = 0
   60 x0 = x
      f0 = fnc(x0,bod)
      x1 = x0-dx
      x2 = x0+dx
      f1 = fnc(x1,bod)
      f2 = fnc(x2,bod)
      z  = 2.*dx*f0/(f1-f2) 
      x  = x0+z 
      if(abs(z) .le. eps)  goto  500
      if(x .lt. xb .or. x .gt. xe)  goto  9993
      ii = ii+1 
      if(ii .ge. lim)  goto  9992 
      goto  60
c 
  500 continue
      return
c 
 9991 write(6,661) jp 
  661 format(//20x,'????  change of sign is not recognized'/
     &         30x,'n should be larger ?'/
     &         30x,'i=',i5) 
      goto  9999
 9992 write(6,662) jp 
  662 format(//20x,'????  ii > lim  no converg.'/ 
     &         30x,'i=',i5) 
      goto  9999
 9993 write(6,663) jp 
  663 format(//20x,'????  x diverg.'/ 
     &         30x,'i=',i5) 
 9999 stop
      end 
c-----------------------------------------------------------------------
      function fnc (x,bod)
c-----------------------------------------------------------------------
      common/pi/pi
c 
      fnc = (sin(x) + pi - x) / (1. + cos (x)) - pi/(2.*bod)
      return
      end 
c-----------------------------------------------------------------------
      subroutine closed(dot,p,phi2,em3,ei2)
c-----------------------------------------------------------------------
c
      dt = dot/100.
      if(p.lt.0.4) then
	if(dot.lt.72)
     *  em3 = 1./(1./(0.75-0.514*dt) + (15.86 + 12.89*dt)*p
     *      + (103.99 -710.84*dt + 1035.6*dt**2)*p**2 )
	if(dot.ge.72)
     *  em3 = 1./(1./(0.53-0.208*dt) + 25.14*p + 129.04*p**2 )
      endif
      if(p.ge.0.4) then
	ddt = dt
	if(ddt.ge. 0.72) ddt = 0.72
	em3 = (0.617-1.343*ddt + 0.772*ddt**2)*(1.-p)
      endif
c
      if(p.le.0.4) then
	if(dot.lt.72)
     *  phi2 = 1./(-0.292+1.06*dt+0.336*dt**2)
     *       - p/(-0.068-0.061*dt+1.759*dt**2)
	if(dot.ge.72) phi2 = 2.0 -1.25*p - 0.625*dt
      endif
      if(p.gt.0.4) then
	if(dot.lt.72)
     *  phi2 = 1./(-0.644+2.567*dt-0.486*dt**2)
     *       - (p-0.4)/(-2.663+12.025*dt-7.708*dt**2)
	if(dot.ge.72) phi2 = 1.7 -0.5*p - 0.625*dt
      endif
c
      ddt = dt
      pp = p
      if(ddt.gt.0.72) ddt = 0.72
      if(p.gt.0.4) pp = 0.4
      ei2 = - 0.094 - 0.129*pp + 0.367*ddt + 0.77*pp*ddt
      ei2 = -ei2
c
      return
      end
c-----------------------------------------------------------------------
      subroutine unload (yy,xw,xs,iarg)
c-----------------------------------------------------------------------
      common/parm/ irs,nout,nond
      common/sec2/ emy,phibo,phiy,py
      common/load1/ em0s,qs,emsmq,pp,pdelt,np,pmax
      common/rev/ wmr,smr,smt,pr,emr,rl,fwm,epsr(20),phir(20),yr(20)
      common/rev2/nin,irev,ishp
      common/col/al,pes,wyild,syild,srt,nel,qy
      common/def/wi,w0q,w0m,w0mq
      dimension yy(1),xw(1),xs(1)
c
      write (6,200) pr,emr
  200 format (/,10x,'axial load at reversal = ',f8.2,//,10x,
     *               'm/my at reversal = ',f5.3)
c
      if(irs.gt.0) wmr1=wmr
      if(irs.lt.0) wmr1=wmr/2.
      call pelas(p1,wmr1)
c
      pincr = (py+pr)/float(nin)
      do 100 i = 1,nin+1
	p = pr - float(i-1)*pincr
	ps = abs(p/py)
	call momphi(irs,ps,0.)
	call abcf(irs)
c
	emis=p*wi/emy
	em0p=p*w0mq/emy
	if(irs.lt.0) emis=0.5*emis
	if(irs.lt.0) em0p=0.5*em0p
	if(ishp.eq.1) fwu = 1.- (1.-fwm)*(pr-p)/(pr+py)
	if(ishp.eq.2) fwu = 1.
	if(ishp.eq.3) fwu = fwm
	if(irs.gt.0) ss = fwu + 3.9*(1.-fwu)
	if(irs.lt.0) ss = fwu + 1.95*(1.-fwu)
	if(irev.eq.1) call dsymm(emis,em0p,p,wm,p1,ss,wmr1)
	if(irev.eq.2) call symm(emis,em0p,p,wm,p1,ss,wmr1)
	if(irev.eq.3) call prfp(emis,em0p,p,wm,p1,ss,wmr1)
c
	if(irs.lt.0) wm=2.*wm
	call shotgr(wm,p,fwu,sh)
	iarg = iarg + 1
	yy(iarg) = p
	xw(iarg) = wm
	xs(iarg) = sh
  100 continue
      iarg = iarg + 1
      yy(iarg) = yy(iarg-1)
      xw(iarg) = xw(iarg-1)
      xs(iarg) = -smt
      iarg = iarg + 1
      yy(iarg) = 0.
      xw(iarg) = xw(iarg-1)
      xs(iarg) = -smt + syild
      return
      end
c-----------------------------------------------------------------------
      subroutine pelas(p1,wmr1)
c-----------------------------------------------------------------------
      common/parm/ irs,nout,nond
      common/sec2/ emy,phibo,phiy,py
      common/rev/ wmr,smr,smt,pr,emr,rl,fwm,epsr(20),phir(20),yr(20)
      common/rev2/nin,irev,ishp
      common/def/wi,w0q,w0m,w0mq
      common /abc/  a,b,c,f,em1,em2,empc,phi1,phi2,ddd
      common/col/al,pes,wyild,syild,srt,nel,qy
      common/load1/ em0s,qs,emsmq,pp,pdelt,np,pmax
      common /abcr/  ar,br,cr,fr,em1r,em2r,empcr,phi1r,phi2r,dddr
c
      iter = 0
      pu = 0.
      pl = -py
      p1 = 0.
 100  iter = iter+1
      if(iter.ge.25) then
	print*,'iterations exceeded 25 in pelas'
	stop
      endif
      p11 = p1
      ps = abs(p1/py)
      call momphi(irs,ps,0.)
      call abcf(irs)
      amp = (emr+empc*rl)/(empcr*rl)
      emis=p1*wi/emy
      em0p=p1*w0mq/emy
      if(irs.lt.0) emis=0.5*emis
      if(irs.lt.0) em0p=0.5*em0p
      if(ishp.eq.1) fwu = 1.- (1.-fwm)*(pr-p1)/(pr+py)
      if(ishp.eq.2) fwu = 1.
      if(ishp.eq.3) fwu = fwm
      if(irs.gt.0) ss = fwu + 3.9*(1.-fwu)
      if(irs.lt.0) ss = fwu + 1.95*(1.-fwu)
      pe =pes*py*ss
      if(irev.eq.1) w1 = wmr1 - amp*phi1r*emy/pe/rl
      if(irev.eq.2) w1 = wmr1 - (emr/a/rl/rl+ phi1/rl)*emy/pe
      if(irev.eq.3) w1 = wmr1 - (emr+empc*rl)*emy/a/rl/rl/pe
      p1 = a*rl*rl*pe*(1.-wmr1/w1) + (emr-emsmq-emis-em0p)*emy/w1
      if(w1.le.-(w0mq+wi)) pu = p11
      if(w1.gt.-(w0mq+wi) .and. abs(p1).le.py) then
	if(p1.lt.p11.and.p1.gt.pl) pl = p1
	if(p1.lt.p11.and.p1.lt.pl) pu = p11
	if(p1.gt.p11.and.p1.lt.pu) pu = p1
	if(p1.gt.p11.and.p1.gt.pu) pl = p11
      endif
      p1 = (pu+pl)/2.
      if(abs(pu-pl).lt.(0.005*py)) return
      go to 100
      end
c-----------------------------------------------------------------------
      subroutine dsymm(emis,em0p,p,wm,p1,ss,wmr1)
c-----------------------------------------------------------------------
      common/sec2/ emy,phibo,phiy,py
      common/col/al,pes,wyild,syild,srt,nel,qy
      common/load1/ em0s,qs,emsmq,pp,pdelt,np,pmax
      common/rev/ wmr,smr,smt,pr,emr,rl,fwm,epsr(20),phir(20),yr(20)
      common /abc/  a,b,c,f,em1,em2,empc,phi1,phi2,ddd
      common /abcr/  ar,br,cr,fr,em1r,em2r,empcr,phi1r,phi2r,dddr
c
      pe =pes*py*ss
      amp = (emr+empc*rl)/(empcr*rl)
      w1 = wmr1 - amp*phi1r*emy/pe/rl
      if(p.lt.p1) w2 = wmr1 - amp*phi2r*emy/pe/rl
c
      if(p.ge.p1) then
	wm = (wmr1*ar*rl*rl*pe-(emr-emsmq-emis-em0p)*emy)/
     *        (ar*rl*rl*pe-p)
	return
      endif
c****   wm2
c
      aa = amp*br*rl-(emr-emsmq-emis-em0p)
      bb = p/emy
      dd = pe/emy
      cc = -dd*wmr1
      ee = -amp*amp*amp*cr*cr*rl
      a0 = bb*bb*dd
      a1 = bb*bb*cc + 2.*aa*bb*dd
      a2 = 2.*aa*bb*cc + aa*aa*dd
      a3 = aa*aa*cc-ee
      call rotcub(a0,a1,a2,a3,x1,x2,x3) 
      wm21=x1 
      wm22=x2 
      wm23=x3 
      if(abs(wm22-wm23).le.1.0e-5)  then
	wm22=0.0
	wm23=0.0
      endif
      call order(wm21,wm22,wm23)
      if(wm23.le.w1.and.wm23.ge.w2.and.abs(wm23).gt.1.0e-5) wm = wm23
      if(wm22.le.w1.and.wm22.ge.w2.and.abs(wm22).gt.1.0e-5) wm = wm22
      if(wm21.le.w1.and.wm21.ge.w2.and.abs(wm21).gt.1.0e-5) wm = wm21
c****   wm3
c
      aa = emsmq + emis + em0p + amp*empcr*rl - emr
      bb = p/emy
      dd = -pe/emy
      cc = amp*dddr/rl - wmr1*dd
      ee = amp*amp*amp*fr/rl
      a0 = bb*dd*dd
      a1 = aa*dd*dd + 2.*bb*cc*dd
      a2 = 2.*aa*cc*dd+bb*cc*cc
      a3 = aa*cc*cc-ee
      call rotcub(a0,a1,a2,a3,x1,x2,x3) 
      wm31=x1
      wm32=x2
      wm33=x3
      if(abs(wm32-wm33).le.1.0e-5)  then
	wm32=0.0
	wm33=0.0
      endif
      call order(wm31,wm32,wm33)
      if(wm33.le.w2.and.abs(wm33).gt.1.0e-5) wm = wm33
      if(wm32.le.w2.and.abs(wm32).gt.1.0e-5) wm = wm32
      if(wm31.le.w2.and.abs(wm31).gt.1.0e-5) wm = wm31
      return
      end
c-----------------------------------------------------------------------
      subroutine symm(emis,em0p,p,wm,p1,ss,wmr1)
c-----------------------------------------------------------------------
      common/sec2/ emy,phibo,phiy,py
      common/col/al,pes,wyild,syild,srt,nel,qy
      common/load1/ em0s,qs,emsmq,pp,pdelt,np,pmax
      common/rev/ wmr,smr,smt,pr,emr,rl,fwm,epsr(20),phir(20),yr(20)
      common /abc/  a,b,c,f,em1,em2,empc,phi1,phi2,ddd
c
      pe =pes*py*ss
      w1 = wmr1 - (emr/a/rl/rl+ phi1/rl)*emy/pe
      if(p.lt.p1) w2 = wmr1 - (emr/a/rl/rl+ phi2/rl)*emy/pe
c
      if(p.ge.p1) then
	wm = (wmr1*a*rl*rl*pe-(emr-emsmq-emis-em0p)*emy)/(a*rl*rl*pe-p)
	return
      endif
c****   wm2
c
c
      aa = b*rl+emsmq+emis+em0p
      bb = p/emy
      dd = pe/emy
      cc = emr/a/rl/rl-dd*wmr1
      ee = -c*c*rl
      a0 = bb*bb*dd
      a1 = bb*bb*cc + 2.*aa*bb*dd
      a2 = 2.*aa*bb*cc + aa*aa*dd
      a3 = aa*aa*cc-ee
      call rotcub(a0,a1,a2,a3,x1,x2,x3) 
      wm21=x1 
      wm22=x2 
      wm23=x3 
      if(abs(wm22-wm23).le.1.0e-5)  then
	wm22=0.0
	wm23=0.0
      endif
      call order(wm21,wm22,wm23)
      if(wm23.le.w1.and.wm23.ge.w2.and.abs(wm23).gt.1.0e-5) wm = wm23
      if(wm22.le.w1.and.wm22.ge.w2.and.abs(wm22).gt.1.0e-5) wm = wm22
      if(wm21.le.w1.and.wm21.ge.w2.and.abs(wm21).gt.1.0e-5) wm = wm21
c****   wm3
c
      aa = emsmq + emis + em0p + empc*rl
      bb = p/emy
      dd = -pe/emy
      cc = ddd/rl - wmr1*dd  - emr/a/rl/rl
      ee = f/rl
      a0 = bb*dd*dd
      a1 = aa*dd*dd + 2.*bb*cc*dd
      a2 = 2.*aa*cc*dd+bb*cc*cc
      a3 = aa*cc*cc-ee
      call rotcub(a0,a1,a2,a3,x1,x2,x3) 
      wm31=x1
      wm32=x2
      wm33=x3
      if(abs(wm32-wm33).le.1.0e-5)  then
	wm32=0.0
	wm33=0.0
      endif
      call order(wm31,wm32,wm33)
      if(wm33.le.w2.and.abs(wm33).gt.1.0e-5) wm = wm33
      if(wm32.le.w2.and.abs(wm32).gt.1.0e-5) wm = wm32
      if(wm31.le.w2.and.abs(wm31).gt.1.0e-5) wm = wm31
      return
      end
c-----------------------------------------------------------------------
      subroutine prfp(emis,em0p,p,wm,p1,ss,wmr1)
c-----------------------------------------------------------------------
      common/sec2/ emy,phibo,phiy,py
      common/col/al,pes,wyild,syild,srt,nel,qy
      common/load1/ em0s,qs,emsmq,pp,pdelt,np,pmax
      common/rev/ wmr,smr,smt,pr,emr,rl,fwm,epsr(20),phir(20),yr(20)
      common /abc/  a,b,c,f,em1,em2,empc,phi1,phi2,ddd
c
      pe =pes*py*ss
      if(p.ge.p1)
     *  wm = (wmr1*a*rl*rl*pe-(emr-emsmq-emis-em0p)*emy)/(a*rl*rl*pe-p)
      if(p.lt.p1) wm = -(empc*rl+emsmq+emis+em0p)*emy/p
      return
      end
c----------------------------------------------------------------------- 
      subroutine shotgr(wm,p,fshp,sh)
c----------------------------------------------------------------------- 
c  calculation of shortening due to axial force both
c  geometrical and material
c----------------------------------------------------------------------- 
      common/parm/ irs,nout,nond
      common/sec1/ dot,d,t,sigy,e
      common/sec2/ emy,phibo,phiy,py
      common/pi/ pi
      common/col/al,pes,wyild,syild,srt,nel,qy
      common/load1/ em0s,qs,emsmq,pp,pdelt,np,pmax
      common/rev/ wmr,smr,smt,pr,emr,rl,fwm,epsr(20),phir(20),yr(20)
      common/def/wi,w0q,w0m,w0mq
      dimension e0(30)
c
      ns = nel
      ps=abs(p/py)
      pneg=-p
      alpi = al/pi
      phic1 = fshp*(wm-wmr)/(alpi*alpi*phiy)
      if(irs .lt.0) phic1 = phic1 * 2.
      phic2 = (1.-fshp)*(wm-wmr)*38.40/al/al/phiy
c  (1) axial strain shortening, material
c
      dl=0.5*al/float(ns) 
      do 20 i=1,ns+1
	if(p.lt.0) then
        xi=dl*float(i-1)
        if(irs.gt.0) then 
	  phip1 = phic1*sin(pi*xi/al)
	  phip2 = phic2/(1.+((xi-al/2.)/al/0.040)**2.)
	  phi = abs(phip1 + phip2 - phir(i))
	else
	  phip1 = - phic1 * cos(2.*pi*xi/al)
	  phip2 = phic2/(1.+((xi-al/2.)/al/0.040)**2.)
	  phi = abs(phip1 + phip2 -phir(i))
        endif 
c 
c---    computation of e0 knowing phi and p and p-phi-e0 curve equations
	phi=phi*phiy
	call e0strn(e,sigy,d,t,pneg,0.,phi,e0(i),i)
	e0(i) = epsr(i) + pr*sigy/py/e + e0(i)
	else
	e0(i) = epsr(i) + (pr-p)*sigy/py/e
	endif
   20 continue
c 
      shortp=0.5*e0(1)*dl 
      do 30 i=2,ns
   30 shortp=shortp+e0(i)*dl
      shortp=2.0*(shortp+e0(ns+1)*0.5*dl) 
c  (2) geometrical shortening 
c 
      ws=wmr-wm
      alq=al+shortp
      alqq=alq
      do 2 i=1,10
      aln=0.0 
      dl1=0.0 
      dh=alqq/float(ns)*0.5 
      y1=0.0
      do 3 k=1,ns
      xl=float(k)/float(2*ns)
      ys=ws*sin(pi*xl)
      if(irs.lt.0) ys=ws/2.0*(1.0-cos(2.0*pi*xl))
      arg = (xl - 0.5)/0.04
      yfm = ws*(1. - (arg*atan(arg)-0.5*alog(1.+arg*arg))/16.11 )
      y2=yr(k+1) - ys*fshp - yfm*(1.-fshp)
      yd=y2-y1
      sd=sqrt(yd*yd+dh*dh)
      y1=y2 
    3 aln=aln+sd
      aln=2.0*aln 
      dl2=aln-alqq
      ddl=dl1-dl2 
      if(abs(ddl).lt.1.0e-3)  go to 5 
      if(abs(alq-aln).lt.1.0e-4) go to 5
      dl1=dl2 
    2 alqq=alq-dl2
    5 short=-dl2+pi*pi*wi*wi/4.0/al
c 
      sh=-(shortp+short)
      return
      end 
c-----------------------------------------------------------------------
      subroutine out(yy,xw,xs,iarg,nc,ni)
c-----------------------------------------------------------------------
      common/parm/ irs,nout,nond
      dimension yy(1),xw(1),xs(1)
      dimension ni(20)
c
      iarg1 = 0
      i1 = 0
      open(11, file='lodef')
      open(12, file='losh')
      if(nout.eq.1 .or. nout.eq.3) then
      write(6,100)
      write(6,110) i1+1
      endif
      do 50 jj = 1,iarg-1
	yy(jj) = - yy(jj)
	xw(jj) = - xw(jj)
	xs(jj) = - xs(jj)
       if(nout.eq.1 .or. nout.eq.3) then
	write(6,120)jj-iarg1,yy(jj),xw(jj),xs(jj)
	if((jj-iarg1) .eq. ni(i1+1) ) then
	  iarg1 = iarg1 + ni(i1+1)
	  i1 = i1+1
	  if(i1+1 .le. nc) write(6,110) i1+1
	endif
       endif
  50  continue
      if(nout.eq.2 .or. nout.eq.3) then
        zero=0. 
        i1 = 0
        iarg1= 0
        write(11,125) zero,zero
        write(12,125) zero,zero
	do 65 ij = 1,iarg-1
           write(11,125) xw(ij),yy(ij)
           write(12,125) xs(ij),yy(ij)
           if((ij-iarg1).eq.ni(i1+1) .and. (i1+1).lt.nc)then
             write(11,125) zero,zero
             write(12,125) zero,zero
             iarg1 = iarg1+ni(i1+1)
             i1=i1+1
           endif
  65    continue
      endif 
c
      return
  100 format(//,20x,'ax. load',10x,'defl',10x,'short')
  110 format(/,5x,'case = ',i2/)
  120 format(10x,i5,5x,f8.2,9x,f6.2,8x,f6.2)
  125 format(10x,f10.4,10x,f10.4)
      end
c-----------------------------------------------------------------------
c***  end  of the program **********************************************
c-----------------------------------------------------------------------
