C     PROGRAM MPCYCL(INPUT,OUTPUT,PLOT,TAPE5=INPUT,TAPE6=OUTPUT)
      DIMENSION MX(10),MY(10),P(10),RLA(10),FLA(10),TA(17)
      REAL MX,MY
      OPEN (UNIT=5,FILE='MPDATA')
      OPEN (UNIT=6,FILE='MPRESL')
C     CALL PLOTS
C     CALL PLOT(5.0,5.0,-3)
C   NMP=0... NO PLOTTING
C   NMP=1... PLOTTING OF MOMENT-CURVATURE
C   NMP=2... PLOTTING OF AXIAL FORCE - STRAIN
C   NMP=3... PLOTTING OF MOMENT-CURVATURE AND AXIAL FORCE-STRAIN
      READ(5,100)  (TA(I),I=1,17),NMP
      WRITE(6,200) (TA(I),I=1,17),NMP
      IF(NMP.NE.1.AND.NMP.NE.3) GO TO 5
      CALL AXIS(-5.0,0.0,70H
     1      CURVATURE   PHI/PHIY,-70,10.0,0.0,-5.0,1.0,0)
      CALL AXIS(0.0,-5.0,62H
     1      MOMENT  M/MY, 62,10.0,90.0,-1.25,0.25,-1)
      IF(NMP.NE.2.AND.NMP.NE.3) GO TO 10
C     IF(NMP.EQ.3) CALL PLOT(18.0,0.0,-3)
    5 CALL AXIS(-5.0,0.0,70H
     1        AXIAL STRAIN  E/EY,-70,10.0,0.0,-5.0,1.0,0)
      CALL AXIS(0.0,-4.0,62H
     1 AXIAL FORCE  P/PY, 62, 8.0,90.0,-1.0,0.25, -1)
C     IF(NMP.EQ.3) CALL PLOT(-18.0,0.0,-3)
      GO TO 10
   15 WRITE(6,110)
C
   10 CALL INPUT(NOUT,NTH,NM,MX,MY,P,DMX,DMY,DP,QF,NRT,ALPH,RLA,FLA)
      CALL       ELEMNT(    DA,  NTH,RO,YLDM,YLDP,PHY,EY)
      CALL       INTIAL(ALPH,NRT,RLA,FLA,RO,NTH)
      CALL CURVE(NM,MX,MY,P,DMX,DMY,DP,QF,DA,NCAL,NTH)
      CALL       PLTOUT(NOUT,NCAL,YLDM,YLDP,PHY,EY,NMP)
      GO TO 15
  100 FORMAT(17A4,I4)
  110 FORMAT(1H1)
  200 FORMAT(1H ,///,17A4,'   NMP =',I3)
      END
      SUBROUTINE INPUT(NOUT,NTH,NM,MX,MY,P,DMX,DMY,DP,QF,NRT,ALPH,RLA,
     1                 FLA)
C  INPUT FOR M-P-PHI CALCULATION UNDER CYCLIC LOADING
      COMMON /MAT/ E,SY,D,T
      DIMENSION MX(10),MY(10),P(10),RLA(10),FLA(10),TA(18)
      REAL MX,MY
C
C   NOUT=1... SOLID LINE FOR PLOTTING
C   NOUT=2... DOTTED LINE FOR PLOTTING
C   NOUT=3... DASH-DOT LINE FOR PLOTTING
      READ(5,*) SY,E,D,T,NTH,NOUT
      WRITE(6,201) SY,E,D,T,NTH,NOUT
C   INPUT OF APPLIED FORCES
C     QF= SHEAR FORCE
C     NM= NUMBER OF INPUT DATA OF FORCE
      READ(5,*) QF,NM
      WRITE(6,205) QF
      READ(5,*) (MX(I),I=1,NM),DMX
      READ(5,*) (MY(I),I=1,NM),DMY
      READ(5,*) (P(I),I=1,NM),DP
      WRITE(6,202) (MX(I),I=1,NM),DMX
      WRITE(6,203) (MY(I),I=1,NM),DMY
      WRITE(6,204) (P(I),I=1,NM),DP
C   INPUT OF LONGITUDINAL RESIDUAL STRESS
C     ALPH= ANGLE OF THE LOCATION OF WELDING SEAM FROM X-AXIS
C     NRT= NUMBER OF INPUT DATA OF RESIDUAL STRESS
      READ(5,*) ALPH,NRT,(RLA(I),FLA(I),I=1,NRT)
      WRITE(6,220) ALPH,(RLA(I),I=1,NRT)
      WRITE(6,221) (FLA(I),I=1,NRT)
C
      RETURN
  201 FORMAT(//,5X,'SY=',F10.2,5X,'E=',F10.2,5X,'D=',F6.3,5X,'T=',F6.4,
     1     5X,'NTH=',I3,10X,'NOUT=',I3)
  202 FORMAT(  5X,'MX(I)=',8E12.3)
  203 FORMAT(5X,'MY(I)=',8E12.3)
  204 FORMAT(5X,'P(I) =',8E12.3)
  205 FORMAT(/,5X,'QF   =',E12.3)
  220 FORMAT(//,5X,'ALPH=',F5.2,/,5X,'RLA(I)=',10E12.3)
  221 FORMAT(5X,'FLA(I)=',10E12.3)
C 999 CALL PLOT(0.0,0.0,999)
      STOP
      END
      SUBROUTINE ELEMNT(    DA,  NTH,RO,YLDM,YLDP,PHY,EY)
C  GENERATE DATA FOR EACH ELEMENT
      COMMON /COORD/ X0(150),Y0(150)
      COMMON /MAT/ E,SY,D,T
      PAI=4.0*ATAN(1.0)
      RO=D/2.0
      RT=RO-T
C   SECTION PROPERTIES
      AREA=PAI*(RO*RO-RT*RT)
      DA=AREA/FLOAT(NTH)
      BI=PAI*(RO**4-RT**4)/4.0
      S=BI/RO
      RGI=SQRT(BI/AREA)
      Z=(D**3-(D-2.0*T)**3)/6.0
      SHAPE=Z/S
      YLDM=SY*S
      PLTM=SY*Z
      YLDP=SY*AREA
      PHY= YLDM/E/BI
      EY=SY/E
      WRITE(6,240)
      WRITE(6,940) AREA,BI,S,Z,SHAPE,RGI,DA
      WRITE(6,941) YLDM,PLTM,YLDP,PHY,EY
C   COORDINATES OF CENTROID OF EACH ELEMENT
      DTHTA5=2.0*PAI/FLOAT(NTH)/2.0
      EPSY=2.0*SIN(DTHTA5)/3.0
      EPS=EPSY*(RO**3-RT**3)/DA
      DO 20 I=1,NTH
      THTA=2.0*DTHTA5*FLOAT(I-1)+DTHTA5
      X0(I)=EPS*COS(THTA)
   20 Y0(I)=EPS*SIN(THTA)
      WRITE(6,110)
      WRITE(6,900) (X0(I),Y0(I),I=1,NTH)
      RETURN
  110 FORMAT(///, 1X,'COORDINATES',/,2X,5(5X,'X0',11X,'Y0',6X))
  240 FORMAT(/////, 1X,'DATA OF MEMBER')
  940 FORMAT(//,4X,'AREA=',E12.5,'  I=',E12.5,'  S=',E12.5,'  Z=',E12.5,
     1     '  SHAPE FUNCTION=',E11.4,'  RGI=',E12.5,'  DA=',E12.5)
  941 FORMAT(4X,'M(YIELD)=',E13.5,'  M(PLASTIC)=',E13.5,'  P(YIELD)=',
     1     E13.5,'  PHI(YIELD)=',E13.5,'  EY=',E13.5)
  900 FORMAT(   15(10(2X,E11.4),/))
      END
      SUBROUTINE INTIAL(ALPH,NRT,RLA,FLA,RO,NTH)
C  CALCULATION OF LONGITUDINAL RESIDUAL STRESS IN EACH ELEMENT
      COMMON /RESIST/ RSTA(150),ES(150)
      DIMENSION RLA(10),FLA(10),RLB(10),A(150)
      PAI=4.0*ATAN(1.0)
      DTH=2.0*PAI/FLOAT(NTH)
      AT=0.0
      DO 50 K=1,NRT
   50 RLB(K)=RLA(K)*RO
      DO 55 I=1,NTH/2
      SL=DTH*(FLOAT(I)-0.5)*RO
      DO 60 J=1,NRT
      IF(RLB(J).LE.SL.AND.RLB(J+1).GT.SL) GO TO 65
   60 CONTINUE
   65 RAT=(SL-RLB(J))/(RLB(J+1)-RLB(J))
      RSTA(I)=FLA(J)+(FLA(J+1)-FLA(J))*RAT
      RSTA(NTH-I+1)=RSTA(I)
      AT=AT+RSTA(I)
   55 CONTINUE
C  ADJUSTMENT IN ORDER TO KEEP EQUILIBLIUM AT A SECTION
C   A(I)= RESIDUAL STRESSES ACCORDINT TO INPUT
C   RSTA(I)= RESIDUAL STRESSES AFTER ADJUSTING FOR EQUILIBRIUM
      AVE=AT/FLOAT(NTH/2)
      ALPH=PAI*ALPH/180.
      NALPH=IFIX(ALPH+0.001)/DTH
      IF(NALPH.GT.1) GO TO 75
      DO 85 I=1,NTH
   85 A(I)=RSTA(I)
      GO TO 80
C  ROTATE WELD SEAM
   75 DO 70 I=1,NTH-NALPH
   70 A(NALPH+I)=RSTA(I)
      DO 71 I=NTH-NALPH+1,NTH
   71 A(I-NTH+NALPH)=RSTA(I)
   80 DO 72 I=1,NTH
   72 RSTA(I)=A(I)-AVE
C
      WRITE(6,900)  (RSTA(I),I=1,NTH)
      WRITE(6,901) (A(I),I=1,NTH)
C     WRITE(6,500)
C   INITIAL VALUES OF STRAIN FOR EACH ELEMENT
      DO 100 I=1,NTH
  100 ES(I)=0.0
      RETURN
  500 FORMAT(1H1)
  900 FORMAT( /, 1X,'RESIDUAL STRESS',/,'  RSTA(I)',15(/,10(3X,F10.4)))
  901 FORMAT( /,'  A(I)   ',15(/,10(3X,F10.4)))
      END
      SUBROUTINE CURVE(NM,MX,MY,P,DMX,DMY,DP,QF,DA,NCAL,NTH)
C  ASSIGN LOADS
      COMMON /COORD/ X0(150),Y0(150)
      COMMON /OUT/ BMX(400),BMY(400),PP(400),PHIX(400),PHIY(400),E0(400)
     1             ,NT(400)
      COMMON /SPACE/ S0(150),ES0(150)
      COMMON /RESIST/ RSTA(150),ES(150)
      DIMENSION MX(10),MY(10),P(10),XA(3),FA(3),FB(3),DFA(3),DF(3)
     1         ,FAO(3),XAO(3)
      REAL MX,MY
C   FA= PREVIOUS LOADING STATE
C   FB= CURRENT LOADING STATE
C   NCAL= NUMBER OF RESULTS CALCULATED
C   IFAC= INDICATOR WHETHER STIFFNESS MATRIX IS SINGULAR (=1)
C   XA= PREVIOUS DEFORMATION STATE
C   DF= INITIAL LOAD INCREMENTS
      FB(1)=MX(1)
      FB(2)=MY(1)
      FB(3)=P(1)
      NCAL=0
      DO 5 IH=1,3
      XA(IH)=0.0
    5 FA(IH)=0.0
C
      DO 10 I=1,NM-1
      NO=ABS((MX(I+1)-MX(I))/DMX)
      NO2=ABS((MY(I+1)-MY(I))/DMY)
      IF(NO2.GT.NO) NO=NO2
      NO3=ABS((P(I+1)-P(I))/DP)
      IF(NO3.GT.NO) NO=NO3
      DM1=(MX(I+1)-MX(I))/FLOAT(NO)
      DM2=(MY(I+1)-MY(I))/FLOAT(NO)
      D3=(P(I+1)-P(I))/FLOAT(NO)
      IF(MX(I+1).GE.MX(I)) DM1= ABS(DM1)
      IF(MX(I+1).LT.MX(I)) DM1=-ABS(DM1)
      IF(MY(I+1).GE.MY(I)) DM2= ABS(DM2)
      IF(MY(I+1).LT.MY(I)) DM2=-ABS(DM2)
      IF(P(I+1).GE.P(I)) D3= ABS(D3)
      IF(P(I+1).LT.P(I)) D3=-ABS(D3)
      DF(1)=DMX
      DF(2)=DMY
      DF(3)=DP
      IFAC=0
C
      DO 20 J=1,NO
      IF(IFAC.GT.0) GO TO 20
      NCAL=NCAL+1
      FB(1)=FB(1)+DM1
      FB(2)=FB(2)+DM2
      FB(3)=FB(3)+D3
      DO 1 L=1,3
    1 DFA(L)=FB(L)-FA(L)
C
      CALL CONVRG(FB,XA,DFA,IFAC,NTIME,FA,DF,DA,QF,NTH,FAO,XAO)
      IF(IFAC.GT.0) GO TO 4
C
      BMX(NCAL)=FA(1)
      BMY(NCAL)=FA(2)
      PP(NCAL)=FA(3)
      PHIX(NCAL)=XA(1)
      PHIY(NCAL)=XA(2)
      E0(NCAL)=XA(3)
      NT(NCAL)=NTIME
      DO 3 L=1,NTH
      ES(L)=ES0(L)
    3 RSTA(L)=S0(L)
      GO TO 20
C   ADJUSTMENT FOR THE CASE WHEN IFAC=1
    4 DO 7 L=1,3
      XA(L)=XAO(L)
    7 FA(L)=FAO(L)
      NCAL=NCAL-1
   20 CONTINUE
   10 CONTINUE
      RETURN
      END
      SUBROUTINE CONVRG(FB,XA,DFA,IFAC,N,    FA,DF,DA,QF,NTH,FAO,XAO)
C  JUDGE CONVERGENCE AND ADJUST LOAD INCREMENT WHEN IT'S TOO LARGE
      DIMENSION XA(3),FA(3),FB(3),DFA(3),DF(3),FAO(3),FBO(3),XAO(3)
     1    ,QG(3,3),DXA(3),QI(3,3)
      DO 3 I=1,3
      XAO(I)=XA(I)
      FAO(I)=FA(I)
    3 FBO(I)=FB(I)
      ICON=0
      ERR=1.0
    5 N=0
C
   10 CALL STIFF(QG,XA,DA,NTH,QF)
      CALL INVERS(QI,QG,IFAC)
      IF(IFAC.GT.0) GO TO 102
C
      CALL MULT1(QI,DFA,3,DXA)
C
      DO 1 K=1,3
    1 XA(K)=XA(K)+DXA(K)
      CALL STRESS(FA,XA,DA,NTH,QF)
      ERRF=0.0
      DO 2 K=1,3
      DFA(K)=FB(K)-FA(K)
    2 IF(ABS(DFA(K)).GT.ABS(ERRF)) ERRF=DFA(K)
      N=N+1
      IF(N.GT.15) GO TO 101
      IF(ABS(ERRF).GT.ERR) GO TO 10
C
C  IF ICON IS GREATER THAN 0, STIFFNESS MATRIX HAS BECOME SINGULAR
C      (ICON TIMES)
      GO TO 200
  101 WRITE(6,501)
C  REDUCE LOAD INCREMENT TO ACCOMPLISH CONVERGENCE
C
  102 ICON=ICON+1
      IF(ICON.GT.3) GO TO 180
      DO 105 I=1,3
      XA(I)=XAO(I)
      FA(I)=FAO(I)
  105 FB(I)=FBO(I)-DF(I)+DF(I)/(FLOAT(ICON)*FLOAT(ICON)+1.0)
      GO TO 5
  180 IFAC=1
C  WHEN IFAC=1, STIFFNESS MATRIX IS SINGULAR
  200 RETURN
  501 FORMAT(1H ,5X,'***  TOO MANY ITERATION TIMES')
      END
      SUBROUTINE STIFF(QG,XA,DA,NTH,QF)
C  GENERATE STIFFNESS MATRIX
      COMMON /COORD/ X0(150),Y0(150)
      COMMON /MAT/ E,SY,D,T
      COMMON /SPACE/ S0(150),ES0(150)
      COMMON /RESIST/ RSTA(150),ES(150)
      DIMENSION Q(3,3),QG(3,3),XA(3)
C   EA=STRAIN
C   TAU= SHEAR STRESS
C   SU= YIELD STRESS BY TRESCA CRITERION
C   EY1= UPPER LIMIT OF ELASTIC STRAIN
C   EY2= LOWER LIMIT OF ELASTIC STRAIN
C   Q = ELEMENT OF STIFFNESS MATRIX FOR A SEGMENT
C   QG= ELEMENT OF GLOBAL STIFFNESS MATRIX
C
      PAI=4.0*ATAN(1.0)
      R=(D-T)/2.0
      DO 10 K=1,3
      DO 10 L=1,3
   10 QG(K,L)=0.0
      DO 20 I=1,NTH
      X=X0(I)
      Y=Y0(I)
      EA=Y*XA(1)-X*XA(2)+XA(3)
      TAU=QF/(PAI*R*T)*(1.0-(Y/R)**2)
      SU=SQRT(SY*SY-4.0*TAU*TAU)
C
      EY1=ES(I)+(SU-RSTA(I))/E
      EY2=ES(I)+(-SU-RSTA(I))/E
      IF(EA.GT.EY2.AND.EA.LT.EY1) EFF=E
      IF(EA.GT.EY1. OR.EA.LT.EY2) EFF=0.0
      ES0(I)=EA
      Q(1,1)=EFF*Y*Y*DA
      Q(2,2)=EFF*X*X*DA
      Q(3,3)=EFF*DA
      Q(1,2)=-EFF*X*Y*DA
      Q(2,1)=Q(1,2)
      Q(1,3)=EFF*Y*DA
      Q(3,1)=Q(1,3)
      Q(2,3)=-EFF*X*DA
      Q(3,2)=Q(2,3)
      DO 1 K=1,3
      DO 1 L=1,3
    1 QG(K,L)=QG(K,L)+Q(K,L)
   20 CONTINUE
      RETURN
      END
      SUBROUTINE STRESS(FA,XA,DA,NTH,QF)
C INTEGRATE STRESS OF A ELEMENT IN ORDER TO OBTAIN SECTION FORCES
      COMMON /MAT/ E,SY,D,T
      COMMON /COORD/ X0(150),Y0(150)
      COMMON /RESIST/ RSTA(150),ES(150)
      COMMON /SPACE/ S0(150),ES0(150)
      DIMENSION FA(3),XA(3)
C   ES0= CURRENT STATE OF STRAIN
C   S0 = CURRENT STATE OF STRESS
      PAI=4.0*ATAN(1.0)
      R=(D-T)/2.0
      DO 1 K=1,3
    1 FA(K)=0.0
      DO 10 I=1,NTH
      X=X0(I)
      Y=Y0(I)
      EA=Y*XA(1)-X*XA(2)+XA(3)
      TAU=QF/(PAI*R*T)*(1.0-(Y/R)**2)
      SU=SQRT(SY*SY-4.0*TAU*TAU)
      ES0(I)=EA
      EY1=ES(I)+(SU-RSTA(I))/E
      EY2=ES(I)+(-SU-RSTA(I))/E
      IF(EA.GT.EY2.AND.EA.LT.EY1) S0(I)=RSTA(I)+E*(EA-ES(I))
      IF(EA.GE.EY1) S0(I)=SU
      IF(EA.LE.EY2) S0(I)=-SU
      FA(1)=FA(1)+S0(I)*Y*DA
      FA(2)=FA(2)-S0(I)*X*DA
   10 FA(3)=FA(3)+S0(I)*DA
      RETURN
      END
      SUBROUTINE INVERS(AI,A,IFAC)
C          GET INVERSE MATRIX AI FROM A
C          IFAC=1.... STIFFNESS MATRIX IS SINGULAR
      DIMENSION  AI(3,3),A(3,3)
C      *** DETERMINANT  A
      ADET1=A(1,1)*A(2,2)*A(3,3)+A(1,2)*A(2,3)*A(3,1)+A(2,1)*A(3,2)
     1       *A(1,3)
      ADET2=A(1,3)*A(2,2)*A(3,1)+A(1,2)*A(2,1)*A(3,3)+A(2,3)*A(3,2)
     1      *A(1,1)
      ADET=ADET1-ADET2
      IFAC=0
      IF(ABS(ADET).GT.1.0E-10) GO TO 50
       IF(ADET.GE.0.0) ADET=1.0E-10
       IF(ADET.LT.0.0) ADET=-1.0E-10
C     WRITE(6,500)
      IFAC=1
   50 AI(1,1)=A(2,2)*A(3,3)-A(2,3)*A(3,2)
      AI(1,2)=A(2,1)*A(3,3)-A(2,3)*A(3,1)
      AI(1,2)=-AI(1,2)
      AI(1,3)=A(2,1)*A(3,2)-A(2,2)*A(3,1)
      AI(2,1)=A(1,2)*A(3,3)-A(1,3)*A(3,2)
      AI(2,1)=-AI(2,1)
      AI(2,2)=A(1,1)*A(3,3)-A(1,3)*A(3,1)
      AI(2,3)=A(1,1)*A(3,2)-A(1,2)*A(3,1)
      AI(2,3)=-AI(2,3)
      AI(3,1)=A(1,2)*A(2,3)-A(1,3)*A(2,2)
      AI(3,2)=A(1,1)*A(2,3)-A(1,3)*A(2,1)
      AI(3,2)=-AI(3,2)
      AI(3,3)=A(1,1)*A(2,2)-A(1,2)*A(2,1)
      DO 10 I=1,3
      DO 10 J=1,3
   10 AI(I,J)=AI(I,J)/ADET
      RETURN
  500 FORMAT(1H ,'**** STIFFNESS MATRIX IS SINGULAR')
      END
      SUBROUTINE  MULT1(A,B,M,C)
C      *** C(M)=A(M*M)*B(M)
      DIMENSION  A(M,M),B(M),C(M)
      DO 1 I=1,M
      C(I)=0.0
      DO 1 J=1,M
      C(I)=C(I)+A(I,J)*B(J)
    1 CONTINUE
      RETURN
      END
      SUBROUTINE PLTOUT(NOUT,NCAL,YLDM,YLDP,PHY,EY,NMP)
C  PRINT AND PLOT THE RESULTS
      COMMON /OUT/ BMX(400),BMY(400),PP(400),PHIX(400),PHIY(400),E0(400)
     1             ,NT(400)
      DIMENSION XX(400),YY(400),DSH(2),GAP(2)
      IF(NOUT.EQ.0) GO TO 50
      DSH(1)=0.4
      DSH(2)=0.05
      GAP(1)=0.08
      GAP(2)=0.08
      IF(NMP.NE.1.AND.NMP.NE.3) GO TO 40
      DO 10 I=1,NCAL
      XX(I)=PHIX(I)/PHY
   10 YY(I)=BMX(I)/YLDM
      NC=0
      DO 25 I=1,NCAL
   25 IF(ABS(XX(I)).GT.12.0) NC=NC+1
      NCAL=NCAL-NC
      XX(NCAL+1)=0.0
      XX(NCAL+2)=1.0
      YY(NCAL+1)=0.0
      YY(NCAL+2)=0.25
      IF(NOUT.EQ.1)              CALL DSHLINE(XX,YY,NCAL,0.0,0.0,0)
      IF(NOUT.EQ.2)              CALL DSHLINE(XX,YY,NCAL,0.24,0.08,1)
      IF(NOUT.EQ.3)              CALL DSHLINE(XX,YY,NCAL,DSH,GAP,2)
   40 IF(NMP.NE.2.AND.NMP.NE.3) GO TO 50
C     IF(NMP.EQ.3) CALL PLOT(18.0,0.0,-3)
      DO 20 I=1,NCAL
      XX(I)=E0(I)/EY
   20 YY(I)=PP(I)/YLDP
C   NC= CONTROLLER TO CUT OFF TOO LARGE VALUES IN X-DIRECTION
      NC=0
      DO 26 I=1,NCAL
   26 IF(ABS(XX(I)).GT.12.0) NC=NC+1
      NCAL=NCAL-NC
      XX(NCAL+1)=0.0
      XX(NCAL+2)=1.0
      YY(NCAL+1)=0.0
      YY(NCAL+2)=0.25
      IF(NOUT.EQ.1)              CALL DSHLINE(XX,YY,NCAL,0.0,0.0,0)
      IF(NOUT.EQ.2)              CALL DSHLINE(XX,YY,NCAL,0.24,0.08,1)
      IF(NOUT.EQ.3)              CALL DSHLINE(XX,YY,NCAL,DSH,GAP,2)
C     IF(NMP.EQ.3) CALL PLOT(-18.0,0.0,-3)
   50 WRITE(6,100)
      DO 15 I=1,NCAL
   15 WRITE(6,110) I,BMX(I),BMY(I),PP(I),PHIX(I),PHIY(I),E0(I),NT(I)
      RETURN
  100 FORMAT(//,19X,'MX',11X,'MY',13X,'P',15X,'PHIX',11X,'PHIY',11X,'E0'
     1     ,13X,'ITERATION',/)
  110 FORMAT(6X,I3,4X,3(E12.5,2X),3X,3(E12.5,2X),11X,I3)
      END
