C   MAIN PROGRAM FOR ULTIMATE STRENGTH OF TUBULAR COLUMN                00000000
C   PROGRAMED BY SHOUJI TOMA OF PURDUE UNIVERSITY, AUG. 1978            00000000
C                                                                       00000000
C    SUBROUTINE                                                         00000000
C     NEWMAK... BUCKLING CALCULATION BY NEWMARK METHOD                  00000000
C     NEWMOD... POST-BUCKLING STRENGTH ANALYSIS BY MODIFIED NEWMARK     00000000
C     MCRELA....  MOMENT-CURVATURE RELATIONSHIP                         00000000
      OPEN(UNIT=5,FILE='NEWDATA')
      
      OPEN(UNIT=6,FILE='NEWRESL')
      
   50 READ(5,111,END=310) IND                                           00000000
      IF(IND.EQ.1)  GO TO 300                                           00000000
      IF(IND.EQ.2)  WRITE(6,500)                                        00000100
      IF(IND.EQ.3)  WRITE(6,510)                                        00000100
      IF(IND.GT.0) GO TO 100                                            00000100
      IF(IND.EQ.-2) WRITE(6,520)                                        00000100
      IF(IND.EQ.-3) WRITE(6,530)                                        00000100
C                                                                       00000100
      CALL NEWMOD(IND)                                                  00000100
C                                                                       00000100
      GO TO 50                                                          00000100
C                                                                       00000100
  100 CALL NEWMAK(IND)                                                  00000200
C                                                                       00000200
      GO TO 50                                                          00000200
C                                                                       00000200
  300 CALL   MCRELA                                                     00000200
C                                                                       00000200
  310 STOP                                                              00000200
  111 FORMAT(2I2)                                                       00000200
  500 FORMAT(1H1,//,5X,'IND= 2, (SYMMETRY)',//)                         00000200
  510 FORMAT(1H1,//,5X,'IND= 3, (ASYMMETRY)',//)                        00000200
  520 FORMAT(1H1,//,5X,'IND=-2 (POST-BUCKLING ANALYSIS, SYMMETRY)',//)  00000300
  530 FORMAT(1H1,//,5X,'IND=-3 (POST-BUCKLING ANALYSIS, ASYMMETRY)',//) 00000300
      END                                                               00000300
      SUBROUTINE  NEWMOD(IND)                                           00000300
C  POST-BUCKLING ANALYSIS BY MODIFIED NEWMARK'S METHOD                  00000300
C  ASSUMING THE DEFLECTED SHAPE TO BE A SINE CURVE                      00000300
C  APPLICABLE ONLY TO SYMMETRIC LOADING                                 00000300
      COMMON /MAT/        YONG,NCTRL,ENU,NTH,NLA                        00000300
      COMMON  /PMT/ PLTM,YLDP                                           00000300
      DIMENSION  XA(3),     FB(3),NUM(3),FS(3),DF(3),NF(3),FA(3),       00000300
     1      QG(3,3),DFA(3),RI(10), BMT(150),SQR( 75,6)                  00000400
     2    ,XO( 75,6),YO( 75,6),DA(8),SAR( 75,6),STR( 75,6)              00000400
     3     ,RSTC(10),RSTA(150),ALPHI(10),SARL(8,75,4),STRL(8,75,4)      00000400
      DIMENSION  WL(2,11),BM(2,11),XL(11),YA(2,11),YB(2,11),PHI(3,11),  00000400
     1     SLOPE(3,11),ALPH(3,11),DY(2),FSS(3),NS(3),ATOT(3),AROW(2)    00000400
     2    ,SYILDI(10),SA(75,6),SC(75,6)                                 00000400
C                                                                       00000400
      CALL       INPUT2(AL,PL,NEL,SPRG1,SPRG2,ISHORT,WL,AROW,ALPHI,     00000400
     1                  SYILDI,IND)                                     00000400
C                                                                       00000400
C          INPUT FOR SHORT COLUMN ANALYSIS                              00000500
      CALL  INPUT(DIA,T, NCTL2,  FS,DF,NF,ALPI,Q,WI,BETA,SYILD)         00000500
C          MAKE DATA FOR EACH ELEMENT                                   00000500
      CALL  ELMENT(T,DIA,RI,Q,WI,BETA,NCTL2,BMT,XO,YO,DA,SYILD)         00000500
C                                                                       00000500
C          COMPUTE RESIDUAL STRESSES AND PRESSURE STRESS FOR EACH CAN   00000500
C            I....STATION NUMBER                                        00000500
C            J....ELEMENT NUMBER IN CIRCUMFERENTIAL DIRECTION           00000500
C            K....ELEMENT NUMBER IN RADIAL DIRECTION                    00000500
      DO 60 I=1,NEL+1                                                   00000500
      ALPI=ALPHI(I)                                                     00000600
C                                                                       00000600
      CALL  INTIAL(NCTL2,RI,ALPI,RSTC,RSTA,RBM)                         00000600
      SYILD=SYILDI(I)                                                   00000600
C                                                                       00000600
      CALL  PRESS(SQR,SAR,STR,RI,BMT,NCTL2,RSTC,RSTA,RBM,SYILD)         00000600
C                                                                       00000600
      DO 61 J=1,NTH                                                     00000600
      DO 61 K=1,NLA                                                     00000600
      SARL(I,J,K)=SAR(J,K)                                              00000600
   61 STRL(I,J,K)=STR(J,K)                                              00000700
   60 CONTINUE                                                          00000700
C                                                                       00000700
C          COMPUTATION OF ULTIMATE BUCKLING LOAD                        00000700
C            PCR....ULTIMATE AXIAL LOAD                                 00000700
C            SI.....MOMENT OF INERTIA                                   00000700
      PAI=4.0*ATAN(1.0)                                                 00000700
      SI=PAI*(DIA**4-(DIA-2.0*T)**4)/64.0                               00000700
      PCR=PAI*PAI*YONG*SI/PL/PL                                         00000700
      WRITE(6,550)  PCR                                                 00000700
      DL=AL/FLOAT(NEL)                                                  00000800
      NFP=NF(3)                                                         00000800
C                                                                       00000800
C   END-RESTRAINT                                                       00000800
C          Z0.......FULLY RESTRAINT FACTOR, MOMENT/RADIAN               00000800
C          Z1,Z2....RESTRAINT FACTOR,       MOMENT/RADIAN               00000800
C          RSTMT....CONSTRAINT MOMENT AT ENDS                           00000800
      Z0=2.0*YONG*SI/PL                                                 00000800
      Z1=Z0*SPRG1                                                       00000800
      Z2=Z0*SPRG2                                                       00000800
      RSTMT1=0.0                                                        00000900
      RSTMT2=0.0                                                        00000900
      WRITE(6,580) Z0,Z1,Z2                                             00000900
      WRITE(6,599)                                                      00000900
      SLOPI1=(WL(1,2)-WL(1,1))/DL                                       00000900
      SLOPI2=(WL(2,2)-WL(2,1))/DL                                       00000900
C                                                                       00000900
C ***  REPEAT  FOR  P                                                   00000900
      DO 100 I=1,NFP                                                    00000900
C          DETERMINATION OF INITIAL CURVE SHAPE FOR NEWMARK'S METHOD    00000900
C            W1,W2....MAXIMUM OFFSET OF CURVE EXCLUDING IMPERFECTION    00001000
C        BUT INCLUDING AMPLIFICATION DUE TO ELASTIC DEFORMATION         00001000
C       AROW....ARROW OF DEFLECTION CURVE (NOT INCLUDE IMPERFECTION)    00001000
      P=FS(3)+DF(3)*FLOAT(I-1)                                          00001000
      WRITE(6,560)  P                                                   00001000
      IF(ABS(AROW(1)).GT.1.0E-5.OR.ABS(AROW(2)).GT.1.0E-5) GO TO 39     00001000
      PW=-P                                                             00001000
      IF(PW.GT.0.95*PCR) PW=0.95*PCR                                    00001000
      WX=WL(1,NEL/2+1)                                                  00001000
      WY=WL(2,NEL/2+1)                                                  00001000
      IF(ABS(WX).LT.1.0E-10) WX=WL(1,NEL/2+2)                           00001100
      IF(ABS(WY).LT.1.0E-10) WY=WL(2,NEL/2+2)                           00001100
      IF(IND.NE.2) GO TO 23                                             00001100
      WX=WL(1,NEL+1)                                                    00001100
      WY=WL(2,NEL+1)                                                    00001100
      IF(ABS(WX).LT.1.0E-10) WX=WL(1,NEL)                               00001100
      IF(ABS(WY).LT.1.0E-10) WY=WL(2,NEL)                               00001100
   23 W1=WX/(1.0-PW/PCR)                                                00001100
      W2=WY/(1.0-PW/PCR)                                                00001100
      IF(ABS(W1).LT.1.0E-10.AND.ABS(W2).LT.1.0E-10) W2=0.05*PL          00001100
      AROW(1)=(W1-WX)*2.0                                               00001200
      AROW(2)=(W2-WY)*2.0                                               00001200
C                                                                       00001200
   39 N=0                                                               00001200
C  ***1) ASSUME  INITIAL  DEFLECTION                                    00001200
C           J.....STATION NUMBER                                        00001200
C           IX....=1 X-DIRECTION,  =2 Y-DIRECTION                       00001200
C           XL....X-COORDINATES OF STRAIN                               00001200
C           YA....CURVE SHAPE EXCLUDING IMPERFECTION                    00001200
C    ITERATING PROCESS STARTS                                           00001200
   90 N=N+1                                                             00001300
      IF(N.LE.25) GO TO 80                                              00001300
      WRITE(6,900)                                                      00001300
      GO TO 100                                                         00001300
   80 DO 40 J=1,NEL+1                                                   00001300
      XL(J)=AL*FLOAT(J-1)/FLOAT(NEL)                                    00001300
      DO 40 IX=1,2                                                      00001300
      YA(IX,J)=AROW(IX)*SIN(PAI*XL(J)/AL)                               00001300
   40 IF(IND.EQ.-2)YA(IX,J)=AROW(IX)*SIN(PAI*XL(J)/2.0/AL)              00001300
      IF(N.EQ.1) WRITE(6,502) (XL(J),J=1,NEL+1)                         00001300
      WRITE(6,561) (YA(1,J),J=1,NEL+1)                                  00001400
      WRITE(6,562) (YA(2,J),J=1,NEL+1)                                  00001400
C *** SHORTENING OF COLUMN                                              00001400
C  AXIAL DEFORMATION AND GEOMETRICAL CHANGE                             00001400
      IF(N.EQ.1) GO TO 44                                               00001400
      SLOPE(3,1)=0.0                                                    00001400
      DO 145 J=2,NEL+1                                                  00001400
      DL2=(YA(1,J-1)-YA(1,J))**2+(YA(2,J-1)-YA(2,J))**2                 00001400
      DELTA=DL-SQRT(DL*DL-DL2)                                          00001400
  145 SLOPE(3,J)=SLOPE(3,J-1)+( PHI(3,J-1)+ PHI(3,J))/2.0*DL-DELTA      00001400
C   TAKING ACCOUNT OF INITIAL IMPERFECTION INTO SHORTENING              00001500
      IF(ISHORT.NE.1) GO TO 149                                         00001500
      CDEL=0.0                                                          00001500
      DO 147J=2,NEL+1                                                   00001500
      DL2=(WL(1,J-1)-WL(1,J))**2+(WL(2,J-1)-WL(2,J))**2                 00001500
      DELTA=DL-SQRT(DL*DL-DL2)                                          00001500
      CDEL=CDEL+DELTA                                                   00001500
  147 SLOPE(3,J)=SLOPE(3,J)-CDEL                                        00001500
  149 WRITE(6,573) (SLOPE(3,J),J=1,NEL+1)                               00001500
C                                                                       00001500
C  SET THE END-CURVATURES                                               00001600
   44 NE=NEL                                                            00001600
      IF(IND.EQ.-2) NE=0                                                00001600
C  ***   CALCULATION  OF  BENDING MOMENT                                00001600
      DO 110 J=1,NE,NEL                                                 00001600
      BM(1,J)=-P*(YA(1,J)+WL(1,J))-RSTMT1                               00001600
  110 BM(2,J)= P*(YA(2,J)+WL(2,J))+RSTMT2                               00001600
C          ASSIGN CACULATION ORDER (SUBROUTINE 'FORCE')                 00001600
      DO 10 K=1,3                                                       00001600
      NS(K)=1                                                           00001600
   10 NUM(K)=4-K                                                        00001700
      IF(N.GT.1) GO TO 91                                               00001700
C      DETERMINE  PHI FROM M-PHI CURVE AT ENDS                          00001700
      DO 120 J=1,NE,NEL                                                 00001700
C          ASSIGN RESIDUAL STRESS, PRESSURE STRESS AND EXTERNAL FORCES  00001700
C          FOR A CAN                                                    00001700
      DO 65 JJ=1,NTH                                                    00001700
      DO 65 KK=1,NLA                                                    00001700
      SAR(JJ,KK)=SARL(J,JJ,KK)                                          00001700
   65 STR(JJ,KK)=STRL(J,JJ,KK)                                          00001700
      FSS(1)=BM(1,J)                                                    00001800
      FSS(2)=BM(2,J)                                                    00001800
      FSS(3)=P                                                          00001800
      SYILD=SYILDI(J)                                                   00001800
C                                                                       00001800
      CALL CURVE(NS,NUM,FSS,DF,SQR,XO,YO,DA,SAR,STR,BMT,RI,XA,IND,SYILD)00001800
      IF(IND.EQ.10)  GO TO 850                                          00001800
C          WHEN IND=10, STIFFNESS MATRIX IS SINGULAR (FOR LONG COLUMN)  00001800
C                                                                       00001800
      PHI(1,J)=-XA(1)                                                   00001800
      PHI(2,J)= XA(2)                                                   00001900
      PHI(3,J)=XA(3)                                                    00001900
  120 CONTINUE                                                          00001900
C                                                                       00001900
C   BEGIN THE PROCESS OF MODFIED NEWMARK'S METHOD                       00001900
C *** 2) CALCULATION OF SLOPE                                           00001900
   91 DO 112 IX=1,2                                                     00001900
      DO 112 J=1,NEL                                                    00001900
  112 SLOPE(IX,J)=(YA(IX,J+1)-YA(IX,J))/DL                              00001900
      WRITE(6,569)   (SLOPE(1,J),J=1,NEL)                               00001900
      WRITE(6,570)  (SLOPE(2,J),J=1,NEL)                                00002000
C *** 3) CURVATURES AT STATIONS EXCEPT ENDS                             00002000
      DO 113 IX=1,2                                                     00002000
      DO 114 J=2,NEL                                                    00002000
  114 PHI(IX,J)=(SLOPE(IX,J-1)-SLOPE(IX,J))/DL                          00002000
  113 IF(IND.EQ.-2) PHI(IX,NEL+1)=2.0*SLOPE(IX,NEL)/DL                  00002000
C                                                                       00002000
C      DETERMINE E0(AXIAL STRAIN) AT STATIONS                           00002000
      DO 115 J=1,NEL+1                                                  00002000
  115 CALL  E0STRN(YONG,SYILDI(J),DIA,T,P,PHI(1,J),PHI(2,J),PHI(3,J))   00002000
C                                                                       00002100
      WRITE(6,565) (PHI(1,J),J=1,NEL+1)                                 00002100
      WRITE(6,566) (PHI(2,J),J=1,NEL+1)                                 00002100
      WRITE(6,566) (PHI(3,J),J=1,NEL+1)                                 00002100
C *** 4)  INTERNAL BENDING MOMENTS AT STATIONS                          00002100
      BME1=BM(1,1)                                                      00002100
      BME2=BM(2,1)                                                      00002100
      BME3=BM(NEL+1,1)                                                  00002100
      BME4=BM(NEL+1,1)                                                  00002100
      DO 130 J=1,NEL+1                                                  00002100
      DO 131 JJ=1,NTH                                                   00002200
      DO 131 KK=1,NLA                                                   00002200
      SAR(JJ,KK)=SARL(J,JJ,KK)                                          00002200
  131 STR(JJ,KK)=STRL(J,JJ,KK)                                          00002200
      DO 132 K=1,3                                                      00002200
  132 XA(K)=PHI(K,J)                                                    00002200
      CALL STRESS(FA,XA,SQR,XO,YO,DA,SAR,STR,SA,SC,NTH,NLA,SYILDI(J))   00002200
      BM(1,J)=FA(1)                                                     00002200
      BM(2,J)=FA(2)                                                     00002200
      ALPH(3,J)=FA(3)                                                   00002200
  130 CONTINUE                                                          00002300
      WRITE(6,563)   (BM(1,J),J=1,NEL+1)                                00002300
      WRITE(6,564)   (BM(2,J),J=1,NEL+1)                                00002300
      WRITE(6,564)   (ALPH(3,J),J=1,NEL+1)                              00002300
C *** 5) RESULTING DEFLECTION, YB                                       00002300
      DO 140 IX=1,2                                                     00002300
      DO 140 J=1,NEL+1                                                  00002300
  140 YB(IX,J)=BM(IX,J)/(-P)-WL(IX,J)                                   00002300
      WRITE(6,571) (YB(1,J),J=1,NEL+1)                                  00002300
      WRITE(6,572) (YB(2,J),J=1,NEL+1)                                  00002300
C                                                                       00002400
C ***   JUDGEMENT FOR CONVERGENCE                                       00002400
C     IF ERROR IS SMALLER THAN 0.01*YAA, THE CURVE HAS CONVERGED        00002400
C          YAA.....MAXIMUM VALUE OF DEFLECTION                          00002400
      YAA=0.0                                                           00002400
      DO 55 IX=1,2                                                      00002400
      DO 55 J=1,NEL+1                                                   00002400
   55 IF(ABS(YA(IX,J)).GT.YAA) YAA=ABS(YA(IX,J))                        00002400
      IF(YAA.LT.0.001)  GO TO 314                                       00002400
      EROR=0.0                                                          00002400
      DO 310 IX=1,2                                                     00002500
      DO 310 J=1,NEL+1                                                  00002500
      DERR=YB(IX,NEL+1)-YA(IX,NEL+1)                                    00002500
  310 IF(ABS(DERR).GT.EROR) EROR=ABS(DERR)                              00002500
      IF(EROR.GT.    0.01*YAA)  GO TO 350                               00002500
  314 WRITE(6,600)                                                      00002500
      GO TO 100                                                         00002500
  350 IF(EROR.LT.    50.0*YAA)  GO TO 315                               00002500
      WRITE(6,910)                                                      00002500
      GO TO 850                                                         00002500
  315 DO 320 IX=1,2                                                     00002600
      DO 320 J=1,NEL+1                                                  00002600
  320 YA(IX,J)=YB(IX,J)                                                 00002600
C                                                                       00002600
      AROW(1)=YB(1,NEL+1)                                               00002600
      AROW(2)=YB(2,NEL+1)                                               00002600
      GO TO 90                                                          00002600
C                                                                       00002600
  100 CONTINUE                                                          00002600
C                                                                       00002600
  850 RETURN                                                            00002700
  502 FORMAT(1H ,4X,'XL',3X,8E15.5)                                     00002700
  550 FORMAT(1H ,//,5X,'PCR =',6E15.5)                                  00002700
  560 FORMAT(1H ,//,2X,'P =',E15.5)                                     00002700
  561 FORMAT(1H ,/,5X,'YA',3X,8E15.5)                                   00002700
  562 FORMAT(1H ,9X,8E15.5)                                             00002700
  563 FORMAT(1H ,4X,'BM',3X,8E15.5)                                     00002700
  564 FORMAT(1H ,9X,8E15.5)                                             00002700
  565 FORMAT(1H ,  3X,'PHI',3X,8E15.5)                                  00002700
  566 FORMAT(1H ,9X,8E15.5)                                             00002700
  567 FORMAT(1H ,  2X,'ALPH',3X,8E15.5)                                 00002800
  568 FORMAT(1H ,9X,8E15.5)                                             00002800
  569 FORMAT(1H ,10X,100('*'),/,2X,'SLOPE',9X,8E15.5)                   00002800
  570 FORMAT(1H ,15X,8E15.5)                                            00002800
  571 FORMAT(1H ,/,5X,'YB',3X,8E15.5)                                   00002800
  572 FORMAT(1H ,9X,8E15.5)                                             00002800
  573 FORMAT(1H ,/,5X,'E0',3X,8E15.5)                                   00002800
  580 FORMAT(1H ,//,5X,'RESTRAINT FACTOR',/,7X,'Z0=',E11.3,'  Z1',E11.3,00002800
     1    '  Z2=',E11.3)                                                00002800
  599 FORMAT(1H1)                                                       00002800
  600 FORMAT(1H ,/,'****  CONVERGENCE')                                 00002900
  900 FORMAT(1H ,'******  TOO MANY ITERATION IN NEWMAK')                00002900
  910 FORMAT(1H ,/,'***  EROR GREATER THAN  50*YAA IN NEWMAK (DIVERGENCE00002900
     1)')                                                               00002900
      END                                                               00002900
      SUBROUTINE E0STRN(E,SYILD,DIA,T,P,PHIX,PHIY,E01)                  00002900
C  CALCULATION OF AXIAL STRAIN, E0, KNOWING P, PHIX AND PHIY            00002900
      RC=(DIA-T)/2.0                                                    00002900
      N=0                                                               00002900
      EY=SYILD/E                                                        00002900
      PAI=4.0*ATAN(1.0)                                                 00003000
      E0=P/(2.0*PAI*E*T*RC)                                             00003000
      ERR=ABS(0.01*E0)                                                  00003000
      PHI0=SQRT(PHIX*PHIX+PHIY*PHIY)                                    00003000
      TPHI=RC*TAN(PHI0)                                                 00003000
      EULT1=TPHI-E0                                                     00003000
      EULT2=TPHI+E0                                                     00003000
      IF(EULT1.GT.EY.AND.EULT2.GT.EY) GO TO 300                         00003000
      IF(EULT1.GT.EY. OR.EULT2.GT.EY) GO TO 200                         00003000
      E01=E0                                                            00003000
      GO TO 100                                                         00003100
  200 N=N+1                                                             00003100
      IF(N.GT.20) GO TO 190                                             00003100
      ETA1=(EY+E0)/TPHI                                                 00003100
      THETY=ASIN(ETA1)                                                  00003100
      E01=(P/(E*T*RC)+EY*(PAI-2.0*THETY)-2.0*TPHI*COS(THETY))/(PAI+     00003100
     1     2.0*THETY)                                                   00003100
      EULT1=TPHI-E01                                                    00003100
      EULT2=TPHI+E01                                                    00003100
      IF(EULT1.GT.EY.AND.EULT2.GT.EY) GO TO 300                         00003100
      IF(ABS(E01-E0).LT.ERR) GO TO 100                                  00003200
      E0=E01                                                            00003200
      GO TO 200                                                         00003200
  300 N=N+1                                                             00003200
      IF(N.GT.20) GO TO 190                                             00003200
      ETA1=(EY+E0)/TPHI                                                 00003200
      ETA2=(EY-E0)/TPHI                                                 00003200
      IF(ETA1.GT.1.0) GO TO 191                                         00003200
      IF(ETA2.GT.1.0) GO TO 200                                         00003200
      THETY1=ASIN(ETA1)                                                 00003200
      THETY2=ASIN(ETA2)                                                 00003300
      E01=(P/(2.0*E*T*RC)-TPHI*(COS(THETY1)-COS(THETY2))-EY*(THETY1-    00003300
     1     THETY2))/(THETY1+THETY2)                                     00003300
      IF(ABS(E01-E0).LT.ERR) GO TO 100                                  00003300
      E0=E01                                                            00003300
      GO TO 300                                                         00003300
  190 WRITE(6,519)                                                      00003300
      STOP                                                              00003300
  191 WRITE(6,520)                                                      00003300
      STOP                                                              00003300
  100 RETURN                                                            00003400
  511 FORMAT(1H ,/,5X,'E0 =',E15.5)                                     00003400
  519 FORMAT(1H ,//,' ***  TOO MANY ITERATIONS IN CACULATING E0')       00003400
  520 FORMAT(1H ,//,' ***  ETA1.GT. 1  IN E0-STRAIN')                   00003400
      END                                                               00003400
      SUBROUTINE  MCRELA                                                00003400
C     ****** TANGENT STIFFNESS METHOD FOR BIAXIAL BENDING OF            00003400
C          CYLINDRICAL COLUMNS                                          00003400
C          SHORT COLUMN ANALYSIS                                        00003400
      DIMENSION  XA(3),N(3),FB(3),NUM(3),FS(3),DF(3),NF(3),FA(3),       00003400
     1      QG(3,3),DFA(3),RI(10), BMT(150),SQR( 75,6)                  00003500
     2    ,XO( 75,6),YO( 75,6),DA(8),SAR( 75,6),STR( 75,6)              00003500
     3     ,RSTC(10),RSTA(150)                                          00003500
C                                                                       00003500
  100 CALL  INPUT(DIA,T, NCTL2,  FS,DF,NF,ALPH,Q,WI,BETA,SYILD)         00003500
C          GENERATE DATA FOR EACH ELEMENT                               00003500
      CALL  ELMENT(T,DIA,RI,Q,WI,BETA,NCTL2,BMT,XO,YO,DA,SYILD)         00003500
C          COMPUTE RESIDUAL STRESSES FOR EACH ELEMENT                   00003500
      CALL  INTIAL(NCTL2,RI,ALPH,RSTC,RSTA,RBM)                         00003500
C          COMPUTE PRESSURE STRESSES FOR EACH ELEMENT                   00003500
      CALL  PRESS(SQR,SAR,STR,RI,BMT,NCTL2,RSTC,RSTA,RBM,SYILD)         00003600
C          ASSIGN LOAD INCREMENT                                        00003600
      CALL  FORCE(N,   NUM,NF)                                          00003600
          IND=1                                                         00003600
C          GET M-P-PHI CURVE BY TANGENT STIFFNESS METHOD                00003600
      CALL  CURVE( N,NUM,FS,DF,SQR,XO,YO,DA,SAR,STR,BMT,RI,XA,IND,SYILD)00003600
C                                                                       00003600
      GO TO 100                                                         00003600
      END                                                               00003600
      SUBROUTINE  NEWMAK(IND)                                           00003600
C   LONG COLUMN BUCKLING ANALYSIS BY NEWMARK'S METHOD                   00003700
      COMMON /MAT/        YONG,NCTRL,ENU,NTH,NLA                        00003700
      COMMON  /PMT/ PLTM,YLDP                                           00003700
      DIMENSION  XA(3),     FB(3),NUM(3),FS(3),DF(3),NF(3),FA(3),       00003700
     1      QG(3,3),DFA(3),RI(10), BMT(150),SQR( 75,6)                  00003700
     2    ,XO( 75,6),YO( 75,6),DA(8),SAR( 75,6),STR( 75,6)              00003700
     3     ,RSTC(10),RSTA(150),ALPHI(10),SARL(8,75,4),STRL(8,75,4)      00003700
      DIMENSION  WL(2,11),BM(2,11),XL(11),YA(2,11),YB(2,11),PHI(3,11),  00003700
     1     SLOPE(3,11),ALPH(3,11),DY(2),FSS(3),NS(3),ATOT(3),AROW(2)    00003700
     2    ,SYILDI(10)                                                   00003700
C                                                                       00003800
      CALL       INPUT2(AL,PL,NEL,SPRG1,SPRG2,ISHORT,WL,AROW,ALPHI,     00003800
     1                  SYILDI,IND)                                     00003800
C                                                                       00003800
C          INPUT FOR SHORT COLUMN ANALYSIS                              00003800
      CALL  INPUT(DIA,T, NCTL2,  FS,DF,NF,ALPI,Q,WI,BETA,SYILD)         00003800
C          MAKE DATA FOR EACH ELEMENT                                   00003800
      CALL  ELMENT(T,DIA,RI,Q,WI,BETA,NCTL2,BMT,XO,YO,DA,SYILD)         00003800
C                                                                       00003800
C          COMPUTE RESIDUAL STRESSES AND PRESSURE STRESS FOR EACH CAN   00003800
C            I....STATION NUMBER                                        00003900
C            J....ELEMENT NUMBER IN CIRCUMFERENTIAL DIRECTION           00003900
C            K....ELEMENT NUMBER IN RADIAL DIRECTION                    00003900
      DO 60 I=1,NEL+1                                                   00003900
      ALPI=ALPHI(I)                                                     00003900
C                                                                       00003900
      CALL  INTIAL(NCTL2,RI,ALPI,RSTC,RSTA,RBM)                         00003900
      SYILD=SYILDI(I)                                                   00003900
C                                                                       00003900
      CALL  PRESS(SQR,SAR,STR,RI,BMT,NCTL2,RSTC,RSTA,RBM,SYILD)         00003900
C                                                                       00004000
      DO 61 J=1,NTH                                                     00004000
      DO 61 K=1,NLA                                                     00004000
      SARL(I,J,K)=SAR(J,K)                                              00004000
   61 STRL(I,J,K)=STR(J,K)                                              00004000
   60 CONTINUE                                                          00004000
C                                                                       00004000
C          COMPUTATION OF ULTIMATE BUCKLING LOAD                        00004000
C            PCR....ULTIMATE AXIAL LOAD                                 00004000
C            SI.....MOMENT OF INERTIA                                   00004000
      PAI=4.0*ATAN(1.0)                                                 00004100
      SI=PAI*(DIA**4-(DIA-2.0*T)**4)/64.0                               00004100
      PCR=PAI*PAI*YONG*SI/PL/PL                                         00004100
      WRITE(6,550)  PCR                                                 00004100
      DL=AL/FLOAT(NEL)                                                  00004100
      NFP=NF(3)                                                         00004100
C                                                                       00004100
C   END-RESTRAINT                                                       00004100
C          Z0.......FULLY RESTRAINT FACTOR, MOMENT/RADIAN               00004100
C          Z1,Z2....RESTRAINT FACTOR,       MOMENT/RADIAN               00004100
C          RSTMT....CONSTRAINT MOMENT AT ENDS                           00004200
      Z0=2.0*YONG*SI/PL                                                 00004200
      Z1=Z0*SPRG1                                                       00004200
      Z2=Z0*SPRG2                                                       00004200
      RSTMT1=0.0                                                        00004200
      RSTMT2=0.0                                                        00004200
      WRITE(6,580) Z0,Z1,Z2                                             00004200
      WRITE(6,599)                                                      00004200
      SLOPI1=(WL(1,2)-WL(1,1))/DL                                       00004200
      SLOPI2=(WL(2,2)-WL(2,1))/DL                                       00004200
C                                                                       00004300
C ***  REPEAT  FOR  P                                                   00004300
      DO 100 I=1,NFP                                                    00004300
C          DETERMINATION OF INITIAL CURVE SHAPE FOR NEWMARK'S METHOD    00004300
C            W1,W2....MAXIMUM OFFSET OF CURVE EXCLUDING IMPERFECTION    00004300
C        BUT INCLUDING AMPLIFICATION DUE TO ELASTIC DEFORMATION         00004300
C       AROW....ARROW OF DEFLECTION CURVE (NOT INCLUDE IMPERFECTION)    00004300
      P=FS(3)+DF(3)*FLOAT(I-1)                                          00004300
      WRITE(6,560)  P                                                   00004300
      IF(ABS(AROW(1)).GT.1.0E-5.OR.ABS(AROW(2)).GT.1.0E-5) GO TO 39     00004300
      PW=-P                                                             00004400
      IF(PW.GT.0.95*PCR) PW=0.95*PCR                                    00004400
      WX=WL(1,NEL/2+1)                                                  00004400
      WY=WL(2,NEL/2+1)                                                  00004400
      IF(ABS(WX).LT.1.0E-10) WX=WL(1,NEL/2+2)                           00004400
      IF(ABS(WY).LT.1.0E-10) WY=WL(2,NEL/2+2)                           00004400
      IF(IND.NE.2) GO TO 23                                             00004400
      WX=WL(1,NEL+1)                                                    00004400
      WY=WL(2,NEL+1)                                                    00004400
      IF(ABS(WX).LT.1.0E-10) WX=WL(1,NEL)                               00004400
      IF(ABS(WY).LT.1.0E-10) WY=WL(2,NEL)                               00004500
   23 W1=WX/(1.0-PW/PCR)                                                00004500
      W2=WY/(1.0-PW/PCR)                                                00004500
      IF(ABS(W1).LT.1.0E-10.AND.ABS(W2).LT.1.0E-10) W2=0.1              00004500
      AROW(1)=W1-WX                                                     00004500
      AROW(2)=W2-WY                                                     00004500
C                                                                       00004500
   39 N=0                                                               00004500
C  ***   ASSUME  INITIAL  DEFLECTION                                    00004500
C           J.....STATION NUMBER                                        00004500
C           IX....=1 X-DIRECTION,  =2 Y-DIRECTION                       00004600
C           XL....X-COORDINATES OF STRAIN                               00004600
C           YA....CURVE SHAPE EXCLUDING IMPERFECTION                    00004600
      DO 40 J=1,NEL+1                                                   00004600
      XL(J)=AL*FLOAT(J-1)/FLOAT(NEL)                                    00004600
      DO 40 IX=1,2                                                      00004600
      YA(IX,J)=AROW(IX)*SIN(PAI*XL(J)/AL)                               00004600
   40 IF(IND.EQ.2) YA(IX,J)=AROW(IX)*SIN(PAI*XL(J)/2.0/AL)              00004600
      WRITE(6,502)  (XL(J),  J=1,NEL+1)                                 00004600
      WRITE(6,561) (YA(1,J),J=1,NEL+1)                                  00004600
      WRITE(6,562) (YA(2,J),J=1,NEL+1)                                  00004700
C                                                                       00004700
C    ITERATING PROCESS STARTS                                           00004700
   90 N=N+1                                                             00004700
      IF(N.LE.25) GO TO 80                                              00004700
      WRITE(6,900)                                                      00004700
      GO TO 100                                                         00004700
C  ***   CALCULATION  OF  BENDING MOMENT                                00004700
   80 DO 110 J=1,NEL+1                                                  00004700
      BM(1,J)=-P*(YA(1,J)+WL(1,J))-RSTMT1                               00004700
  110 BM(2,J) = P*(YA(2,J)+WL(2,J))+RSTMT2                              00004800
      WRITE(6,563) (BM(1,J),J=1,NEL+1)                                  00004800
      WRITE(6,564) (BM(2,J),J=1,NEL+1)                                  00004800
C          ASSIGN CACULATION ORDER (SUBROUTINE 'FORCE')                 00004800
      DO 10 K=1,3                                                       00004800
      NS(K)=1                                                           00004800
   10 NUM(K)=4-K                                                        00004800
C ***  DETERMINE  PHI FROM M-PHI CURVE                                  00004800
      DO 120 J=1,NEL+1                                                  00004800
C          ASSIGN RESIDUAL STRESS, PRESSURE STRESS AND EXTERNAL FORCES  00004800
C          FOR A CAN                                                    00004900
      DO 65 JJ=1,NTH                                                    00004900
      DO 65 KK=1,NLA                                                    00004900
      SAR(JJ,KK)=SARL(J,JJ,KK)                                          00004900
   65 STR(JJ,KK)=STRL(J,JJ,KK)                                          00004900
      FSS(1)=BM(1,J)                                                    00004900
      FSS(2)=BM(2,J)                                                    00004900
      FSS(3) = P                                                        00004900
      SYILD=SYILDI(J)                                                   00004900
C                                                                       00004900
      CALL CURVE(NS,NUM,FSS,DF,SQR,XO,YO,DA,SAR,STR,BMT,RI,XA,IND,SYILD)00005000
      IF(IND.EQ.10)  GO TO 850                                          00005000
C          WHEN IND=10, STIFFNESS MATRIX IS SINGULAR (FOR LONG COLUMN)  00005000
C                                                                       00005000
      PHI(1,J)=-XA(1)                                                   00005000
      PHI(2,J)= XA(2)                                                   00005000
      PHI(3,J)=XA(3)                                                    00005000
  120 CONTINUE                                                          00005000
C          OUTPUT OF CURVATURE                                          00005000
      WRITE(6,565)  (PHI(1,J),J=1,NEL+1)                                00005000
      WRITE(6,566) (PHI(2,J),J=1,NEL+1)                                 00005100
C ***   CALCULATION OF ALPH-BAR                                         00005100
C          EVALUATION FOR CONTRIBUTION OF ALPHA TO SLOPE                00005100
      DO 130 IX=1,3                                                     00005100
      ALPH(IX,1)=DL/24.0*(7.0*PHI(IX,1)+6.0*PHI(IX,2)-PHI(IX,3))        00005100
      DO 20 J=2,NEL                                                     00005100
   20 ALPH(IX,J)=DL/12.0*(PHI(IX,J-1)+10.0*PHI(IX,J)+PHI(IX,J+1))       00005100
      ALPH(IX,NEL+1)=DL/24.0*(7.0*PHI(IX,NEL+1)+6.0*PHI(IX,NEL)-        00005100
     1    PHI(IX,NEL-1))                                                00005100
      IF(IND.EQ.2) ALPH(IX,NEL+1)=DL/12.0*(2.0*PHI(IX,NEL)+10.0*        00005100
     1    PHI(IX,NEL+1))                                                00005200
  130 CONTINUE                                                          00005200
C          OUTPUT OF ALPH-BAR                                           00005200
      WRITE(6,567) (ALPH(1,J),J=1,NEL+1)                                00005200
      WRITE(6,568) (ALPH(2,J),J=1,NEL+1)                                00005200
      WRITE(6,568) (ALPH(3,J),J=1,NEL+1)                                00005200
C          INTEGRATION OF ALPH-BAR                                      00005200
C ***  SLOPE FOR NON-SYMMETRY                                           00005200
      IF(IND.EQ.2)  GO TO 200                                           00005200
      DO 30 IX=1,2                                                      00005200
      ATOT(IX)=0.0                                                      00005300
      DO 30 J=1,NEL+1                                                   00005300
   30 ATOT(IX)=ATOT(IX)-ALPH(IX,J)                                      00005300
      SLOPE(1,1)=ATOT(1)/2.0                                            00005300
      SLOPE(2,1)=ATOT(2)/2.0                                            00005300
      DO 140 IX=1,2                                                     00005300
      DO 140 J=2,NEL                                                    00005300
  140 SLOPE(IX,J)=SLOPE(IX,J-1)+ALPH(IX,J)                              00005300
      GO TO 210                                                         00005300
C ***  SLOPE FOR SYMMETRY                                               00005300
  200 SLOPE(1,NEL)=-ALPH(1,NEL+1)/2.0                                   00005400
      SLOPE(2,NEL)=-ALPH(2,NEL+1)/2.0                                   00005400
      DO 220 IX=1,2                                                     00005400
      DO 220 J=1,NEL-1                                                  00005400
      L=NEL-J                                                           00005400
  220 SLOPE(IX,L)=SLOPE(IX,L+1)-ALPH(IX,L+1)                            00005400
  210 WRITE(6,569) (SLOPE(1,J),J=1,NEL)                                 00005400
      WRITE(6,570) (SLOPE(2,J),J=1,NEL)                                 00005400
C                                                                       00005400
C           BENDING MOMENT DUE TO END-RESTRAINT                         00005400
      CALL RSTRAT(Z1,Z2,SLOPE,ALPH,SLOPI1,SLOPI2,RSTMT1,RSTMT2,P)       00005500
C                                                                       00005500
C ***   DEFLECTION,  YB                                                 00005500
C          RESULTANT DEFLECTION SHAPE                                   00005500
      YB(1,1)=0.0                                                       00005500
      YB(2,1)=0.0                                                       00005500
      DO 230 IX=1,2                                                     00005500
      DO 230 J=2,NEL+1                                                  00005500
  230 YB(IX,J)=YB(IX,J-1)+SLOPE(IX,J-1)*DL                              00005500
      IF(IND.EQ.2)  GO TO 300                                           00005500
      DO 50 IX=1,2                                                      00005600
      DY(IX)=YB(IX,NEL+1)/FLOAT(NEL)                                    00005600
      DO 50 J=1,NEL                                                     00005600
   50 YB(IX,J+1)=YB(IX,J+1)-DY(IX)*FLOAT(J)                             00005600
  300 WRITE(6,571) (YB(1,J),J=1,NEL+1)                                  00005600
      WRITE(6,572) (YB(2,J),J=1,NEL+1)                                  00005600
C                                                                       00005600
C *** SHORTENING OF COLUMN                                              00005600
C  AXIAL DEFORMATION AND GEOMETRICAL CHANGE                             00005600
      SLOPE(3,1)=0.0                                                    00005600
      ALPH(3,1)=2.0*ALPH(3,1)                                           00005700
      DO 145 J=2,NEL+1                                                  00005700
      DL2=(YB(1,J-1)-YB(1,J))**2+(YB(2,J-1)-YB(2,J))**2                 00005700
      DELTA=DL-SQRT(DL*DL-DL2)                                          00005700
  145 SLOPE(3,J)=SLOPE(3,J-1)+(ALPH(3,J-1)+ALPH(3,J))/2.0-DELTA         00005700
C   TAKING ACCOUNT OF INITIAL IMPERFECTION INTO SHORTENING              00005700
      IF(ISHORT.NE.1) GO TO 149                                         00005700
      CDEL=0.0                                                          00005700
      DO 147J=2,NEL+1                                                   00005700
      DL2=(WL(1,J-1)-WL(1,J))**2+(WL(2,J-1)-WL(2,J))**2                 00005700
      DELTA=DL-SQRT(DL*DL-DL2)                                          00005800
      CDEL=CDEL+DELTA                                                   00005800
  147 SLOPE(3,J)=SLOPE(3,J)-CDEL                                        00005800
  149 WRITE(6,573) (SLOPE(3,J),J=1,NEL+1)                               00005800
C ***   JUDGEMENT FOR CONVERGENCE                                       00005800
C     IF ERROR IS SMALLER THAN 0.01*YAA, THE CURVE HAS CONVERGED        00005800
C          YAA.....MAXIMUM VALUE OF DEFLECTION                          00005800
      YAA=0.0                                                           00005800
      DO 55 IX=1,2                                                      00005800
      DO 55 J=1,NEL+1                                                   00005800
   55 IF(ABS(YA(IX,J)).GT.YAA) YAA=ABS(YA(IX,J))                        00005900
      IF(YAA.LT.0.001)  GO TO 314                                       00005900
      EROR=0.0                                                          00005900
      DO 310 IX=1,2                                                     00005900
      DO 310 J=1,NEL+1                                                  00005900
      DERR=YB(IX,J)-YA(IX,J)                                            00005900
  310 IF(ABS(DERR).GT.EROR) EROR=ABS(DERR)                              00005900
      IF(EROR.GT.    0.01*YAA)  GO TO 350                               00005900
  314 WRITE(6,600)                                                      00005900
      GO TO 100                                                         00005900
  350 IF(EROR.LT.    50.0*YAA)  GO TO 315                               00006000
      WRITE(6,910)                                                      00006000
      GO TO 850                                                         00006000
  315 DO 320 IX=1,2                                                     00006000
      DO 320 J=1,NEL+1                                                  00006000
  320 YA(IX,J)=YB(IX,J)                                                 00006000
C                                                                       00006000
      GO TO 90                                                          00006000
C                                                                       00006000
  100 CONTINUE                                                          00006000
C                                                                       00006100
  850 RETURN                                                            00006100
  502 FORMAT(1H ,4X,'XL',3X,8E15.5)                                     00006100
  550 FORMAT(1H ,//,5X,'PCR =',6E15.5)                                  00006100
  560 FORMAT(1H ,//,2X,'P =',E15.5)                                     00006100
  561 FORMAT(1H ,/,5X,'YA',3X,8E15.5)                                   00006100
  562 FORMAT(1H ,9X,8E15.5)                                             00006100
  563 FORMAT(1H ,10X,100('*'),/,5X,'BM',3X,8E15.5)                      00006100
  564 FORMAT(1H ,9X,8E15.5)                                             00006100
  565 FORMAT(1H ,  3X,'PHI',3X,8E15.5)                                  00006100
  566 FORMAT(1H ,9X,8E15.5)                                             00006200
  567 FORMAT(1H ,  2X,'ALPH',3X,8E15.5)                                 00006200
  568 FORMAT(1H ,9X,8E15.5)                                             00006200
  569 FORMAT(1H ,  1X,'SLOPE',9X,8E15.5)                                00006200
  570 FORMAT(1H ,15X,8E15.5)                                            00006200
  571 FORMAT(1H ,/,5X,'YB',3X,8E15.5)                                   00006200
  572 FORMAT(1H ,9X,8E15.5)                                             00006200
  573 FORMAT(1H ,/,5X,'E0',3X,8E15.5)                                   00006200
  580 FORMAT(1H ,//,5X,'RESTRAINT FACTOR',/,7X,'Z0=',E11.3,'  Z1',E11.3,00006200
     1    '  Z2=',E11.3)                                                00006200
  599 FORMAT(1H1)                                                       00006300
  600 FORMAT(1H ,/,'****  CONVERGENCE')                                 00006300
  900 FORMAT(1H ,'******  TOO MANY ITERATION IN NEWMAK')                00006300
  910 FORMAT(1H ,/,'***  EROR GREATER THAN  50*YAA IN NEWMAK (DIVERGENCE00006300
     1)')                                                               00006300
      END                                                               00006300
      SUBROUTINE  CONVRG(FB,XA,DFA,IFAC,N,FA,SQR,NC3,DF,XO,YO,DA,       00006300
     1                  SAR,STR,SA,SC,IND,SYILD)                        00006300
C          JUDGE CONVERGENCE AND ADJUST INCREMENT WHEN IT IS TOO LARGE  00006300
      COMMON /MAT/        YONG,NCTRL,ENU,NTH,NLA                        00006300
      DIMENSION  QG(3,3),FB(3),XA(3),DXA(3),DFA(3),FA(3),QI(3,3)        00006400
     1   ,SQR( 75,6),XAO(3),FAO(3),FBO(3)                               00006400
     2    ,XO( 75,6),YO( 75,6),DA(8),SAR( 75,6),STR( 75,6)              00006400
     3    ,SA( 75,6),SC( 75,6)                                          00006400
C                                                                       00006400
      ERR=2.0                                                           00006400
      N3=NC3                                                            00006400
      IF(NC3.LT.0)  N3=-NC3                                             00006400
      DO 3 I=1,3                                                        00006400
       XAO(I)=XA(I)                                                     00006400
       FAO(I)=FA(I)                                                     00006500
    3  FBO(I)=FB(I)                                                     00006500
      ICON=0                                                            00006500
    5 N=0                                                               00006500
C                                                                       00006500
      CALL  REPEAT(FA,FB,DFA,XA,    XO,YO,DA,IFAC,N,ERR,SQR,SAR,STR,    00006500
     1    SA,SC,NTH,NLA,SYILD)                                          00006500
C                                                                       00006500
      IF(IFAC.EQ.0.OR.IND.EQ.1) GO TO 80                                00006500
      IND=10                                                            00006500
C          IF IND=10, STIFFNESS MATRIX IS SIGULAR (FOR LONG COLUMN ANA.)00006600
      GO TO 200                                                         00006600
   80 IF(IFAC.GT.0) GO TO 102                                           00006600
      IF(N.GT.15)  GO TO 101                                            00006600
      IF(ICON.GE.1)  GO TO 180                                          00006600
C          IF ICON IS GREATER THAN 0, STIFFNESS MATRIX HAS BECOME       00006600
C          SINGULAR (ICON TIMES)                                        00006600
      GO TO 200                                                         00006600
  101 WRITE(6,501)                                                      00006600
C ***  REDUCE LOAD INCREMENT TO OBTAIN CONVERGENCE                      00006600
  102 ICON=ICON+1                                                       00006700
      IF(ICON.GT.3)  GO TO 180                                          00006700
      DO 105 I=1,3                                                      00006700
       XA(I)=XAO(I)                                                     00006700
       FA(I)=FAO(I)                                                     00006700
  105  FB(I)=FBO(I)                                                     00006700
      FB(N3)=FBO(N3)-DF+DF/(FLOAT(ICON)*FLOAT(ICON)+1.0)                00006700
      GO TO 5                                                           00006700
  180 IFAC=1                                                            00006700
C          IF IFAC=1, STIFFNESS MATRIX IS SINGULAR                      00006700
C                                                                       00006800
  200 RETURN                                                            00006800
  501 FORMAT(1H ,5X,'****  TOO MANY ITERATION TIMES')                   00006800
      END                                                               00006800
      SUBROUTINE  CURVE(N,NUM,FS,DF,SQR,XO,YO,DA,SAR,STR,      BMT,RI,  00006800
     1                  XA,IND,SYILD)                                   00006800
C          ASSIGN LOAD INCREMENT TO GET M-P-PHI CURVE                   00006800
      COMMON /MAT/        YONG,NCTRL,ENU,NTH,NLA                        00006800
      DIMENSION  N(3),NUM(3),FS(3),DF(3),FB(3),DFA(3),FA(3),XA(3),      00006800
     1   RI(10),SQR( 75,6),XO( 75,6),YO( 75,6),DA(8)                    00006800
     2   ,SAR( 75,6),STR( 75,6),SA( 75,6),SC( 75,6),BMT(150)            00006900
C                                                                       00006900
C          DIRECTION INDICATOR FOR THE POINT IN TRESCA YIELD CONDITION  00006900
      NN1=N(1)                                                          00006900
      NN2=N(2)                                                          00006900
      NN3=N(3)                                                          00006900
      N1=NUM(1)                                                         00006900
      N2=NUM(2)                                                         00006900
      N3=NUM(3)                                                         00006900
      NC3=N3                                                            00006900
      IF(DF(N3).LT.0.0)  NC3=-N3                                        00007000
C         REPEATING CACULATION FOR LOAD INCREMENT                       00007000
      DO 10 I=1,NN1                                                     00007000
      FB(N1)=FS(N1)+DF(N1)*FLOAT(I-1)                                   00007000
C                                                                       00007000
      DO 10 J=1,NN2                                                     00007000
      FB(N2)=FS(N2)+DF(N2)*FLOAT(J-1)                                   00007000
      IFAC=0                                                            00007000
      DO 5 IH=1,3                                                       00007000
      XA(IH)=0.0                                                        00007000
    5 FA(IH)=0.0                                                        00007100
C                                                                       00007100
      DO 30 K=1,NN3                                                     00007100
      IF(IFAC.GT.0)  GO TO 30                                           00007100
      FB(N3)=FS(N3)+DF(N3)*FLOAT(K-1)                                   00007100
      DO 1 L=1,3                                                        00007100
    1 DFA(L)=FB(L)-FA(L)                                                00007100
C                                                                       00007100
      CALL CONVRG(FB,XA,DFA,IFAC,NTIME,FA,SQR,NC3,DF(N3),XO,YO,DA,      00007100
     1            SAR,STR,SA,SC,IND,SYILD)                              00007100
C                                                                       00007200
      IF(IND.EQ.10) GO TO 100                                           00007200
      IF(NN1.EQ.1.AND.NN2.EQ.1.AND.NN3.EQ.1)  GO TO 20                  00007200
      CALL  OUTPUT(FA,XA,K,NTIME)                                       00007200
   20 DO 2 L=1,3                                                        00007200
    2 FA(L)=FB(L)                                                       00007200
C                                                                       00007200
   30 CONTINUE                                                          00007200
      IF(NN1.EQ.1.AND.NN2.EQ.1.AND.NN3.EQ.1)  GO TO 10                  00007200
      CALL  OUTPT2(SA,SC,BMT,RI)                                        00007200
   10 CONTINUE                                                          00007300
C                                                                       00007300
  100 RETURN                                                            00007300
      END                                                               00007300
      SUBROUTINE  ELMENT(T,DIA,RI,Q,WI,BETA,NCTL2,BMT,XO,YO,DA,SYILD)   00007300
C          GENERATE DATA FOR EACH ELEMENT                               00007300
      COMMON /MAT/        YONG,NCTRL,ENU,NTH,NLA                        00007300
      COMMON  /PMT/   PLTM,YLDP                                         00007300
      COMMON  /SPRESS/   SAVE                                           00007300
      DIMENSION  EPS(10),RI(10), BMT(150),XO( 75,6),YO( 75,6),DA(8)     00007300
C          AREA.....SECTIONAL AREA                                      00007400
C          BI.......MOMENT OF INERTIA                                   00007400
C          S.......SECTION MODULUS                                      00007400
C          RGI......RADIUS GYRATION                                     00007400
C          Z.......PLASTIC MODULUS                                      00007400
C          SHAPE....SHAPE FUNCTION                                      00007400
C          YLDM.....INITIAL YIELDING MOMENT                             00007400
C          PLTM.....PLASTIC MOMENT                                      00007400
C          YLDP.....ULTIMATE AXIAL FORCE                                00007400
C          PHIY.....CURVATURE AT INITIAL YIELD                          00007400
      PAI=4.0*ATAN(1.0)                                                 00007500
      RO=DIA/2.0                                                        00007500
      RT=RO-T                                                           00007500
      DTHTA=2.0*PAI/FLOAT(NTH)                                          00007500
      DTHTA5=DTHTA/2.0                                                  00007500
      AREA=PAI*(RO*RO-RT*RT)                                            00007500
      BI=PAI*(RO**4  -RT**4  )/4.0                                      00007500
      S=BI/RO                                                           00007500
      RGI=SQRT(BI/AREA)                                                 00007500
      Z=(DIA**3  -(DIA-2.0*T)**3  )/6.0                                 00007500
      SHAPE=Z/S                                                         00007600
      YLDM=SYILD*S                                                      00007600
      PLTM=SYILD*Z                                                      00007600
      YLDP=SYILD*AREA                                                   00007600
      PHIY=YLDM/YONG/BI                                                 00007600
C          RI AND DA,  AND CENTROID OF DA (EPS)                         00007600
      EPSY=2.0*SIN(DTHTA5)/3.0                                          00007600
      DT=T/FLOAT(NLA)                                                   00007600
      DO 10 J=1,NLA+1                                                   00007600
   10 RI(J)=RO-DT*FLOAT(J-1)                                            00007600
      DO 15 J=1,NLA                                                     00007700
      DA(J)=DTHTA5*(RI(J)*RI(J)-RI(J+1)*RI(J+1))                        00007700
   15 EPS(J)=EPSY*(RI(J)**3-RI(J+1)**3)/DA(J)                           00007700
C  ****  INITIAL IMPERFECTION                                           00007700
C          QCR......CRITICAL EXTERNAL PRESSRE                           00007700
C          BMAX.....MAXIMUM BENDING MOMENT                              00007700
C          SMA......MAXIMUM BENDING STRESS                              00007700
C          SAVE.....AXIAL STRESS (CONSTANT)                             00007700
      BETA=PAI*BETA/180.0                                               00007700
      RATD=T/DIA*2.0                                                    00007700
      QCR=2.0*YONG/(1.0-ENU*ENU)/(DIA/T)/(DIA/T-1.0)**2                 00007801
      IF(QCR.LT.Q)  WRITE(6,800)                                        00007800
      RAVE=(RI(1)+RI(NLA+1))/2.0                                        00007800
      BMAX=-Q*RAVE*WI/(1.0-Q/QCR)                                       00007800
      SMA=-6.0*BMAX/T/T                                                 00007800
      SAVE=-Q*RAVE/T                                                    00007800
C          BMT(I)....BENDING MOMENT AT ELEMENT I                        00007800
C          W        OUT-OF-ROUNDNESS AT EACH ELEMENT                    00007800
      DO 20 I=1,NTH                                                     00007800
      THTA=DTHTA*FLOAT(I-1)+DTHTA5                                      00007800
      THTB=THTA-BETA                                                    00007900
      W=WI/(1.0-Q/QCR)*COS(2.0*THTB)                                    00007900
      BMT(I)=BMAX*COS(2.0*THTB)                                         00007900
C          XO, YO...COORDINATES OF ELEMENT (I,J)                        00007900
      DO 20 J=1,NLA                                                     00007900
      XO(I,J)=(EPS(J)+W)*COS(THTA)                                      00007900
      YO(I,J)=(EPS(J)+W)*SIN(THTA)                                      00007900
   20 CONTINUE                                                          00007900
C          OUTPUT OF DATA                                               00007900
      WRITE(6,2400)                                                     00007900
      WRITE(6,940)  AREA,BI,S,Z,SHAPE                                   00008000
      WRITE(6,945) RGI                                                  00008000
      WRITE(6,941)  YLDM,PLTM,YLDP,PHIY                                 00008000
      WRITE(6,950)  (DA(I),I=1,NLA)                                     00008000
      WRITE(6,951)  (RI(I),I=1,NLA+1)                                   00008000
      WRITE(6,952)  QCR,SAVE,SMA                                        00008000
C                                                                       00008000
      IF(NCTL2.NE.1)  GO TO 100                                         00008000
      WRITE(6,1000)                                                     00008000
      DO 90 I=1,NTH                                                     00008000
   90 WRITE(6,900) I,(XO(I,J),YO(I,J),J=1,NLA)                          00008100
C                                                                       00008100
  100 RETURN                                                            00008100
  800 FORMAT(1H ,'**** QCR   LESS  THAN Q')                             00008100
  940 FORMAT(1H ,//,4X,'AREA =',E13.5,'  I =',E13.5,'  S =',E13.5,      00008100
     1    '  Z =',E13.5,'   SHAPE FUNCTION =',E13.5)                    00008100
  941 FORMAT(1H ,3X,'M(YILD)=',E13.5,'  M(PLASTIC)=',E13.5,' P(YILD)=', 00008100
     1     E13.5,'  PHI(YIELD)=',E13.5)                                 00008100
  945 FORMAT(1H ,/,4X,'R =',E13.5,//)                                   00008100
  950 FORMAT(1H ,///,4X,'DA =', 8E15.5)                                 00008100
  951 FORMAT(1H ,3X,'RI =',8E15.5)                                      00008200
  952 FORMAT(1H ,/,4X,'QCR=',E15.5,5X,'STRESS DUE TO PRESSURE =',2E15.5)00008200
  900 FORMAT(1H ,I5,3X,10E12.4)                                         00008200
 1000 FORMAT(1H ,///,3X,'  COORDINATES',/,9X,5(5X,'XO',10X,'YO',5X))    00008200
 2400 FORMAT(1H1,//,1X,'DATA OF MEMBER')                                00008200
      END                                                               00008200
      SUBROUTINE  FORCE(N,   NUM,NF)                                    00008200
C ***  DETERMINE  ORDER OF MX, MY, P                                    00008200
C          NF....INPUT REPEATING TIME                                   00008200
C          N.....REPEATING TIME IN ORDER FROM SMALLER TO LARGER         00008200
C          NUM...I= ORDER NUMBER FROM THE SMALLEST                      00008300
C                NUM= INPUT ORDER FOR I                                 00008300
      DIMENSION        N(3),NUM(3),NF(3)                                00008300
      N(1)=NF(1)                                                        00008300
      N(2)=NF(2)                                                        00008300
      IF(N(2).GT.N(1))  GO TO 10                                        00008300
      N(2)=N(1)                                                         00008300
      N(1)=NF(2)                                                        00008300
   10 N(3)=NF(3)                                                        00008300
      IF(NF(3).GT.N(2))  GO TO 20                                       00008300
      IF(NF(3).GT.N(1))  GO TO 15                                       00008400
      N(3)=N(2)                                                         00008400
      N(2)=N(1)                                                         00008400
      N(1)=NF(3)                                                        00008400
      GO TO 20                                                          00008400
   15 N(3)=N(2)                                                         00008400
      N(2)=NF(3)                                                        00008400
   20 CONTINUE                                                          00008400
      DO 1 I=1,3                                                        00008400
      IF(N(I).EQ.NF(1))  NUM(I)=1                                       00008400
      IF(N(I).EQ.NF(2))  NUM(I)=2                                       00008500
    1 IF(N(I).EQ.NF(3))  NUM(I)=3                                       00008500
C                                                                       00008500
      RETURN                                                            00008500
      END                                                               00008500
      SUBROUTINE  INPUT(DIA,T,NCTL2,   FS,DF,NF,ALPH,Q,WI,BETA,SYILD)   00008500
C          INPUT FOR SHORT COLUMN ANALYSIS                              00008500
      COMMON /MAT/        YONG,NCTRL,ENU,NTH,NLA                        00008500
      COMMON /RESTRS/ NRSTC,RLC(8),FLC(8),NRSTA,RLA(10),FLA(10)         00008500
      DIMENSION  TITLE(18),FS(3),DF(3),NF(3)                            00008500
C                                                                       00008600
      READ(5,1000,END=500)  (TITLE(I),I=1,18)                           00008600
      WRITE(6,2000) (TITLE(I),I=1,18)                                   00008600
      READ(5,1001)  SYILD,YONG,DIA,T,NTH,NLA,ENU                        00008600
      WRITE(6,2001) SYILD,YONG,DIA,T,NTH,NLA,ENU                        00008600
C          LOAD INCREMENT                                               00008600
      READ(5,1002)  FS(3),DF(3),NF(3),FS(2),DF(2),NF(2),FS(1),DF(1),    00008600
     1     NF(1)                                                        00008600
      WRITE(6,2004)                                                     00008600
      WRITE(6,2002)                                                     00008600
      DO 10 I=1,3                                                       00008700
   10 WRITE(6,2003)  FS(I),DF(I),NF(I)                                  00008700
C          NCTRL....=1 USUAL CALCULATION, =3 LOWER LIMIT ANALYSIS       00008700
C          NCTRL2...=1 OUTPUT OF STRESSES AT INTERMEDIATE STAGE         00008700
C                   =0 NO OUTPUT OF STRESSES                            00008700
      READ(5,1210)  NCTRL,NCTL2,ALPH                                    00008700
      WRITE(6,2210) NCTRL,NCTL2,ALPH                                    00008700
C          RESIDUAL STRESSES                                            00008700
      READ(5,1200) NRSTC,(RLC(I),FLC(I),I=1,NRSTC)                      00008700
      READ(5,1201) NRSTA,(RLA(I),FLA(I),I=1,NRSTA)                      00008700
      IF(NRSTC.LE.6)  GO TO 20                                          00008800
      WRITE(6,2200)  (RLC(I),FLC(I),I=1,6)                              00008800
      WRITE(6,2200)  (RLC(I),FLC(I),I=7,NRSTC)                          00008800
      GO TO 25                                                          00008800
   20 WRITE(6,2200)  (RLC(I),FLC(I),I=1,NRSTC)                          00008800
   25 IF(NRSTA.LE.6)  GO TO 30                                          00008800
      WRITE(6,2201)  (RLA(I),FLA(I),I=1,6)                              00008800
      WRITE(6,2201)  (RLA(I),FLA(I),I=7,NRSTA)                          00008800
      GO TO 35                                                          00008800
   30 WRITE(6,2201)  (RLA(I),FLA(I),I=1,NRSTA)                          00008800
   35 CONTINUE                                                          00008900
C          EXTERNAL PRESSURE AND OUT-OF-ROUNDNESS                       00008900
      READ(5,1300)  Q,WI,BETA                                           00008900
      WRITE(6,2300) Q                                                   00008900
      WRITE(6,2301) WI,BETA                                             00008900
C                                                                       00008900
      RETURN                                                            00008900
  500 STOP                                                              00008900
 1000 FORMAT(18A4)                                                      00008900
 1001 FORMAT(1X,4F10.0,2I6,4X,F8.0)                                     00008900
 1002 FORMAT(1X ,3(2F10.0,I3))                                          00009000
 2000 FORMAT(1H ,/////,18A4)                                            00009000
 2001 FORMAT(1H ,///,5X,'YIELD ST =',F10.2,5X,'E =',F10.2,5X,'D =',F6.3,00009000
     1   5X,'T =',F5.3,5X,'NTHTA =',I3,5X,'NT =',I3,/,5X,               00009000
     2    'POISSON RATIO =',F6.2)                                       00009000
 2002 FORMAT(1H ,  /,10X,'FORCE', 8X,'INCREMENT',8X,'TIMES')            00009000
 2003 FORMAT(1H ,5X,F10.2,8X,F10.2,8X,I3)                               00009000
 2004 FORMAT(1H ,///,5X,'FORCE INCREMENT  (MX, MY, P)')                 00009000
 1210 FORMAT(1X ,9X,2I5,11X,F8.0)                                       00009000
 1200 FORMAT(1X ,3X,I4,10F6.0)                                          00009000
 1201 FORMAT(1X ,3X,I4,20F6.0)                                          00009100
 1300 FORMAT(2(10X,F10.0),F10.0)                                        00009100
 2210 FORMAT(1H , ///,5X,'NCTRL =',I3,5X,'NCTRL2 =',I3,///,             00009100
     1     'RESIDUAL STRESS ',/,5X,'ALPH =',F8.3)                       00009100
 2200 FORMAT(1H ,5X,' CIRCUM',3X, 6(2F7.3,2X))                          00009100
 2201 FORMAT(1H ,5X,' AXIAL',4X, 6(2F7.3,2X))                           00009100
 2300 FORMAT(1H ,//,5X,'EXTERNAL  PRESSURE     =',E15.5)                00009100
 2301 FORMAT(1H ,/,5X,'INITIAL OUT-OF-ROUNDNESS=',E15.5,5X,'BETA =',    00009100
     1       F7.2)                                                      00009100
      END                                                               00009100
      SUBROUTINE INPUT2(AL,PL,NEL,SPRG1,SPRG2,ISHORT,WL,AROW,ALPHI,     00009200
     1                  SYILDI,IND)                                     00009200
      DIMENSION WL(2,11),AROW(2),ALPHI(10),SYILDI(10)                   00009200
C          INPUT FOR LONG COLUMN ANALYSIS                               00009200
C            AL....COLUMN LENGTH (WHOLE LENGTH = PL)                    00009200
C            NEL...STATION NUMBER FOR NEWMARK'S METHOD (=NEL+1)         00009200
C            WL....INITIAL OUT-OF-STRAIGTHNESS                          00009200
C                 IF(NCW=1) WL WOULD BE EXPRESSED BY THE RATIOS TO PL   00009200
C          ALPHI...DIRECTION OF SEAM WELDING OF THE CAN                 00009200
C          SYILDI..YIELD STRENGTH OF THE CAN                            00009200
C          SPRG1....RESTRAINT RATIO W/R MX, Z1/Z0                       00009300
C          SPRG2....RESTRAINT RATIO W/R MY, Z2/Z0                       00009300
      READ(5,115)  AL,NEL,SPRG1,SPRG2,ISHORT                            00009300
      WRITE(6,510) AL,NEL,SPRG1,SPRG2                                   00009300
      IF(ISHORT.EQ.1) WRITE(6,512)                                      00009300
      IF(ISHORT.NE.1) WRITE(6,513)                                      00009300
      AL=AL*12.0                                                        00009300
      PL=AL                                                             00009300
      IF(IND.EQ.2.OR.IND.EQ.-2) PL=2.0*AL                               00009300
      READ(5,125)  NCW,(WL(1,J),J=1,NEL+1)                              00009300
      READ(5,125)  NCW,(WL(2,J),J=1,NEL+1)                              00009400
      IF(NCW.LE.0)  GO TO 25                                            00009400
      DO 15 J=1,NEL+1                                                   00009400
      WL(1,J)=WL(1,J)*PL                                                00009400
   15 WL(2,J)=WL(2,J)*PL                                                00009400
   25 WRITE(6,520)                                                      00009400
      WRITE(6,521)  (WL(1,J),J=1,NEL+1)                                 00009400
      WRITE(6,521)  (WL(2,J),J=1,NEL+1)                                 00009400
      READ(5,125) NDAM,(AROW(J),J=1,2)                                  00009400
      WRITE(6,527)  (AROW(J),J=1,2)                                     00009400
      READ(5,135) (ALPHI(I),I=1,NEL+1)                                  00009500
      WRITE(6,525) (ALPHI(I),I=1,NEL+1)                                 00009500
      READ(5,135)  (SYILDI(I),I=1,NEL+1)                                00009500
      WRITE(6,526) (SYILDI(I),I=1,NEL+1)                                00009500
      RETURN                                                            00009500
  115 FORMAT(10X,F10.0,10X,I5,5X,2F10.0,I5)                             00009500
  125 FORMAT(I1,F9.0,7F10.0)                                            00009500
  135 FORMAT(12F10.0)                                                   00009500
  510 FORMAT(1H ,5X,'LENGTH(FT)=',F8.3,5X,'NEL=',I3,//,5X,'ELASTIC SUPPO00009500
     1RT',/,6X,'SPRING1=',E11.3,'  SPRING2=',E11.3)                     00009500
  512 FORMAT(1H ,/,6X,'ISHORT =1 (SHORTENING INCLUDES GEOMETRICAL THAT O00009600
     1F IMPERFECTION)')                                                 00009600
  513 FORMAT(1H ,/,6X,'ISHORT =2 (SHORTENING DEOS NOT INCLUDE GOMETRICAL00009600
     1 THAT OF IMPERFECTION)')                                          00009600
  520 FORMAT(1H ,//,5X,'INITIAL OUT-OF-STRAIGHTNESS')                   00009600
  521 FORMAT(1H ,5X,'WL(I,J)=',10E12.3)                                 00009600
  525 FORMAT(1H ,//,5X,'ALPHI(I)=',10E12.3)                             00009600
  526 FORMAT(1H ,/,5X,'SYILD(I)=',10E12.3)                              00009600
  527 FORMAT(1H ,/,5X,'ARROW OF ASSUMED DEFLECTION CURVE',/,            00009600
     1       6X, 'ROW(IX)=',10E12.4)                                    00009600
      END                                                               00009700
      SUBROUTINE  INTIAL(NCTL2,  RI,ALPH,RSTC,RSTA,RBM)                 00009700
C **** CALCULATION OF RESIDUAL STRESS                                   00009700
      COMMON /MAT/        YONG,NCTRL,ENU,NTH,NLA                        00009700
      COMMON /RESTRS/ NRSTC,RLC(8),FLC(8),NRSTA,RLA(10),FLA(10)         00009700
      DIMENSION  A(150),RI(10),RSTC(10),RSTA(150),Y(10),RLB(10)         00009700
C     ***  CIRCUMFERENTIAL RESIDUAL STRESS                              00009700
C          RSTC.....CIRCUMFERENTIAL RESIDUAL STRESSES                   00009700
C          RBM......BENDING MOMENT DUE TO CIRCUMFERENTIAL RESIDUAL STRES00009700
      DLA=(RI(1)-RI(2))*0.5                                             00009700
      RBM=0.0                                                           00009800
      DO 10 I=1,NLA                                                     00009800
      TL=RI(1)-RI(I)+DLA                                                00009800
      DO 20 J=1,NRSTC                                                   00009800
      RLCJ=RLC(J+1)-RLC(J)                                              00009800
      TLRC=RLC(J)-TL                                                    00009800
      IF(ABS(RLCJ).LT.1.0E-10.AND.ABS(TLRC).LT.1.0E-10)  GO TO 24       00009800
   20 IF(RLC(J).LT.TL.AND.RLC(J+1).GT.TL)  GO TO 25                     00009800
   24 RSTC(I)=(FLC(J)+FLC(J+1))/2.0                                     00009800
      GO TO 8                                                           00009800
   25 RAT=(TL-RLC(J))/(RLC(J+1)-RLC(J))                                 00009900
      RSTC(I)=  FLC(J)+(FLC(J+1)-FLC(J))*RAT                            00009900
    8 Y(I)=(RI(1)-RI(NLA+1))*0.5-TL                                     00009900
      RBM=RBM-RSTC(I)*2.0*DLA*Y(I)                                      00009900
   10 CONTINUE                                                          00009900
C          A(I).....AXIAL RESIDUAL STRESSES AFTER ADJUSTING EQUILIBLIUM 00009900
C     ***  LONGITUDINAL RESIDUAL STRESS                                 00009900
C          RSTA.....AXIAL STRESSES WITHOUT EQUILIBLIUM                  00009900
      PAI=4.0*ATAN(1.0)                                                 00009900
      DTH=2.0*PAI/FLOAT(NTH)                                            00009900
      AT=0.0                                                            00010000
      DO 50 K=1,NRSTA                                                   00010000
   50 RLB(K)=RLA(K)*RI(1)                                               00010000
       NTH2=NTH/2                                                       00010000
      DO 55 I=1,NTH2                                                    00010000
      SL=DTH*(FLOAT(I)-0.5)*RI(1)                                       00010000
      DO 60 J=1,NRSTA                                                   00010000
      IF(RLB(J).LE.SL.AND.RLB(J+1).GT.SL)  GO TO 65                     00010000
   60 CONTINUE                                                          00010000
   65 RAT=(SL-RLB(J))/(RLB(J+1)-RLB(J))                                 00010000
      RSTA(I)=FLA(J)+(FLA(J+1)-FLA(J))*RAT                              00010100
      RSTA(NTH-I+1)=RSTA(I)                                             00010100
      AT=AT+RSTA(I)                                                     00010100
   55 CONTINUE                                                          00010100
C          ADJUSTMENT IN ORDER TO KEEP EQUILIBLIUM AT SECTION           00010100
      AVE=AT/FLOAT(NTH/2)                                               00010100
      ALPH=PAI*ALPH/180.0                                               00010100
      NALPH=IFIX((ALPH+0.001)/DTH)                                      00010100
      IF(NALPH.GT.1)  GO TO 75                                          00010100
      DO 85 I=1,NTH                                                     00010100
   85 A(I)=RSTA(I)                                                      00010200
      GO TO 80                                                          00010200
C     ***  ROTATE WELD SEAM                                             00010200
       NNA=NTH-NALPH                                                    00010200
   75 DO 70 I=1,NNA                                                     00010200
   70 A(NALPH+I)=RSTA(I)                                                00010200
       NTAL=NTH-NALPH+1                                                 00010200
       DO 71 I=NTAL,NTH                                                 00010200
   71 A(I-NTH+NALPH)=RSTA(I)                                            00010200
   80 DO 72 I=1,NTH                                                     00010200
   72 RSTA(I)=A(I)-AVE                                                  00010300
C                                                                       00010300
      IF(NCTL2.NE.1)  GO TO 100                                         00010300
      WRITE(6,901)                                                      00010300
      DO 90 I=1,NTH                                                     00010300
   90 WRITE(6,900)  I,(RSTC(J),  J=1,NLA),RSTA(I),A(I)                  00010300
C                                                                       00010300
  100 RETURN                                                            00010300
  900 FORMAT(1H ,    8X,I3,3X,12F10.4)                                  00010300
  901 FORMAT(1H ,//,5X,'RSTC(I,J) AND RSTA(I) AND   A(I)')              00010300
      END                                                               00010400
      SUBROUTINE INVERS(AI,A,IFAC)                                      00010400
C          GET INVERSE MATRIX AI FROM A                                 00010400
C          IFAC=1.... STIFFNESS MATRIX IS SINGULAR                      00010400
      DIMENSION  AI(3,3),A(3,3)                                         00010400
C      *** DETERMINANT  A                                               00010400
      ADET1=A(1,1)*A(2,2)*A(3,3)+A(1,2)*A(2,3)*A(3,1)+A(2,1)*A(3,2)     00010400
     1       *A(1,3)                                                    00010400
      ADET2=A(1,3)*A(2,2)*A(3,1)+A(1,2)*A(2,1)*A(3,3)+A(2,3)*A(3,2)     00010400
     1      *A(1,1)                                                     00010400
      ADET=ADET1-ADET2                                                  00010500
      IFAC=0                                                            00010500
      IF(ABS(ADET).GT.1.0E-10) GO TO 50                                 00010500
       IF(ADET.GE.0.0) ADET=1.0E-10                                     00010500
       IF(ADET.LT.0.0) ADET=-1.0E-10                                    00010500
      WRITE(6,500)                                                      00010500
      IFAC=1                                                            00010500
   50 AI(1,1)=A(2,2)*A(3,3)-A(2,3)*A(3,2)                               00010500
      AI(1,2)=A(2,1)*A(3,3)-A(2,3)*A(3,1)                               00010500
      AI(1,2)=-AI(1,2)                                                  00010500
      AI(1,3)=A(2,1)*A(3,2)-A(2,2)*A(3,1)                               00010600
      AI(2,1)=A(1,2)*A(3,3)-A(1,3)*A(3,2)                               00010600
      AI(2,1)=-AI(2,1)                                                  00010600
      AI(2,2)=A(1,1)*A(3,3)-A(1,3)*A(3,1)                               00010600
      AI(2,3)=A(1,1)*A(3,2)-A(1,2)*A(3,1)                               00010600
      AI(2,3)=-AI(2,3)                                                  00010600
      AI(3,1)=A(1,2)*A(2,3)-A(1,3)*A(2,2)                               00010600
      AI(3,2)=A(1,1)*A(2,3)-A(1,3)*A(2,1)                               00010600
      AI(3,2)=-AI(3,2)                                                  00010600
      AI(3,3)=A(1,1)*A(2,2)-A(1,2)*A(2,1)                               00010600
      DO 10 I=1,3                                                       00010700
      DO 10 J=1,3                                                       00010700
   10 AI(I,J)=AI(I,J)/ADET                                              00010700
      RETURN                                                            00010700
  500 FORMAT(1H ,'**** STIFFNESS MATRIX IS SINGULAR')                   00010700
      END                                                               00010700
      SUBROUTINE  LINEAR(SYC,EA,SAI,SA,EFF)                             00010700
C ***  APPLICATION OF LINEAR VARIATION OF EFF  FROM SAI TO SYC          00010700
      COMMON /MAT/        YONG,NCTRL,ENU,NTH,NLA                        00010700
      EY=SYC/YONG                                                       00010700
      ZETA=EA/EY                                                        00010800
      EMU=SAI/SYC                                                       00010800
      CEMU=1.0-EMU                                                      00010800
      IF(CEMU.GT.0.001)  GO TO 70                                       00010800
      SA=SYC                                                            00010800
      EFF=0.0                                                           00010800
      GO TO 100                                                         00010800
   70 EX=(EMU-ZETA)/(1.0-EMU)                                           00010800
      SA=SYC-SYC*(1.0-EMU)*EXP(EX)                                      00010800
      EFF=YONG*(SA-SYC)/(SAI-SYC)                                       00010800
      IF(EFF.LT.0.0)  WRITE(6,950)                                      00010900
  100 RETURN                                                            00010900
  950 FORMAT(1H ,' **** ERROR  EFF IS NEGATIVE')                        00010900
      END                                                               00010900
      SUBROUTINE  MULT1(A,B,M,C)                                        00010900
C      *** C(M)=A(M*M)*B(M)                                             00010900
      DIMENSION  A(M,M),B(M),C(M)                                       00010900
      DO 1 I=1,M                                                        00010900
      C(I)=0.0                                                          00010900
      DO 1 J=1,M                                                        00010900
      C(I)=C(I)+A(I,J)*B(J)                                             00011000
    1 CONTINUE                                                          00011000
      RETURN                                                            00011000
      END                                                               00011000
      SUBROUTINE  OUTPUT(FB,XA,K,N)                                     00011000
C          OUTPUT FB AND XA WHICH ARE MOMENT AND PHI RESPECTIVELY       00011000
      DIMENSION  FB(3),XA(3)                                            00011000
      IF(K.EQ.1)  WRITE(6,1000)                                         00011000
      WRITE(6,1100)  (FB(I),I=1,3),(XA(I),I=1,3),N                      00011000
      RETURN                                                            00011000
 1000 FORMAT(1H1,10X,'MX',13X,'MY',13X,'P',15X,'XA(1)',10X,'XA(2)',10X, 00011100
     1     'XA(3)',/)                                                   00011100
 1100 FORMAT(1H , 5X,3(E12.5,2X),3X,3(E12.5,2X),6X,'ITERATION =',I3)    00011100
      END                                                               00011100
      SUBROUTINE  OUTPT2(SA,SC,BMT,RI)                                  00011100
C          OUTPUT STRESSES AT INTERMEDIATE STAGE AND CHECK EQUILIBLIUM  00011100
C          FOR REFERENCE                                                00011100
C          P0.....NORMAL FORCE DUE TO EXTERNAL PRESSURE                 00011100
C          PP.....RESULTANT NORMAL FORCE OBTAINED BY THE PROGRAM        00011100
C          BMT....BENDING MOMENT DUE TO EXTERNAL PRESSURE               00011100
C          BMP....RESULTANT BENDING MOMENT OBTAINED BY THE PROGRAM      00011200
      COMMON /MAT/        YONG,NCTRL,ENU,NTH,NLA                        00011200
      COMMON  /SPRESS/   SAVE                                           00011200
      DIMENSION  SA(75, 8),SC( 75,8),BMT(150),RI(10),Y(8),PI(10)        00011200
      WRITE(6,500)                                                      00011200
      DO 80 I=1,NTH                                                     00011200
   80 WRITE(6,501)  I,(SA(I,J),J=1,NLA),(SC(I,J),J=1,NLA)               00011200
      WRITE(6,510)                                                      00011200
      T=RI(1)-RI(NLA+1)                                                 00011200
      DLA=RI(1)-RI(2)                                                   00011200
      P0=T*SAVE                                                         00011300
      DO 10 J=1,NLA                                                     00011300
   10 Y(J)=RI(J)-(RI(1)+RI(NLA+1))*0.5-DLA*0.5                          00011300
      DO 100 I=1,NTH                                                    00011300
      PP=0.0                                                            00011300
      PS=0.0                                                            00011300
      BMP=0.0                                                           00011300
      PYI=0.0                                                           00011300
      DO 50 J=1,NLA                                                     00011300
   50 PP=PP+SC(I,J)*DLA                                                 00011300
      PF=PP/FLOAT(NLA)                                                  00011400
      DO 60 J=1,NLA                                                     00011400
      PI(J)=SC(I,J)*DLA-PF                                              00011400
      PS=PS+ABS(PI(J))                                                  00011400
   60 PYI=PYI+ABS(PI(J))*Y(J)                                           00011400
      IF(PS.LT.1.0E-20)  PS=1.0E-20                                     00011400
      DELTA=PYI/PS                                                      00011400
      DO 70 J=1,NLA                                                     00011400
   70 BMP=BMP-PI(J)*(Y(J)-DELTA)                                        00011400
  100 WRITE(6,511)  I,P0,PP,BMT(I),BMP                                  00011400
      RETURN                                                            00011500
  500 FORMAT(1H ,///,5X,'SA(I,J)  AND  SC(I,J)')                        00011500
  501 FORMAT(1H ,5X,I3,3X,10E12.4)                                      00011500
  510 FORMAT(1H ,///,20X,'P0',12X,'PP',12X,'BMT(I)',9X,'BMP')           00011500
  511 FORMAT(1H ,5X,I3,8E15.5)                                          00011500
      END                                                               00011500
      SUBROUTINE  PRESS(SQR,SAR,STR,RI,BMT,NCTL2,RSTC,RSTA,RBM,SYILD)   00011500
C ***  STRESS FOR EACH ELEMENT DUE TO PRESSURE                          00011500
C          SQR....PURE PRESSURE STRESS WITHOUT RESIDUAL STRESSES IN     00011500
C                 CIRCUMFERENTIAL DIRECTION                             00011500
C          STR....CIRCUMFERENTIAL STRESS WHICH RESULTS FROM PRESSURE    00011600
C                 AND RESIDUAL STRESSES                                 00011600
C          SAR....AXIAL STRESS WHICH RESULTS FROM PRESSURE AND R. S.    00011600
      COMMON /MAT/        YONG,NCTRL,ENU,NTH,NLA                        00011600
      COMMON  /SPRESS/   SAVE                                           00011600
      DIMENSION SQR( 75,6),SAR( 75,6),STR( 75,6),RI(10),BMT(150),DA(8)  00011600
     1              ,FB(3),FA(3),XA(3),DFA(3),Q(3,3),QG(3,3),RSTC(10),  00011600
     2     RSTA(150),DAM( 75,6),SA( 75,6),SC( 75,6),X( 75,6),Y( 75,6)   00011600
     3  ,DXA(3),QI(3,3)                                                 00011600
C                                                                       00011600
      T=RI(1)-RI(NLA+1)                                                 00011700
      DLA=(RI(1)-RI(2))*0.5                                             00011700
      NHT=1                                                             00011700
      ERR=0.01                                                          00011700
C **** ELEMENT                                                          00011700
      DO 3 I=1,NLA                                                      00011700
      X(1,I)=0.0                                                        00011700
      Y(1,I)=RI(I)-(RI(1)+RI(NLA+1))*0.5-DLA                            00011700
    3 DA(I)=DLA*2.0                                                     00011700
      DO 4 I=1,NTH                                                      00011700
      DO 4 J=1,NLA                                                      00011800
    4 DAM(I,J)=0.0                                                      00011800
C ****  SQR WITHOUT RESIDUAL STRESS                                     00011800
C ****  CURVE                                                           00011800
      DO 200 I=1,NTH                                                    00011800
      FB(1)=-BMT(I)                                                     00011800
      FB(2)=0.0                                                         00011800
      FB(3)=SAVE*DA(1)*FLOAT(NLA)                                       00011800
      DO 15 K=1,3                                                       00011800
      XA(K)=0.0                                                         00011800
      FA(K)=0.0                                                         00011900
   15 DFA(K)=FB(K)                                                      00011900
C ****  CONVRG                                                          00011900
      NC3=1                                                             00011900
      IF(DFA(1).LT.0.0)  NC3=-1                                         00011900
      N=0                                                               00011900
      IFAC=0                                                            00011900
C ****  REPEAT                                                          00011900
      DO 16 J=1,NLA                                                     00011900
      SAR(1,J)=0.0                                                      00011900
   16 STR(1,J)=RSTA(I)                                                  00012000
C                                                                       00012000
      CALL  REPEAT(FA,FB,DFA,XA,    X,Y,DA,IFAC,N,ERR,DAM,SAR,STR,      00012000
     1      SA,SC,NHT,NLA,SYILD)                                        00012000
C                                                                       00012000
      IF(N.GT.15)  GO TO 101                                            00012000
      DO 18 J=1,NLA                                                     00012000
   18 SQR(I,J)=SA(1,J)                                                  00012000
  200 CONTINUE                                                          00012000
C                                                                       00012000
C **** STR WITH RESIDUAL STRESS AND HYDRO STATIC PRESSURE               00012100
C ****  CURVE                                                           00012100
      DO 100 I=1,NTH                                                    00012100
      FB(1)=-BMT(I)-RBM                                                 00012100
      FB(2)=0.0                                                         00012100
      DO 5 K=1,3                                                        00012100
      FB(3)=SAVE*DA(1)*FLOAT(NLA)                                       00012100
      XA(K)=0.0                                                         00012100
      FA(K)=0.0                                                         00012100
    5 DFA(K)=FB(K)                                                      00012100
C ****  CONVRG                                                          00012200
      NC3=1                                                             00012200
      IF(DFA(1).LT.0.0)  NC3=-1                                         00012200
      N=0                                                               00012200
      IFAC=0                                                            00012200
C ****  REPEAT                                                          00012200
      DO 6 J=1,NLA                                                      00012200
      SAR(1,J)=RSTC(J)                                                  00012200
    6 STR(1,J)=RSTA(I)                                                  00012200
C                                                                       00012200
      CALL  REPEAT(FA,FB,DFA,XA,    X,Y,DA,IFAC,N,ERR,DAM,SAR,STR,      00012300
     1      SA,SC,NHT,NLA,SYILD)                                        00012300
C                                                                       00012300
      IF(N.GT.15)  GO TO 101                                            00012300
C ***  DETERMINE INITIAL VALUE  STR, SQR, SAR                           00012300
      DO 20 J=1,NLA                                                     00012300
      STR(I,J)=SA(1,J)                                                  00012300
   20 SAR(I,J)=SC(1,J)                                                  00012300
      IF(I.NE.1)  GO TO 100                                             00012300
      DO 35 J=1,NLA                                                     00012300
      SA(2,J)=STR(1,J)                                                  00012400
   35 SC(2,J)=SAR(1,J)                                                  00012400
  100 CONTINUE                                                          00012400
      DO 40 J=1,NLA                                                     00012400
      STR(1,J)=SA(2,J)                                                  00012400
   40 SAR(1,J)=SC(2,J)                                                  00012400
C ****  OUTPUT DATA GENERATED FROM INPUT                                00012400
      IF(NCTL2.NE.1)  GO TO 150                                         00012400
      WRITE(6,651)                                                      00012400
      DO 130 I=1,NTH                                                    00012400
  130 WRITE(6,650) I,(SQR(I,J),J=1,NLA)                                 00012500
      WRITE(6,652)                                                      00012500
      DO 131 I=1,NTH                                                    00012500
  131 WRITE(6,650) I,(STR(I,J),J=1,NLA)                                 00012500
      WRITE(6,653)                                                      00012500
      DO 132 I=1,NTH                                                    00012500
  132 WRITE(6,650) I,(SAR(I,J),J=1,NLA)                                 00012500
C                                                                       00012500
  150 RETURN                                                            00012500
  101 WRITE(6,501)                                                      00012500
      STOP                                                              00012600
C                                                                       00012600
  501 FORMAT(1H ,'****  TOO MANY ITERATION IN PRESS')                   00012600
  650 FORMAT(1H ,I5,5X,6E15.4)                                          00012600
  651 FORMAT(1H ,//,5X,'SQR(I,J)')                                      00012600
  652 FORMAT(1H ,//,5X,'STR(I,J)')                                      00012600
  653 FORMAT(1H ,//,5X,'SAR(I,J)')                                      00012600
      END                                                               00012600
      SUBROUTINE  REPEAT(FA,FB,DFA,XA,    XO,YO,DA,IFAC,N,ERR,SQR,SAR,  00012600
     1   STR,SA,SC,NTH,NLA,SYILD)                                       00012600
C          TANGENT STIFFNESS METHOD                                     00012700
C          SUBROUTINE                                                   00012700
C            STIFF....GENERATE STIFFNESS MATRIX QG                      00012700
C            INVERS...GET INVERSE MATRIX QI FROM QG                     00012700
C            MULT1....DXA = QI*DFA                                      00012700
C            STRESS...GET FORCES FA CORRESPONDING TO STRAIN XA          00012700
      DIMENSION  QG(3,3),FB(3),XA(3),DXA(3),DFA(3),FA(3),QI(3,3)        00012700
     1   ,SQR( 75,6),XAO(3),FAO(3),FBO(3)                               00012700
     2    ,XO( 75,6),YO( 75,6),DA(8),SAR( 75,6),STR( 75,6)              00012700
     3    ,SA( 75,6),SC( 75,6)                                          00012700
C                                                                       00012800
   10 CALL  STIFF(QG,XA,SQR,    XO,YO,DA,SAR,STR,NTH,NLA,SYILD)         00012800
C                                                                       00012800
      CALL INVERS(QI,QG,IFAC)                                           00012800
      IF(IFAC.GT.0)  GO TO 101                                          00012800
C                                                                       00012800
      CALL  MULT1(QI,DFA,3,DXA)                                         00012800
      DO 1 K=1,3                                                        00012800
    1 XA(K)=XA(K)+DXA(K)                                                00012800
C                                                                       00012800
      CALL STRESS(FA,XA,SQR,    XO,YO,DA,SAR,STR,SA,SC,NTH,NLA,SYILD)   00012900
C                                                                       00012900
      ERRF=0.0                                                          00012900
      DO 2 K=1,3                                                        00012900
      DFA(K)=FB(K)-FA(K)                                                00012900
    2 IF(ABS(DFA(K)).GT.ABS(ERRF))  ERRF=DFA(K)                         00012900
      N=N+1                                                             00012900
      IF(N.GT.15)  GO TO 101                                            00012900
      IF(ABS(ERRF).GT.ERR)  GO TO 10                                    00012900
C                                                                       00012900
  101 RETURN                                                            00013000
      END                                                               00013000
      SUBROUTINE RSTRAT(Z1,Z2,SLOPE,ALPH,SLOPI1,SLOPI2,RSTMT1,RSTMT2,P) 00013000
C  BENDING MOMENT DUE TO END-RESTRAINT                                  00013000
      COMMON  /PMT/ PLTM,YLDP                                           00013000
      DIMENSION SLOPE(3,11),ALPH(3,11)                                  00013000
      RSTMT1=Z1*(SLOPE(1,1)-ALPH(1,1)-SLOPI1)                           00013000
      RSTMT2=Z2*(SLOPE(2,1)-ALPH(2,1)-SLOPI2)                           00013000
      RP=-P/YLDP                                                        00013000
      RMT=PLTM*(1.0-1.18*RP*RP)                                         00013000
      IF(RP.GT.0.65)  RMT=1.43*PLTM*(1.0-RP)                            00013100
      IF(RP.GT.1.0)  GO TO 50                                           00013100
      IF(RSTMT1.GT.RMT) RSTMT1=RMT                                      00013100
      IF(RSTMT2.GT.RMT)  RSTMT2=RMT                                     00013100
      IF(RSTMT1.LT.-RMT) RSTMT1=-RMT                                    00013100
      IF(RSTMT2.LT.-RMT) RSTMT2=-RMT                                    00013100
      RETURN                                                            00013100
   50 WRITE(6,500)                                                      00013100
      STOP                                                              00013100
  500 FORMAT(1H ,'*****  ERROR--- P IS GREATER THAN P(Y)')              00013100
      END                                                               00013200
      SUBROUTINE  SAISY(SAI,SY,STR,EM,SAR,SYILD)                        00013200
C  ***  DETERMINE  SAI, SY                                              00013200
C          SAI....INITIAL YIELD STRESS                                  00013200
C          SY.....YIELD STRESS WITH SIGN                                00013200
      COMMON /MAT/        YONG,NCTRL,ENU,NTH,NLA                        00013200
      ENU=1.0E-10                                                       00013200
      SOR=STR-ENU*SAR                                                   00013200
      IF(ABS(SOR).GT.(SYILD+0.1)) WRITE(6,951)                          00013200
      SY=SYILD                                                          00013200
      IF(EM.LT.0.0)  SY=-SYILD                                          00013300
      B1=SYILD*ENU                                                      00013300
      B2=SYILD-B1+1.0E-5                                                00013300
      IF(SOR.GT.B2.AND.EM.GT.0.0)  GO TO 40                             00013300
      IF(SOR.LT.-B2.AND.EM.LT.0.0) GO TO 40                             00013300
      IF(EM.LT.0.0)  GO TO 30                                           00013300
      IF(SOR.LT.-B1)  GO TO 20                                          00013300
      GO TO 35                                                          00013300
   30 IF(SOR.GT.B1)  GO TO 20                                           00013300
C ***  REGION  TT,CC                                                    00013300
   35 SAI=SY                                                            00013400
      GO TO 50                                                          00013400
C  ***  REGION  SIDES OF TT, CC                                         00013400
   40 SAI=(SY-STR+SAR*ENU)/ENU                                          00013400
      GO TO 50                                                          00013400
C ***  REGION  TC, CT                                                   00013400
   20 SAI=(SY+STR-SAR*ENU)/(1.0-ENU)                                    00013400
   50 RETURN                                                            00013400
  951 FORMAT(1H ,'****  ERROR  SOR GREATER THAN SYILD')                 00013400
      END                                                               00013400
      SUBROUTINE  STIFF(QG,XA,SQR,    XO,YO,DA,SAR,STR,NTH,NLA,SYILD)   00013500
C          STIFFNESS MATRIX                                             00013500
C            Q.....STIFFNESS OF A ELEMENT                               00013500
C            QG....GLOBAL STIFFNESS MATRIX (INTEGRATION OF EACH ELEMENT)00013500
      DIMENSION  Q(3,3),QG(3,3),XA(3),SQR( 75,6)                        00013500
     1   ,XO( 75,6),YO( 75,6),DA(8),SAR( 75,6),STR( 75,6)               00013500
C                                                                       00013500
      DO 10 K=1,3                                                       00013500
      DO 10 L=1,3                                                       00013500
   10 QG(K,L)=0.0                                                       00013500
      DO 20 I=1,NTH                                                     00013600
      DO 20 J=1,NLA                                                     00013600
      X=XO(I,J)                                                         00013600
      Y=YO(I,J)                                                         00013600
      EA=Y*XA(1)-X*XA(2)+XA(3)                                          00013600
C                                                                       00013600
      CALL  YONGEF(EFF,EA,SQR(I,J),SAR(I,J),STR(I,J),SA,SC,SYILD)       00013600
C                                                                       00013600
      AD=DA(J)                                                          00013600
      Q(1,1)=EFF*Y*Y*AD                                                 00013600
      Q(2,2)=EFF*X*X*AD                                                 00013700
      Q(3,3)=EFF*AD                                                     00013700
      Q(1,2)=-EFF*X*Y*AD                                                00013700
      Q(2,1)=Q(1,2)                                                     00013700
      Q(1,3)=EFF*Y*AD                                                   00013700
      Q(3,1)=Q(1,3)                                                     00013700
      Q(2,3)=-EFF*X*AD                                                  00013700
      Q(3,2)=Q(2,3)                                                     00013700
      DO 1 K=1,3                                                        00013700
      DO 1 L=1,3                                                        00013700
    1 QG(K,L)=QG(K,L)+Q(K,L)                                            00013800
   20 CONTINUE                                                          00013800
C          SINCE Q(2,2)=0 IN THICKNESS DIRECTION, PUT Q(2,2)=1          00013800
      IF(ABS(QG(2,2)).LT.1.0E-10)  QG(2,2)=1.0                          00013800
      RETURN                                                            00013800
      END                                                               00013800
      SUBROUTINE  STRESS(FA,XA,SQR,    XO,YO,DA,SAR,STR,SA,SC,NTH,NLA,  00013800
     1                   SYILD)                                         00013800
C          INTEGRATE FORCES FA OF A ELEMENT                             00013800
C            EA....STRAIN OF A ELEMENT                                  00013800
C            SA....AXIAL STRESS OF A ELEMENT                            00013900
      DIMENSION  FA(3),XA(3),SQR( 75,6),XO( 75,6),YO( 75,6),DA(8)       00013900
     1     ,SAR( 75,6),STR( 75,6),SA( 75,6),SC( 75,6)                   00013900
C                                                                       00013900
      DO 1 K=1,3                                                        00013900
    1 FA(K)=0.0                                                         00013900
      DO 100 I=1,NTH                                                    00013900
      DO 100 J=1,NLA                                                    00013900
      X=XO(I,J)                                                         00013900
      Y=YO(I,J)                                                         00013900
      EA=Y*XA(1)-X*XA(2)+XA(3)                                          00014000
C                                                                       00014000
      CALL  YONGEF(EFF,EA,SQR(I,J),SAR(I,J),STR(I,J),SA(I,J),SC(I,J),   00014000
     1             SYILD)                                               00014000
C                                                                       00014000
   20 FA(1)=FA(1)+SA(I,J)*Y*DA(J)                                       00014000
      FA(2)=FA(2)-SA(I,J)*X*DA(J)                                       00014000
      FA(3)=FA(3)+SA(I,J)*DA(J)                                         00014000
  100 CONTINUE                                                          00014000
      RETURN                                                            00014000
      END                                                               00014100
      SUBROUTINE  YONGEF(EFF,EA,SQR,SAR,STR,SA,SC,SYILD)                00014100
C ***  EFFECTIVE YONG,S MODULUS      ***********************************00014100
C          GET LOCATION OF THE POINT IN TRESCA BIAXIAL STRESS PLANE     00014100
C         EM...CONTROLER WETHER STRESS IS IN COMPRESSION OR TENSION     00014100
C          SYC...STOPPING LOCATION WHICH THE POINT CAN REACH            00014100
      COMMON /MAT/        YONG,NCTRL,ENU,NTH,NLA                        00014100
      COMMON  /SPRESS/   SAVE                                           00014100
C          INSIDE OF TRESCA YIELD SURFACE                               00014100
      ER=SAR/YONG                                                       00014100
      EM=EA+ER                                                          00014200
C                                                                       00014200
      CALL  SAISY(SAI,SY,STR,EM,SAR,SYILD)                              00014200
C                                                                       00014200
      SC=STR+EA*YONG*ENU                                                00014200
      EA=EA+ER                                                          00014200
      SA=YONG*EA                                                        00014200
      EFF=YONG                                                          00014200
C ***  CHECK OUT SIDE OF TT, CC REGION                                  00014200
      IF(ABS(SAI-SY).LT.1.0E-5.AND.EM.GT.0.0.AND.SA.GT.SAI) GO TO 53    00014200
      IF(ABS(SAI-SY).LT.1.0E-5.AND.EM.LT.0.0.AND.SA.LT.SAI) GO TO 53    00014300
      GO TO 55                                                          00014300
   53 SA=SAI                                                            00014300
      SC=STR+(SAI-SAR)*ENU                                              00014300
      EFF=0.0                                                           00014300
      GO TO 100                                                         00014300
C ***  CHECK SA BEYOND SAI                                              00014300
   55 IF(SAI.LT.-1.0E-5.AND.SA.LT.(SAI+0.0001))  GO TO 60               00014300
      IF(SAI.GT.1.0E-5.AND.SA.GT.(SAI-0.0001))  GO TO 60                00014300
C ***  CHECK SA IS IN TRESCA AT OPPOSITE SIDE                           00014300
      IF(SA.LT.-SYILD)  SA=-SYILD                                       00014400
      IF(SA.GT.SYILD)  SA=SYILD                                         00014400
      IF(EM.GT.0.0.AND.STR.GT.0.0.AND.SA.LT.(SC -SY))  SA=SC -SY        00014400
      IF(EM.LT.0.0.AND.STR.LT.0.0.AND.SA.GT.( SC-SY))  SA= SC-SY        00014400
      GO TO 100                                                         00014400
C ***  DETERMINE SYC CONSIDERING PRESSURE EFFECT                        00014400
   60 SYC=SY+SQR                                                        00014400
      IF(NCTRL.EQ.3)  SYC=SAI                                           00014400
      IF(ABS(STR-SAR).GT.(SYILD-1.0E-10))  SYC=SAR                      00014400
      IF(ABS(SYC).GT.SYILD)  SYC=SY                                     00014400
      IF(ABS(SAI).GT.ABS(SYC))  SYC=SAI                                 00014500
      IF(ABS(SYC-SAI).GT.1.0E-5)  GO TO 65                              00014500
      SA=SAI                                                            00014500
      EFF=0.0                                                           00014500
      GO TO 100                                                         00014500
C                                                                       00014500
   65 CALL  LINEAR(SYC,EA,SAI,SA,EFF)                                   00014500
C                                                                       00014500
C ***  STRESS OF CIRCUMFERENTIAL DIRECTION                              00014500
  100 SC=STR+SA*ENU                                                     00014500
      IF(SC.LT.-SYILD)  SC=-SYILD                                       00014600
      IF(SC.GT.SYILD)  SC=SYILD                                         00014600
      IF(EM.LT.0.0.AND.STR.GT.0.0.AND.SC.GT.(SA-SY)) SC=SA-SY           00014600
      IF(EM.GT.0.0.AND.STR.LT.0.0.AND.SC.LT.(SA-SY))  SC=SA-SY          00014600
      RETURN                                                            00014600
      END                                                               00014600
